#pragma once
#ifndef SONGDATA_HPP
#define SONGDATA_HPP
// Reaper version: 6.64/x64
// Generated from kerava.RPP
#define TEMPO_INT_TO_FLOAT_DENOMINATOR 100.000f
#define GLOBAL_TEMPOF 150.000f
#define GLOBAL_DIVISION 960
#define GLOBAL_DIVISIONF 960.0f
#define GLOBAL_TEMPO_IN_MICROSECS_PQNF 400000.0000000f
#define VOLUME_ENVELOPE_CONTROL_NUMBER 100
#define HAS_ALL_NOTES_OFF_EVENTS 1
#define HAS_ENVELOPE_EVENTS 1
#define HAS_NOTE_OFF_EVENTS 1
#define HAS_NRPN_EVENTS 1
#define HAS_TEMPO_EVENTS 1

struct ParamEnvelopeState
{
  public:
    // The number of the track the envelope applies to.
    uint8_t m_track_num;

    // The ID of the parameter.
    uint8_t m_param_id;

    // The parameter value to be applied each cycle.
    // Initialized with the default parameter value.
    float m_param_value;

    // The value to add to the parameter each cycle.
    float m_value_to_add;

    // The parameter target value once the envelope reaches the end.
    float m_target_param_value;

    // Samples left until the envelope hits the target value.
    int32_t m_samples_left;

    // Samples left until the parameter should be updated again.
    int16_t m_samples_to_next;
};
namespace synth_event_types
{
  enum synth_event_types
  {
    NoteOff = 0,
    NoteOn = 1,
    PitchBend = 2,
    CC = 3,
    NRPN = 4,
    Division = 5,
    Tempo = 6,
    AllNotesOff = 7,
    StartEnvelope = 8
  };
}

// START TRACK PARAMETER BLOCK

// Output Bus Level
#define OUTPUT_BUS_LEVEL 3.6728230049808f

// Parameter automation envelope states
// These are the starting values for the envelopes.
// Format: {Track ID, parameter ID, value, + 4 state variables that are written at runtime, initialized as 0}
static ParamEnvelopeState param_env_states[]
{
  {10, 42, 0.0799878f, 0, 0, 0, 0},
  {10, 43, 0.0599985f, 0, 0, 0, 0},
  {10, 47, 0.5149920f, 0, 0, 0, 0},
  {10, 49, 0.0499886f, 0, 0, 0, 0},
  {11, 42, 0.0799878f, 0, 0, 0, 0},
  {11, 43, 0.0599985f, 0, 0, 0, 0},
  {11, 47, 0.5449912f, 0, 0, 0, 0},
  {13, 77, 0.0000000f, 0, 0, 0, 0},
  {14, 73, 0.0000000f, 0, 0, 0, 0},
  {22, 100, 0.0000000f, 0, 0, 0, 0},
  {25, 100, 0.0000000f, 0, 0, 0, 0},
  {26, 2, 0.2699931f, 0, 0, 0, 0},
  {26, 0, 0.8333257f, 0, 0, 0, 0}
};

static int32_t instr_params[15][80]
{
//----------------------------------------------------------------------------
// Track 0 - bd_1
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [1] k_osc1_semi = -56.4583 [ -60 - 60 ] => 0.0295139 (1934)
1934,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 70 [ 0 - 100 ] => 0.7 (45874)
45874,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [8] k_osc2_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [9] k_osc2_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [10] k_osc2_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [13] k_osc3_semi = -55.8333 [ -60 - 60 ] => 0.0347222 (2275)
2275,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 50.1736 [ 0 - 100 ] => 0.501736 (32881)
32881,
// [16] k_osc3_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [19] k_lfo1_speed = 0.0999868 [ -250 - 250 ] => 0.5002 (32780)
32780,
// [20] k_lfo1_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [21] k_lfo1_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [22] k_lfo1_mod_dest = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [23] k_lfo1_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [24] k_lfo2_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0.269997 [ -100 - 100 ] => 0.50135 (32855)
32855,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 13.1944 [ 0 - 100 ] => 0.131944 (8646)
8646,
// [39] k_pitch_sustain = 3.29861 [ 0 - 100 ] => 0.0329861 (2161)
2161,
// [40] k_pitch_release = 15.7986 [ 0 - 100 ] => 0.157986 (10353)
10353,
// [41] k_filter1_mode = 5 [ 0 - 6 ] => 0.833333 (54612)
54612,
// [42] k_filter1_cutoff = 5.3833 [ 0 - 22050 ] => 0.015625 (1023)
1023,
// [43] k_filter1_resonance = 20.3125 [ 0 - 100 ] => 0.203125 (13311)
13311,
// [44] k_filter1_drive = 80.0347 [ 0 - 100 ] => 0.800347 (52450)
52450,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 6 [ 0 - 6 ] => 1 (65535)
65535,
// [49] k_filter2_cutoff = 22050 [ 0 - 22050 ] => 1 (65535)
65535,
// [50] k_filter2_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [51] k_filter2_drive = 34.2014 [ 0 - 100 ] => 0.342014 (22413)
22413,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [57] k_filter_sustain = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [58] k_filter_release = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 500 [ 0 - 5000 ] => 0.1 (6553)
6553,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.02 [ 0 - 100 ] => 0.0002 (13)
13,
// [67] k_amp_decay = 26.9098 [ 0 - 100 ] => 0.269098 (17635)
17635,
// [68] k_amp_sustain = 85.2431 [ 0 - 100 ] => 0.852431 (55864)
55864,
// [69] k_amp_release = 17.6389 [ 0 - 100 ] => 0.176389 (11559)
11559,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [78] k_osc2_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 1 - rimshot
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [1] k_osc1_semi = -24.1834 [ -60 - 60 ] => 0.298472 (19560)
19560,
// [2] k_osc1_detune = 47.3945 [ 0 - 100 ] => 0.473945 (31059)
31059,
// [3] k_osc1_volume = 53.1243 [ 0 - 100 ] => 0.531243 (34815)
34815,
// [4] k_osc1_pw = 37.499 [ 0 - 100 ] => 0.37499 (24574)
24574,
// [5] k_osc1_pwm = 53.6385 [ 0 - 100 ] => 0.536385 (35151)
35151,
// [6] k_osc2_waveform = 8 [ 0 - 11 ] => 0.727273 (47661)
47661,
// [7] k_osc2_semi = -31.0583 [ -60 - 60 ] => 0.241181 (15805)
15805,
// [8] k_osc2_detune = 55.729 [ 0 - 100 ] => 0.55729 (36522)
36522,
// [9] k_osc2_volume = 38.0194 [ 0 - 100 ] => 0.380194 (24916)
24916,
// [10] k_osc2_pw = 60.9369 [ 0 - 100 ] => 0.609369 (39934)
39934,
// [11] k_osc2_pwm = 61.9791 [ 0 - 100 ] => 0.619791 (40618)
40618,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 0.164002 [ -250 - 250 ] => 0.500328 (32788)
32788,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 7.35615 [ 0 - 100 ] => 0.52079 (34129)
34129,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 3.32657 [ 0 - 100 ] => 0.42707 (27988)
27988,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0.673354 [ 0 - 100 ] => 0.286458 (18773)
18773,
// [36] k_pitch_env_mod = 6.2484 [ -100 - 100 ] => 0.531242 (34814)
34814,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 4.51389 [ 0 - 100 ] => 0.0451389 (2958)
2958,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [42] k_filter1_cutoff = 4492.73 [ 0 - 22050 ] => 0.451389 (29581)
29581,
// [43] k_filter1_resonance = 15.625 [ 0 - 100 ] => 0.15625 (10239)
10239,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = -200 [ -200 - 200 ] => 0 (0)
0,
// [46] k_filter1_vel_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [47] k_filter1_env_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [48] k_filter2_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [49] k_filter2_cutoff = 10106.5 [ 0 - 22050 ] => 0.677012 (44367)
44367,
// [50] k_filter2_resonance = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = -133.336 [ -200 - 200 ] => 0.166659 (10921)
10921,
// [53] k_filter2_vel_mod = -39.5864 [ -100 - 100 ] => 0.302068 (19796)
19796,
// [54] k_filter2_env_mod = 11.458 [ -100 - 100 ] => 0.55729 (36522)
36522,
// [55] k_filter_attack = 0.0961318 [ 0 - 100 ] => 0.000961318 (62)
62,
// [56] k_filter_decay = 9.99924 [ 0 - 100 ] => 0.0999924 (6553)
6553,
// [57] k_filter_sustain = 45.3117 [ 0 - 100 ] => 0.453117 (29695)
29695,
// [58] k_filter_release = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [59] k_amp_env_vel_mod = 24.9989 [ 0 - 100 ] => 0.249989 (16383)
16383,
// [60] k_env_length = 8.95399 [ 0 - 100 ] => 0.0895399 (5867)
5867,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [66] k_amp_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [67] k_amp_decay = 7.98611 [ 0 - 100 ] => 0.0798611 (5233)
5233,
// [68] k_amp_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [69] k_amp_release = 0.347222 [ 0 - 100 ] => 0.00347222 (227)
227,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -35.0706 [ -100 - 100 ] => 0.324647 (21275)
21275,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 2 - clap
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = 0.398283 [ -60 - 60 ] => 0.503319 (32985)
32985,
// [8] k_osc2_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [9] k_osc2_volume = 64.4097 [ 0 - 100 ] => 0.644097 (42210)
42210,
// [10] k_osc2_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = -12.4028 [ -60 - 60 ] => 0.396643 (25993)
25993,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 28.4722 [ 0 - 100 ] => 0.284722 (18659)
18659,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 6 [ 0 - 11 ] => 0.545455 (35746)
35746,
// [19] k_lfo1_speed = 240.452 [ -250 - 250 ] => 0.980903 (64283)
64283,
// [20] k_lfo1_startphase = -255 [ -360 - 360 ] => 0.145833 (9557)
9557,
// [21] k_lfo1_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [22] k_lfo1_mod_dest = 5 [ 0 - 11 ] => 0.454545 (29788)
29788,
// [23] k_lfo1_mod_amount = 71.6826 [ 0 - 100 ] => 0.920139 (60301)
60301,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 100 [ -100 - 100 ] => 1 (65535)
65535,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0.694444 [ 0 - 100 ] => 0.00694444 (455)
455,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 4 [ 0 - 6 ] => 0.666667 (43690)
43690,
// [42] k_filter1_cutoff = 1475.24 [ 0 - 22050 ] => 0.258659 (16951)
16951,
// [43] k_filter1_resonance = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [44] k_filter1_drive = 83.3333 [ 0 - 100 ] => 0.833333 (54612)
54612,
// [45] k_filter1_keytrack = 101.389 [ -200 - 200 ] => 0.753472 (49378)
49378,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [49] k_filter2_cutoff = 76.8284 [ 0 - 22050 ] => 0.0590278 (3868)
3868,
// [50] k_filter2_resonance = 1.04167 [ 0 - 100 ] => 0.0104167 (682)
682,
// [51] k_filter2_drive = 71.0069 [ 0 - 100 ] => 0.710069 (46534)
46534,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 48.2638 [ -100 - 100 ] => 0.741319 (48582)
48582,
// [55] k_filter_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [56] k_filter_decay = 10.7639 [ 0 - 100 ] => 0.107639 (7054)
7054,
// [57] k_filter_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [58] k_filter_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [59] k_amp_env_vel_mod = 18.7488 [ 0 - 100 ] => 0.187488 (12287)
12287,
// [60] k_env_length = 10.518 [ 0 - 100 ] => 0.10518 (6892)
6892,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [66] k_amp_attack = 0.198367 [ 0 - 100 ] => 0.00198367 (129)
129,
// [67] k_amp_decay = 7.11806 [ 0 - 100 ] => 0.0711806 (4664)
4664,
// [68] k_amp_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [69] k_amp_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -25.002 [ -100 - 100 ] => 0.37499 (24574)
24574,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 3 - closed_hh_1
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [1] k_osc1_semi = 60 [ -60 - 60 ] => 1 (65535)
65535,
// [2] k_osc1_detune = 47.3945 [ 0 - 100 ] => 0.473945 (31059)
31059,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 37.499 [ 0 - 100 ] => 0.37499 (24574)
24574,
// [5] k_osc1_pwm = 53.6385 [ 0 - 100 ] => 0.536385 (35151)
35151,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = 60 [ -60 - 60 ] => 1 (65535)
65535,
// [8] k_osc2_detune = 55.729 [ 0 - 100 ] => 0.55729 (36522)
36522,
// [9] k_osc2_volume = 38.0194 [ 0 - 100 ] => 0.380194 (24916)
24916,
// [10] k_osc2_pw = 60.9369 [ 0 - 100 ] => 0.609369 (39934)
39934,
// [11] k_osc2_pwm = 61.9791 [ 0 - 100 ] => 0.619791 (40618)
40618,
// [12] k_osc3_waveform = 6 [ 0 - 11 ] => 0.545455 (35746)
35746,
// [13] k_osc3_semi = -4.49088 [ -60 - 60 ] => 0.462576 (30314)
30314,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 60.4167 [ 0 - 100 ] => 0.604167 (39594)
39594,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [19] k_lfo1_speed = 0.164002 [ -250 - 250 ] => 0.500328 (32788)
32788,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [23] k_lfo1_mod_amount = 7.35615 [ 0 - 100 ] => 0.52079 (34129)
34129,
// [24] k_lfo2_waveform = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [25] k_lfo2_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [29] k_lfo2_mod_amount = 3.32657 [ 0 - 100 ] => 0.42707 (27988)
27988,
// [30] k_lfo3_waveform = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [31] k_lfo3_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [35] k_lfo3_mod_amount = 0.673354 [ 0 - 100 ] => 0.286458 (18773)
18773,
// [36] k_pitch_env_mod = 8.679 [ -100 - 100 ] => 0.543395 (35611)
35611,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 10.2431 [ 0 - 100 ] => 0.102431 (6712)
6712,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 11499.1 [ 0 - 22050 ] => 0.722149 (47326)
47326,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 10.9361 [ 0 - 100 ] => 0.109361 (7166)
7166,
// [45] k_filter1_keytrack = -200 [ -200 - 200 ] => 0 (0)
0,
// [46] k_filter1_vel_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [47] k_filter1_env_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [48] k_filter2_mode = 4 [ 0 - 6 ] => 0.666667 (43690)
43690,
// [49] k_filter2_cutoff = 10314.9 [ 0 - 22050 ] => 0.683957 (44823)
44823,
// [50] k_filter2_resonance = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = -133.336 [ -200 - 200 ] => 0.166659 (10921)
10921,
// [53] k_filter2_vel_mod = -39.5864 [ -100 - 100 ] => 0.302068 (19796)
19796,
// [54] k_filter2_env_mod = 11.458 [ -100 - 100 ] => 0.55729 (36522)
36522,
// [55] k_filter_attack = 0.0961318 [ 0 - 100 ] => 0.000961318 (62)
62,
// [56] k_filter_decay = 9.99924 [ 0 - 100 ] => 0.0999924 (6553)
6553,
// [57] k_filter_sustain = 45.3117 [ 0 - 100 ] => 0.453117 (29695)
29695,
// [58] k_filter_release = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [59] k_amp_env_vel_mod = 24.9989 [ 0 - 100 ] => 0.249989 (16383)
16383,
// [60] k_env_length = 8.85417 [ 0 - 100 ] => 0.0885417 (5802)
5802,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [66] k_amp_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [67] k_amp_decay = 4.72222 [ 0 - 100 ] => 0.0472222 (3094)
3094,
// [68] k_amp_sustain = 1.38889 [ 0 - 100 ] => 0.0138889 (910)
910,
// [69] k_amp_release = 10.7634 [ 0 - 100 ] => 0.107634 (7053)
7053,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -13.5428 [ -100 - 100 ] => 0.432286 (28329)
28329,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 4 - ride
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [1] k_osc1_semi = 60 [ -60 - 60 ] => 1 (65535)
65535,
// [2] k_osc1_detune = 47.3945 [ 0 - 100 ] => 0.473945 (31059)
31059,
// [3] k_osc1_volume = 53.6451 [ 0 - 100 ] => 0.536451 (35156)
35156,
// [4] k_osc1_pw = 37.499 [ 0 - 100 ] => 0.37499 (24574)
24574,
// [5] k_osc1_pwm = 53.6385 [ 0 - 100 ] => 0.536385 (35151)
35151,
// [6] k_osc2_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [7] k_osc2_semi = 60 [ -60 - 60 ] => 1 (65535)
65535,
// [8] k_osc2_detune = 55.729 [ 0 - 100 ] => 0.55729 (36522)
36522,
// [9] k_osc2_volume = 36.8041 [ 0 - 100 ] => 0.368041 (24119)
24119,
// [10] k_osc2_pw = 60.9369 [ 0 - 100 ] => 0.609369 (39934)
39934,
// [11] k_osc2_pwm = 61.9791 [ 0 - 100 ] => 0.619791 (40618)
40618,
// [12] k_osc3_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [13] k_osc3_semi = 0.0925183 [ -60 - 60 ] => 0.500771 (32818)
32818,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [19] k_lfo1_speed = 0.164002 [ -250 - 250 ] => 0.500328 (32788)
32788,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 2 [ 0 - 11 ] => 0.181818 (11915)
11915,
// [23] k_lfo1_mod_amount = 7.35615 [ 0 - 100 ] => 0.52079 (34129)
34129,
// [24] k_lfo2_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [25] k_lfo2_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 7 [ 0 - 11 ] => 0.636364 (41704)
41704,
// [29] k_lfo2_mod_amount = 3.32657 [ 0 - 100 ] => 0.42707 (27988)
27988,
// [30] k_lfo3_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [31] k_lfo3_speed = 250 [ -250 - 250 ] => 1 (65535)
65535,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [35] k_lfo3_mod_amount = 0.673354 [ 0 - 100 ] => 0.286458 (18773)
18773,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 13042.8 [ 0 - 22050 ] => 0.769097 (50402)
50402,
// [43] k_filter1_resonance = 2.43056 [ 0 - 100 ] => 0.0243056 (1592)
1592,
// [44] k_filter1_drive = 10.9361 [ 0 - 100 ] => 0.109361 (7166)
7166,
// [45] k_filter1_keytrack = -200 [ -200 - 200 ] => 0 (0)
0,
// [46] k_filter1_vel_mod = -2.432 [ -100 - 100 ] => 0.48784 (31970)
31970,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 3 [ 0 - 6 ] => 0.5 (32767)
32767,
// [49] k_filter2_cutoff = 6386.84 [ 0 - 22050 ] => 0.538194 (35270)
35270,
// [50] k_filter2_resonance = 14.7569 [ 0 - 100 ] => 0.147569 (9670)
9670,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = -200 [ -200 - 200 ] => 0 (0)
0,
// [53] k_filter2_vel_mod = -39.5864 [ -100 - 100 ] => 0.302068 (19796)
19796,
// [54] k_filter2_env_mod = 6.9442 [ -100 - 100 ] => 0.534721 (35042)
35042,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 15.7284 [ 0 - 100 ] => 0.157284 (10307)
10307,
// [57] k_filter_sustain = 51.9089 [ 0 - 100 ] => 0.519089 (34018)
34018,
// [58] k_filter_release = 51.5972 [ 0 - 100 ] => 0.515972 (33814)
33814,
// [59] k_amp_env_vel_mod = 50.1389 [ 0 - 100 ] => 0.501389 (32858)
32858,
// [60] k_env_length = 8.95399 [ 0 - 100 ] => 0.0895399 (5867)
5867,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.2 [ 0 - 100 ] => 0.002 (131)
131,
// [67] k_amp_decay = 13.9236 [ 0 - 100 ] => 0.139236 (9124)
9124,
// [68] k_amp_sustain = 56.941 [ 0 - 100 ] => 0.56941 (37316)
37316,
// [69] k_amp_release = 49.4787 [ 0 - 100 ] => 0.494787 (32425)
32425,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 17.3598 [ -100 - 100 ] => 0.586799 (38455)
38455,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 5 - vr_plim
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 2 [ 0 - 11 ] => 0.181818 (11915)
11915,
// [7] k_osc2_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [8] k_osc2_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [9] k_osc2_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [10] k_osc2_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 5 [ 0 - 11 ] => 0.454545 (29788)
29788,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 21.0069 [ 0 - 100 ] => 0.210069 (13766)
13766,
// [16] k_osc3_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 0.0999868 [ -250 - 250 ] => 0.5002 (32780)
32780,
// [20] k_lfo1_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [21] k_lfo1_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 1005.48 [ 0 - 22050 ] => 0.213542 (13994)
13994,
// [43] k_filter1_resonance = 34.5486 [ 0 - 100 ] => 0.345486 (22641)
22641,
// [44] k_filter1_drive = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 4 [ 0 - 6 ] => 0.666667 (43690)
43690,
// [49] k_filter2_cutoff = 35.1577 [ 0 - 22050 ] => 0.0399306 (2616)
2616,
// [50] k_filter2_resonance = 88.7153 [ 0 - 100 ] => 0.887153 (58139)
58139,
// [51] k_filter2_drive = 12.8472 [ 0 - 100 ] => 0.128472 (8419)
8419,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [57] k_filter_sustain = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [58] k_filter_release = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 500 [ 0 - 5000 ] => 0.1 (6553)
6553,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.2 [ 0 - 100 ] => 0.002 (131)
131,
// [67] k_amp_decay = 23.2639 [ 0 - 100 ] => 0.232639 (15245)
15245,
// [68] k_amp_sustain = 23.7847 [ 0 - 100 ] => 0.237847 (15587)
15587,
// [69] k_amp_release = 65.7292 [ 0 - 100 ] => 0.657292 (43075)
43075,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [78] k_osc2_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 6 - snare
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 5 [ 0 - 11 ] => 0.454545 (29788)
29788,
// [1] k_osc1_semi = 31.65 [ -60 - 60 ] => 0.76375 (50052)
50052,
// [2] k_osc1_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [3] k_osc1_volume = 82.4653 [ 0 - 100 ] => 0.824653 (54043)
54043,
// [4] k_osc1_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 7 [ 0 - 11 ] => 0.636364 (41704)
41704,
// [7] k_osc2_semi = -60 [ -60 - 60 ] => 0 (0)
0,
// [8] k_osc2_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [9] k_osc2_volume = 20.1389 [ 0 - 100 ] => 0.201389 (13198)
13198,
// [10] k_osc2_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [13] k_osc3_semi = -0.526439 [ -60 - 60 ] => 0.495613 (32479)
32479,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 130.201 [ -250 - 250 ] => 0.760403 (49833)
49833,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.179499 [ -250 - 250 ] => 0.500359 (32791)
32791,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.278503 [ -250 - 250 ] => 0.500557 (32804)
32804,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 80.9028 [ -100 - 100 ] => 0.904514 (59277)
59277,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 4.86111 [ 0 - 100 ] => 0.0486111 (3185)
3185,
// [39] k_pitch_sustain = 18.75 [ 0 - 100 ] => 0.1875 (12287)
12287,
// [40] k_pitch_release = 22.3958 [ 0 - 100 ] => 0.223958 (14677)
14677,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 17286.1 [ 0 - 22050 ] => 0.885409 (58025)
58025,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 12.6725 [ 0 - 100 ] => 0.126725 (8304)
8304,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 41.3194 [ -100 - 100 ] => 0.706597 (46306)
46306,
// [47] k_filter1_env_mod = 5.5552 [ -100 - 100 ] => 0.527776 (34587)
34587,
// [48] k_filter2_mode = 4 [ 0 - 6 ] => 0.666667 (43690)
43690,
// [49] k_filter2_cutoff = 7547.76 [ 0 - 22050 ] => 0.585066 (38342)
38342,
// [50] k_filter2_resonance = 93.4028 [ 0 - 100 ] => 0.934028 (61211)
61211,
// [51] k_filter2_drive = 1.38889 [ 0 - 100 ] => 0.0138889 (910)
910,
// [52] k_filter2_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [53] k_filter2_vel_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [54] k_filter2_env_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [55] k_filter_attack = 0.0991836 [ 0 - 100 ] => 0.000991836 (64)
64,
// [56] k_filter_decay = 14.4093 [ 0 - 100 ] => 0.144093 (9443)
9443,
// [57] k_filter_sustain = 1.04067 [ 0 - 100 ] => 0.0104067 (682)
682,
// [58] k_filter_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [59] k_amp_env_vel_mod = 74.65 [ 0 - 100 ] => 0.7465 (48921)
48921,
// [60] k_env_length = 6.77043 [ 0 - 100 ] => 0.0677043 (4437)
4437,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [66] k_amp_attack = 0.07 [ 0 - 100 ] => 0.0007 (45)
45,
// [67] k_amp_decay = 18.2283 [ 0 - 100 ] => 0.182283 (11945)
11945,
// [68] k_amp_sustain = 6.07639 [ 0 - 100 ] => 0.0607639 (3982)
3982,
// [69] k_amp_release = 14.0625 [ 0 - 100 ] => 0.140625 (9215)
9215,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -28.4738 [ -100 - 100 ] => 0.357631 (23437)
23437,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 7 - snare_break
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 7 [ 0 - 11 ] => 0.636364 (41704)
41704,
// [1] k_osc1_semi = 34.5833 [ -60 - 60 ] => 0.788194 (51654)
51654,
// [2] k_osc1_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [3] k_osc1_volume = 15.7986 [ 0 - 100 ] => 0.157986 (10353)
10353,
// [4] k_osc1_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [7] k_osc2_semi = -60 [ -60 - 60 ] => 0 (0)
0,
// [8] k_osc2_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [9] k_osc2_volume = 82.1181 [ 0 - 100 ] => 0.821181 (53816)
53816,
// [10] k_osc2_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [13] k_osc3_semi = 18.75 [ -60 - 60 ] => 0.65625 (43007)
43007,
// [14] k_osc3_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [15] k_osc3_volume = 30.0347 [ 0 - 100 ] => 0.300347 (19683)
19683,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 130.201 [ -250 - 250 ] => 0.760403 (49833)
49833,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.179499 [ -250 - 250 ] => 0.500359 (32791)
32791,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.278503 [ -250 - 250 ] => 0.500557 (32804)
32804,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0.173611 [ 0 - 100 ] => 0.00173611 (113)
113,
// [38] k_pitch_decay = 9.2014 [ 0 - 100 ] => 0.092014 (6030)
6030,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 6.77084 [ 0 - 100 ] => 0.0677084 (4437)
4437,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 1140.53 [ 0 - 22050 ] => 0.227431 (14904)
14904,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 23.6111 [ 0 - 100 ] => 0.236111 (15473)
15473,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 40.2778 [ -100 - 100 ] => 0.701389 (45965)
45965,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 2 [ 0 - 6 ] => 0.333333 (21845)
21845,
// [49] k_filter2_cutoff = 122.886 [ 0 - 22050 ] => 0.0746528 (4892)
4892,
// [50] k_filter2_resonance = 25.6945 [ 0 - 100 ] => 0.256945 (16838)
16838,
// [51] k_filter2_drive = 7.98611 [ 0 - 100 ] => 0.0798611 (5233)
5233,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.0991836 [ 0 - 100 ] => 0.000991836 (64)
64,
// [56] k_filter_decay = 56.5968 [ 0 - 100 ] => 0.565968 (37090)
37090,
// [57] k_filter_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [58] k_filter_release = 14.4097 [ 0 - 100 ] => 0.144097 (9443)
9443,
// [59] k_amp_env_vel_mod = 74.65 [ 0 - 100 ] => 0.7465 (48921)
48921,
// [60] k_env_length = 7.46528 [ 0 - 100 ] => 0.0746528 (4892)
4892,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [66] k_amp_attack = 0.07 [ 0 - 100 ] => 0.0007 (45)
45,
// [67] k_amp_decay = 32.6389 [ 0 - 100 ] => 0.326389 (21389)
21389,
// [68] k_amp_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [69] k_amp_release = 5.9028 [ 0 - 100 ] => 0.059028 (3868)
3868,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 20.1372 [ -100 - 100 ] => 0.600686 (39365)
39365,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 6 [ 0 - 6 ] => 1 (65535)
65535,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 8 - bd_break
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [1] k_osc1_semi = -28.5416 [ -60 - 60 ] => 0.262153 (17180)
17180,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = -54.3767 [ -60 - 60 ] => 0.0468605 (3071)
3071,
// [8] k_osc2_detune = 61.4557 [ 0 - 100 ] => 0.614557 (40274)
40274,
// [9] k_osc2_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [10] k_osc2_pw = 81.2497 [ 0 - 100 ] => 0.812497 (53246)
53246,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = -46.8767 [ -60 - 60 ] => 0.109361 (7166)
7166,
// [14] k_osc3_detune = 56.7681 [ 0 - 100 ] => 0.567681 (37202)
37202,
// [15] k_osc3_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [16] k_osc3_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 0.0874996 [ -250 - 250 ] => 0.500175 (32778)
32778,
// [20] k_lfo1_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [21] k_lfo1_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.164002 [ -250 - 250 ] => 0.500328 (32788)
32788,
// [26] k_lfo2_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.263005 [ -250 - 250 ] => 0.500526 (32801)
32801,
// [32] k_lfo3_startphase = -0.00575066 [ -360 - 360 ] => 0.499992 (32766)
32766,
// [33] k_lfo3_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [36] k_pitch_env_mod = 10.4166 [ -100 - 100 ] => 0.552083 (36180)
36180,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 18.2292 [ 0 - 100 ] => 0.182292 (11946)
11946,
// [39] k_pitch_sustain = 11.4583 [ 0 - 100 ] => 0.114583 (7509)
7509,
// [40] k_pitch_release = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [41] k_filter1_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [42] k_filter1_cutoff = 21.5128 [ 0 - 22050 ] => 0.0312352 (2046)
2046,
// [43] k_filter1_resonance = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [46] k_filter1_vel_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [47] k_filter1_env_mod = 0.325 [ -100 - 100 ] => 0.501625 (32873)
32873,
// [48] k_filter2_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [49] k_filter2_cutoff = 39.9642 [ 0 - 22050 ] => 0.0425727 (2790)
2790,
// [50] k_filter2_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [51] k_filter2_drive = 13.5409 [ 0 - 100 ] => 0.135409 (8874)
8874,
// [52] k_filter2_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [53] k_filter2_vel_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [54] k_filter2_env_mod = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [55] k_filter_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [56] k_filter_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [57] k_filter_sustain = 0.347222 [ 0 - 100 ] => 0.00347222 (227)
227,
// [58] k_filter_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [59] k_amp_env_vel_mod = 48.9555 [ 0 - 100 ] => 0.489555 (32082)
32082,
// [60] k_env_length = 16.9437 [ 0 - 100 ] => 0.169437 (11104)
11104,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 0 [ 0 - 5000 ] => 0 (0)
0,
// [65] k_env_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [66] k_amp_attack = 0.02 [ 0 - 100 ] => 0.0002 (13)
13,
// [67] k_amp_decay = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [68] k_amp_sustain = 77.7778 [ 0 - 100 ] => 0.777778 (50971)
50971,
// [69] k_amp_release = 72.5694 [ 0 - 100 ] => 0.725694 (47558)
47558,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 9 - crash
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 4 [ 0 - 11 ] => 0.363636 (23830)
23830,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 6 [ 0 - 11 ] => 0.545455 (35746)
35746,
// [7] k_osc2_semi = -23.1416 [ -60 - 60 ] => 0.307153 (20129)
20129,
// [8] k_osc2_detune = 23.0903 [ 0 - 100 ] => 0.230903 (15132)
15132,
// [9] k_osc2_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [10] k_osc2_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [16] k_osc3_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 0.0999868 [ -250 - 250 ] => 0.5002 (32780)
32780,
// [20] k_lfo1_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [21] k_lfo1_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [39] k_pitch_sustain = 5.03472 [ 0 - 100 ] => 0.0503472 (3299)
3299,
// [40] k_pitch_release = 67.7083 [ 0 - 100 ] => 0.677083 (44372)
44372,
// [41] k_filter1_mode = 2 [ 0 - 6 ] => 0.333333 (21845)
21845,
// [42] k_filter1_cutoff = 2105.74 [ 0 - 22050 ] => 0.309028 (20252)
20252,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [49] k_filter2_cutoff = 22050 [ 0 - 22050 ] => 1 (65535)
65535,
// [50] k_filter2_resonance = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 37.9513 [ 0 - 100 ] => 0.379513 (24871)
24871,
// [57] k_filter_sustain = 1.5625 [ 0 - 100 ] => 0.015625 (1023)
1023,
// [58] k_filter_release = 68.4028 [ 0 - 100 ] => 0.684028 (44827)
44827,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 15.5556 [ 0 - 100 ] => 0.155556 (10194)
10194,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 500 [ 0 - 5000 ] => 0.1 (6553)
6553,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [67] k_amp_decay = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [68] k_amp_sustain = 92.5347 [ 0 - 100 ] => 0.925347 (60642)
60642,
// [69] k_amp_release = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -6.5972 [ -100 - 100 ] => 0.467014 (30605)
30605,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 4 [ 0 - 6 ] => 0.666667 (43690)
43690,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [77] k_osc1_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [78] k_osc2_ratio = 7.77084 [ 0 - 20 ] => 0.388542 (25463)
25463,
// [79] k_osc3_ratio = 18.5 [ 0 - 20 ] => 0.925 (60619)
60619
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 10 - bass_1
//----------------------------------------------------------------------------

// Track 10 has automation envelope events for parameters: 42, 43, 47, 49

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 55.2083 [ 0 - 100 ] => 0.552083 (36180)
36180,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = -12.5167 [ -60 - 60 ] => 0.395694 (25931)
25931,
// [8] k_osc2_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [9] k_osc2_volume = 71.5278 [ 0 - 100 ] => 0.715278 (46875)
46875,
// [10] k_osc2_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 74.1319 [ 0 - 100 ] => 0.741319 (48582)
48582,
// [16] k_osc3_pw = 30.902 [ 0 - 100 ] => 0.30902 (20251)
20251,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = -91.0545 [ -250 - 250 ] => 0.317891 (20832)
20832,
// [20] k_lfo1_startphase = -15.0127 [ -360 - 360 ] => 0.479149 (31401)
31401,
// [21] k_lfo1_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.179499 [ -250 - 250 ] => 0.500359 (32791)
32791,
// [26] k_lfo2_startphase = 56.2457 [ -360 - 360 ] => 0.578119 (37887)
37887,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.286013 [ -250 - 250 ] => 0.500572 (32804)
32804,
// [32] k_lfo3_startphase = -360 [ -360 - 360 ] => 0 (0)
0,
// [33] k_lfo3_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 141.12 [ 0 - 22050 ] => 0.08 (5242)
5242,
// [43] k_filter1_resonance = 6 [ 0 - 100 ] => 0.06 (3932)
3932,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 13.8888 [ -100 - 100 ] => 0.569444 (37318)
37318,
// [47] k_filter1_env_mod = 3 [ -100 - 100 ] => 0.515 (33750)
33750,
// [48] k_filter2_mode = 2 [ 0 - 6 ] => 0.333333 (21845)
21845,
// [49] k_filter2_cutoff = 55.125 [ 0 - 22050 ] => 0.05 (3276)
3276,
// [50] k_filter2_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [56] k_filter_decay = 8.33333 [ 0 - 100 ] => 0.0833333 (5461)
5461,
// [57] k_filter_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [58] k_filter_release = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [59] k_amp_env_vel_mod = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [60] k_env_length = 36.0409 [ 0 - 100 ] => 0.360409 (23619)
23619,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [63] k_glide_type = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [64] k_glide_time = 60.764 [ 0 - 5000 ] => 0.0121528 (796)
796,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [67] k_amp_decay = 28.1235 [ 0 - 100 ] => 0.281235 (18430)
18430,
// [68] k_amp_sustain = 44.2708 [ 0 - 100 ] => 0.442708 (29012)
29012,
// [69] k_amp_release = 6.07639 [ 0 - 100 ] => 0.0607639 (3982)
3982,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 11 - bass_2
//----------------------------------------------------------------------------

// Track 11 has automation envelope events for parameters: 42, 43, 47

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 55.2083 [ 0 - 100 ] => 0.552083 (36180)
36180,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = -12.5167 [ -60 - 60 ] => 0.395694 (25931)
25931,
// [8] k_osc2_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [9] k_osc2_volume = 71.5278 [ 0 - 100 ] => 0.715278 (46875)
46875,
// [10] k_osc2_pw = 49.9992 [ 0 - 100 ] => 0.499992 (32766)
32766,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 74.1319 [ 0 - 100 ] => 0.741319 (48582)
48582,
// [16] k_osc3_pw = 30.902 [ 0 - 100 ] => 0.30902 (20251)
20251,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = -91.0545 [ -250 - 250 ] => 0.317891 (20832)
20832,
// [20] k_lfo1_startphase = -15.0127 [ -360 - 360 ] => 0.479149 (31401)
31401,
// [21] k_lfo1_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.179499 [ -250 - 250 ] => 0.500359 (32791)
32791,
// [26] k_lfo2_startphase = 56.2457 [ -360 - 360 ] => 0.578119 (37887)
37887,
// [27] k_lfo2_keytrack = 99.9984 [ -200 - 200 ] => 0.749996 (49150)
49150,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.286013 [ -250 - 250 ] => 0.500572 (32804)
32804,
// [32] k_lfo3_startphase = -360 [ -360 - 360 ] => 0 (0)
0,
// [33] k_lfo3_keytrack = -0.00319481 [ -200 - 200 ] => 0.499992 (32766)
32766,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 141.12 [ 0 - 22050 ] => 0.08 (5242)
5242,
// [43] k_filter1_resonance = 6 [ 0 - 100 ] => 0.06 (3932)
3932,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 13.8888 [ -100 - 100 ] => 0.569444 (37318)
37318,
// [47] k_filter1_env_mod = 9 [ -100 - 100 ] => 0.545 (35716)
35716,
// [48] k_filter2_mode = 2 [ 0 - 6 ] => 0.333333 (21845)
21845,
// [49] k_filter2_cutoff = 117.236 [ 0 - 22050 ] => 0.0729167 (4778)
4778,
// [50] k_filter2_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [56] k_filter_decay = 8.33333 [ 0 - 100 ] => 0.0833333 (5461)
5461,
// [57] k_filter_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [58] k_filter_release = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [59] k_amp_env_vel_mod = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [60] k_env_length = 36.0409 [ 0 - 100 ] => 0.360409 (23619)
23619,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [63] k_glide_type = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [64] k_glide_time = 60.764 [ 0 - 5000 ] => 0.0121528 (796)
796,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [67] k_amp_decay = 28.1235 [ 0 - 100 ] => 0.281235 (18430)
18430,
// [68] k_amp_sustain = 44.2708 [ 0 - 100 ] => 0.442708 (29012)
29012,
// [69] k_amp_release = 6.07639 [ 0 - 100 ] => 0.0607639 (3982)
3982,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = -0.0015974 [ -100 - 100 ] => 0.499992 (32766)
32766,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [78] k_osc2_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276,
// [79] k_osc3_ratio = 0.999772 [ 0 - 20 ] => 0.0499886 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 12 - horn_stab
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [3] k_osc1_volume = 70 [ 0 - 100 ] => 0.7 (45874)
45874,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [7] k_osc2_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [8] k_osc2_detune = 67.5347 [ 0 - 100 ] => 0.675347 (44258)
44258,
// [9] k_osc2_volume = 26.2153 [ 0 - 100 ] => 0.262153 (17180)
17180,
// [10] k_osc2_pw = 7.11806 [ 0 - 100 ] => 0.0711806 (4664)
4664,
// [11] k_osc2_pwm = 6.07635 [ 0 - 100 ] => 0.0607635 (3982)
3982,
// [12] k_osc3_waveform = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 38.1944 [ 0 - 100 ] => 0.381944 (25030)
25030,
// [15] k_osc3_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [16] k_osc3_pw = 23.2639 [ 0 - 100 ] => 0.232639 (15245)
15245,
// [17] k_osc3_pwm = 5.55554 [ 0 - 100 ] => 0.0555554 (3640)
3640,
// [18] k_lfo1_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [19] k_lfo1_speed = -1.11151 [ -250 - 250 ] => 0.497777 (32621)
32621,
// [20] k_lfo1_startphase = 30.0002 [ -360 - 360 ] => 0.541667 (35498)
35498,
// [21] k_lfo1_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [22] k_lfo1_mod_dest = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [23] k_lfo1_mod_amount = 0.0544808 [ 0 - 100 ] => 0.152778 (10012)
10012,
// [24] k_lfo2_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 1229.25 [ 0 - 22050 ] => 0.236111 (15473)
15473,
// [43] k_filter1_resonance = 7.98611 [ 0 - 100 ] => 0.0798611 (5233)
5233,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 36.4584 [ -100 - 100 ] => 0.682292 (44714)
44714,
// [48] k_filter2_mode = 3 [ 0 - 6 ] => 0.5 (32767)
32767,
// [49] k_filter2_cutoff = 172.862 [ 0 - 22050 ] => 0.0885412 (5802)
5802,
// [50] k_filter2_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [51] k_filter2_drive = 22.9167 [ 0 - 100 ] => 0.229167 (15018)
15018,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 24.3056 [ -100 - 100 ] => 0.621528 (40731)
40731,
// [55] k_filter_attack = 7.46528 [ 0 - 100 ] => 0.0746528 (4892)
4892,
// [56] k_filter_decay = 9.47914 [ 0 - 100 ] => 0.0947914 (6212)
6212,
// [57] k_filter_sustain = 46.7014 [ 0 - 100 ] => 0.467014 (30605)
30605,
// [58] k_filter_release = 23.125 [ 0 - 100 ] => 0.23125 (15154)
15154,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 14.8611 [ 0 - 100 ] => 0.148611 (9739)
9739,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 500 [ 0 - 5000 ] => 0.1 (6553)
6553,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.03 [ 0 - 100 ] => 0.0003 (19)
19,
// [67] k_amp_decay = 8.33333 [ 0 - 100 ] => 0.0833333 (5461)
5461,
// [68] k_amp_sustain = 70.4861 [ 0 - 100 ] => 0.704861 (46193)
46193,
// [69] k_amp_release = 41.0764 [ 0 - 100 ] => 0.410764 (26919)
26919,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0 [ 0 - 20 ] => 0 (0)
0,
// [78] k_osc2_ratio = 0 [ 0 - 20 ] => 0 (0)
0,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 13 - sample_playback
//----------------------------------------------------------------------------

// Track 13 has automation envelope events for parameters: 77

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [1] k_osc1_semi = 13.9416 [ -60 - 60 ] => 0.61618 (40381)
40381,
// [2] k_osc1_detune = 61.1111 [ 0 - 100 ] => 0.611111 (40049)
40049,
// [3] k_osc1_volume = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [7] k_osc2_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [8] k_osc2_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [9] k_osc2_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [10] k_osc2_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 0 [ 0 - 100 ] => 0 (0)
0,
// [16] k_osc3_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [17] k_osc3_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [18] k_lfo1_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [19] k_lfo1_speed = 0.0999868 [ -250 - 250 ] => 0.5002 (32780)
32780,
// [20] k_lfo1_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [21] k_lfo1_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [22] k_lfo1_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [23] k_lfo1_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [24] k_lfo2_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [25] k_lfo2_speed = 0.200003 [ -250 - 250 ] => 0.5004 (32793)
32793,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [29] k_lfo2_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [30] k_lfo3_waveform = 10 [ 0 - 11 ] => 0.909091 (59577)
59577,
// [31] k_lfo3_speed = 0.29999 [ -250 - 250 ] => 0.5006 (32806)
32806,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 0 [ 0 - 11 ] => 0 (0)
0,
// [35] k_lfo3_mod_amount = 0 [ 0 - 100 ] => 0 (0)
0,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [42] k_filter1_cutoff = 22050 [ 0 - 22050 ] => 1 (65535)
65535,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 0 [ 0 - 6 ] => 0 (0)
0,
// [49] k_filter2_cutoff = 22050 [ 0 - 22050 ] => 1 (65535)
65535,
// [50] k_filter2_resonance = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = 0 [ -200 - 200 ] => 0.5 (32767)
32767,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [57] k_filter_sustain = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [58] k_filter_release = 20 [ 0 - 100 ] => 0.2 (13107)
13107,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [63] k_glide_type = 0 [ 0 - 2 ] => 0 (0)
0,
// [64] k_glide_time = 500 [ 0 - 5000 ] => 0.1 (6553)
6553,
// [65] k_env_mode = 0 [ 0 - 2 ] => 0 (0)
0,
// [66] k_amp_attack = 0.2 [ 0 - 100 ] => 0.002 (131)
131,
// [67] k_amp_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [68] k_amp_sustain = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [69] k_amp_release = 2.25694 [ 0 - 100 ] => 0.0225694 (1479)
1479,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 11.5853 [ 0 - 100 ] => 0.115853 (7592)
7592,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 0 [ 0 - 20 ] => 0 (0)
0,
// [78] k_osc2_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 14 - hi_string
//----------------------------------------------------------------------------

// Track 14 has automation envelope events for parameters: 73

{
// START_PLUG_STATE
// OpsV param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_osc1_waveform = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [1] k_osc1_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [2] k_osc1_detune = 48.9583 [ 0 - 100 ] => 0.489583 (32084)
32084,
// [3] k_osc1_volume = 70 [ 0 - 100 ] => 0.7 (45874)
45874,
// [4] k_osc1_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [5] k_osc1_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [6] k_osc2_waveform = 1 [ 0 - 11 ] => 0.0909091 (5957)
5957,
// [7] k_osc2_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [8] k_osc2_detune = 52.0834 [ 0 - 100 ] => 0.520834 (34132)
34132,
// [9] k_osc2_volume = 70.1389 [ 0 - 100 ] => 0.701389 (45965)
45965,
// [10] k_osc2_pw = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [11] k_osc2_pwm = 0 [ 0 - 100 ] => 0 (0)
0,
// [12] k_osc3_waveform = 3 [ 0 - 11 ] => 0.272727 (17873)
17873,
// [13] k_osc3_semi = 0.399957 [ -60 - 60 ] => 0.503333 (32985)
32985,
// [14] k_osc3_detune = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [15] k_osc3_volume = 71.0069 [ 0 - 100 ] => 0.710069 (46534)
46534,
// [16] k_osc3_pw = 50.6944 [ 0 - 100 ] => 0.506944 (33222)
33222,
// [17] k_osc3_pwm = 28.9931 [ 0 - 100 ] => 0.289931 (19000)
19000,
// [18] k_lfo1_waveform = 9 [ 0 - 11 ] => 0.818182 (53619)
53619,
// [19] k_lfo1_speed = -248.264 [ -250 - 250 ] => 0.00347222 (227)
227,
// [20] k_lfo1_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [21] k_lfo1_keytrack = 52.7776 [ -200 - 200 ] => 0.631944 (41414)
41414,
// [22] k_lfo1_mod_dest = 11 [ 0 - 11 ] => 1 (65535)
65535,
// [23] k_lfo1_mod_amount = 7.96518 [ 0 - 100 ] => 0.53125 (34815)
34815,
// [24] k_lfo2_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [25] k_lfo2_speed = 0.833511 [ -250 - 250 ] => 0.501667 (32876)
32876,
// [26] k_lfo2_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [27] k_lfo2_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [28] k_lfo2_mod_dest = 7 [ 0 - 11 ] => 0.636364 (41704)
41704,
// [29] k_lfo2_mod_amount = 49.0342 [ 0 - 100 ] => 0.836806 (54840)
54840,
// [30] k_lfo3_waveform = 0 [ 0 - 11 ] => 0 (0)
0,
// [31] k_lfo3_speed = 1.87501 [ -250 - 250 ] => 0.50375 (33013)
33013,
// [32] k_lfo3_startphase = 0 [ -360 - 360 ] => 0.5 (32767)
32767,
// [33] k_lfo3_keytrack = 100 [ -200 - 200 ] => 0.75 (49151)
49151,
// [34] k_lfo3_mod_dest = 8 [ 0 - 11 ] => 0.727273 (47661)
47661,
// [35] k_lfo3_mod_amount = 0.182178 [ 0 - 100 ] => 0.206597 (13539)
13539,
// [36] k_pitch_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [37] k_pitch_attack = 0 [ 0 - 100 ] => 0 (0)
0,
// [38] k_pitch_decay = 0 [ 0 - 100 ] => 0 (0)
0,
// [39] k_pitch_sustain = 0 [ 0 - 100 ] => 0 (0)
0,
// [40] k_pitch_release = 0 [ 0 - 100 ] => 0 (0)
0,
// [41] k_filter1_mode = 1 [ 0 - 6 ] => 0.166667 (10922)
10922,
// [42] k_filter1_cutoff = 2986.99 [ 0 - 22050 ] => 0.368055 (24120)
24120,
// [43] k_filter1_resonance = 0 [ 0 - 100 ] => 0 (0)
0,
// [44] k_filter1_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [45] k_filter1_keytrack = -66.6668 [ -200 - 200 ] => 0.333333 (21844)
21844,
// [46] k_filter1_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [47] k_filter1_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [48] k_filter2_mode = 2 [ 0 - 6 ] => 0.333333 (21845)
21845,
// [49] k_filter2_cutoff = 3043.61 [ 0 - 22050 ] => 0.371527 (24348)
24348,
// [50] k_filter2_resonance = 0.729167 [ 0 - 100 ] => 0.00729167 (477)
477,
// [51] k_filter2_drive = 0 [ 0 - 100 ] => 0 (0)
0,
// [52] k_filter2_keytrack = 200 [ -200 - 200 ] => 1 (65535)
65535,
// [53] k_filter2_vel_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [54] k_filter2_env_mod = 0 [ -100 - 100 ] => 0.5 (32767)
32767,
// [55] k_filter_attack = 0.1 [ 0 - 100 ] => 0.001 (65)
65,
// [56] k_filter_decay = 1.5625 [ 0 - 100 ] => 0.015625 (1023)
1023,
// [57] k_filter_sustain = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [58] k_filter_release = 0.347222 [ 0 - 100 ] => 0.00347222 (227)
227,
// [59] k_amp_env_vel_mod = 80 [ 0 - 100 ] => 0.8 (52428)
52428,
// [60] k_env_length = 10 [ 0 - 100 ] => 0.1 (6553)
6553,
// [61] k_filter_routing = 0 [ 0 - 1 ] => 0 (0)
0,
// [62] k_poly_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [63] k_glide_type = 1 [ 0 - 2 ] => 0.5 (32767)
32767,
// [64] k_glide_time = 3008.68 [ 0 - 5000 ] => 0.601736 (39434)
39434,
// [65] k_env_mode = 2 [ 0 - 2 ] => 1 (65535)
65535,
// [66] k_amp_attack = 0.2 [ 0 - 100 ] => 0.002 (131)
131,
// [67] k_amp_decay = 5 [ 0 - 100 ] => 0.05 (3276)
3276,
// [68] k_amp_sustain = 92 [ 0 - 100 ] => 0.92 (60292)
60292,
// [69] k_amp_release = 0.27778 [ 0 - 100 ] => 0.0027778 (182)
182,
// [70] k_tempo = 0 [ 0 - 1 ] => 0 (0)
0,
// [71] k_pan = 16.3194 [ -100 - 100 ] => 0.581597 (38114)
38114,
// [72] k_filter1_output_level = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [73] k_filter2_output_level = 0 [ 0 - 100 ] => 0 (0)
0,
// [74] k_synth_type = 0 [ 0 - 6 ] => 0 (0)
0,
// [75] k_fm_algorithm = 0 [ 0 - 1 ] => 0 (0)
0,
// [76] k_osc3_feedback = 0 [ 0 - 100 ] => 0 (0)
0,
// [77] k_osc1_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [78] k_osc2_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276,
// [79] k_osc3_ratio = 1 [ 0 - 20 ] => 0.05 (3276)
3276
// END_PLUG_STATE
},

};

static int32_t distortion_params[3][4]
{
//----------------------------------------------------------------------------
// Track 15 - dist_bd_clap
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opSr param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_dist_mode = 1 [ 0 - 7 ] => 0.142857 (9362)
9362,
// [1] k_dist_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_dist_drive = 39.4097 [ 0 - 100 ] => 0.394097 (25827)
25827,
// [3] k_dist_post_gain = 90 [ 0 - 1000 ] => 0.09 (5898)
5898
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 16 - dist_bass_1
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opSr param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_dist_mode = 4 [ 0 - 7 ] => 0.571429 (37448)
37448,
// [1] k_dist_mix = 34.0278 [ 0 - 100 ] => 0.340278 (22300)
22300,
// [2] k_dist_drive = 60.2431 [ 0 - 100 ] => 0.602431 (39480)
39480,
// [3] k_dist_post_gain = 90 [ 0 - 1000 ] => 0.09 (5898)
5898
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 17 - dist_bass_2
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opSr param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_dist_mode = 4 [ 0 - 7 ] => 0.571429 (37448)
37448,
// [1] k_dist_mix = 76.0417 [ 0 - 100 ] => 0.760417 (49833)
49833,
// [2] k_dist_drive = 44.2708 [ 0 - 100 ] => 0.442708 (29012)
29012,
// [3] k_dist_post_gain = 90 [ 0 - 1000 ] => 0.09 (5898)
5898
// END_PLUG_STATE
},

};

static int32_t echo_params[5][6]
{
//----------------------------------------------------------------------------
// Track 18 - delay
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKa param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_delay_mode = 4 [ 0 - 4 ] => 1 (65535)
65535,
// [1] k_delay_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_delay_time = 0.0416666 [ 0 - 2 ] => 0.0208333 (1365)
1365,
// [3] k_delay_feedback = 49.3056 [ 0 - 100 ] => 0.493056 (32312)
32312,
// [4] k_delay_lowpass_cutoff = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [5] k_delay_highpass_cutoff = 0 [ 0 - 100 ] => 0 (0)
0
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 19 - delay2
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKa param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_delay_mode = 4 [ 0 - 4 ] => 1 (65535)
65535,
// [1] k_delay_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_delay_time = 0.1 [ 0 - 2 ] => 0.05 (3276)
3276,
// [3] k_delay_feedback = 68.9236 [ 0 - 100 ] => 0.689236 (45169)
45169,
// [4] k_delay_lowpass_cutoff = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [5] k_delay_highpass_cutoff = 0 [ 0 - 100 ] => 0 (0)
0
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 20 - crash_delay
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKa param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_delay_mode = 4 [ 0 - 4 ] => 1 (65535)
65535,
// [1] k_delay_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_delay_time = 0.2 [ 0 - 2 ] => 0.1 (6553)
6553,
// [3] k_delay_feedback = 85.7639 [ 0 - 100 ] => 0.857639 (56205)
56205,
// [4] k_delay_lowpass_cutoff = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [5] k_delay_highpass_cutoff = 0 [ 0 - 100 ] => 0 (0)
0
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 21 - plim_delay
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKa param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_delay_mode = 3 [ 0 - 4 ] => 0.75 (49151)
49151,
// [1] k_delay_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_delay_time = 0.2 [ 0 - 2 ] => 0.1 (6553)
6553,
// [3] k_delay_feedback = 45.3542 [ 0 - 100 ] => 0.453542 (29722)
29722,
// [4] k_delay_lowpass_cutoff = 60.2431 [ 0 - 100 ] => 0.602431 (39480)
39480,
// [5] k_delay_highpass_cutoff = 0 [ 0 - 100 ] => 0 (0)
0
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 22 - papukaija
//----------------------------------------------------------------------------

// Track 22 has automation envelope events for parameters: 100

{
// START_PLUG_STATE
// opKa param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_delay_mode = 4 [ 0 - 4 ] => 1 (65535)
65535,
// [1] k_delay_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [2] k_delay_time = 0.8 [ 0 - 2 ] => 0.4 (26214)
26214,
// [3] k_delay_feedback = 96.0069 [ 0 - 100 ] => 0.960069 (62918)
62918,
// [4] k_delay_lowpass_cutoff = 90.7986 [ 0 - 100 ] => 0.907986 (59504)
59504,
// [5] k_delay_highpass_cutoff = 2.08333 [ 0 - 100 ] => 0.0208333 (1365)
1365
// END_PLUG_STATE
},

};

static int32_t reverb_params[2][6]
{
//----------------------------------------------------------------------------
// Track 23 - reverb with predelay
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKu param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_reverb_mix = 50 [ 0 - 100 ] => 0.5 (32767)
32767,
// [1] k_reverb_predelay = 6.77083 [ 0 - 100 ] => 0.0677083 (4437)
4437,
// [2] k_reverb_bandwidth = 36.1111 [ 0 - 100 ] => 0.361111 (23665)
23665,
// [3] k_reverb_damping = 61.2848 [ 0 - 100 ] => 0.612848 (40162)
40162,
// [4] k_reverb_decay = 62.3264 [ 0 - 100 ] => 0.623264 (40845)
40845,
// [5] k_reverb_roomsize = 73.7847 [ 0 - 100 ] => 0.737847 (48354)
48354
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 24 - reverb without predelay
//----------------------------------------------------------------------------

{
// START_PLUG_STATE
// opKu param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_reverb_mix = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [1] k_reverb_predelay = 3.64583 [ 0 - 100 ] => 0.0364583 (2389)
2389,
// [2] k_reverb_bandwidth = 100 [ 0 - 100 ] => 1 (65535)
65535,
// [3] k_reverb_damping = 75.5208 [ 0 - 100 ] => 0.755208 (49492)
49492,
// [4] k_reverb_decay = 16.3194 [ 0 - 100 ] => 0.163194 (10694)
10694,
// [5] k_reverb_roomsize = 52.4306 [ 0 - 100 ] => 0.524306 (34360)
34360
// END_PLUG_STATE
},

};

static int32_t filter_params[2][3]
{
//----------------------------------------------------------------------------
// Track 25 - lisaa_bassoa
//----------------------------------------------------------------------------

// Track 25 has automation envelope events for parameters: 100

{
// START_PLUG_STATE
// opSr param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_filter_mode = 3 [ 0 - 6 ] => 0.5 (32767)
32767,
// [1] k_filter_cutoff = 48.4497 [ 0 - 22050 ] => 0.046875 (3071)
3071,
// [2] k_filter_resonance = 23.4375 [ 0 - 100 ] => 0.234375 (15359)
15359
// END_PLUG_STATE
},

//----------------------------------------------------------------------------
// Track 26 - seula
//----------------------------------------------------------------------------

// Track 26 has automation envelope events for parameters: 2, 0

{
// START_PLUG_STATE
// opSr param export
//     Format:
//     // [parameter ID] parameter name = non-normalized parameter value (displayed value in UI (optional)) [range min - range max] => normalized parameter value (written integer value)
//     integer parameter value,

// [0] k_filter_mode = 5 [ 0 - 6 ] => 0.833333 (54612)
54612,
// [1] k_filter_cutoff = 111.72 [ 0 - 22050 ] => 0.0711806 (4664)
4664,
// [2] k_filter_resonance = 27 [ 0 - 100 ] => 0.27 (17694)
17694
// END_PLUG_STATE
},

};

// END TRACK PARAMETER BLOCK

// START SONG DATA BLOCK
/*
song data structure format:
5 values per event
time(delta), eventnum, channel, note/controlnum, velocity/value
*/

static uint32_t g_song_data[] =
{
  // deltaTick: 0, absoluteTick: 0, eventType: Tempo, channel: 0, controlNum: 0, value: 15000,
  0, 6, 0, 0, 15000,
  // deltaTick: 0, absoluteTick: 0, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 10, controlNum: 43, value: 3932,
  0, 4, 10, 43, 3932,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 10, controlNum: 47, value: 33751,
  0, 4, 10, 47, 33751,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 10, controlNum: 49, value: 3277,
  0, 4, 10, 49, 3277,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 10, controlNum: 42, value: 5243,
  0, 4, 10, 42, 5243,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 11, controlNum: 47, value: 35717,
  0, 4, 11, 47, 35717,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 11, controlNum: 43, value: 3932,
  0, 4, 11, 43, 3932,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 11, controlNum: 42, value: 5243,
  0, 4, 11, 42, 5243,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 13, controlNum: 77, value: 0,
  0, 4, 13, 77, 0,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 14, controlNum: 73, value: 0,
  0, 4, 14, 73, 0,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 22, controlNum: 100, value: 0,
  0, 4, 22, 100, 0,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 25, controlNum: 100, value: 0,
  0, 4, 25, 100, 0,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 26, controlNum: 2, value: 17694,
  0, 4, 26, 2, 17694,
  // deltaTick: 0, absoluteTick: 0, eventType: NRPN, channel: 26, controlNum: 0, value: 56032,
  0, 4, 26, 0, 56032,
  // deltaTick: 240, absoluteTick: 240, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 240, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 480, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  60, 1, 10, 31, 62,
  // deltaTick: 180, absoluteTick: 660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 720, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 840, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 960, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 1200, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 1200, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 1380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 1440, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 1440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 1530, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 90, absoluteTick: 1620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  90, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 1680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 1860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 1920, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 2160, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 2160, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 2160, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 2160, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 2250, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 2280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 2340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 2400, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 180, absoluteTick: 2580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 2640, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 2640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 2640, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 2739, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 2761, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 2820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 2880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 3120, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 3120, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 3300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 3360, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  60, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 3540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 3600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 3780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 3840, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 4080, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 4080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 4080, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 4200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 4260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 4320, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  60, 1, 10, 31, 62,
  // deltaTick: 180, absoluteTick: 4500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 4560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 4560, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 4680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 4740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 4800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 5040, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 5040, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 5220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 5280, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 5280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 5370, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 90, absoluteTick: 5460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  90, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 5520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 5700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 5760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 6000, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 6000, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 6000, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 6000, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 6090, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 6120, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 6180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 6240, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 180, absoluteTick: 6420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 6480, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 6480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 6480, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 6579, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 6601, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 6660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 6720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 6960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 6960, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 7140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 7200, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  60, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 7200, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 7320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 7380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 7440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 7620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 7680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 7920, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 7920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 7920, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 8040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 8100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 8160, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  60, 1, 10, 31, 62,
  // deltaTick: 180, absoluteTick: 8340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 8400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 8400, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 8520, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 8580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 8640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 8880, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 8880, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 9060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 9120, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 9120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 9210, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 90, absoluteTick: 9300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  90, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 9360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 9540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 9600, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 9840, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 9840, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 9840, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 9840, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 9930, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 9960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 10020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 10080, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 180, absoluteTick: 10260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 10320, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 10320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 10320, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 10419, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 10441, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 10500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 10560, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 10800, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 10800, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 10980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 11040, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  60, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 11220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 11280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 11460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 11520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 11520, eventType: NRPN, channel: 14, controlNum: 73, value: 655,
  0, 4, 14, 73, 655,
  // deltaTick: 0, absoluteTick: 11520, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 1920}, targetValue: 33095,
  0, 8, 14, 491593, 33095,
  // deltaTick: 60, absoluteTick: 11580, eventType: NoteOn, channel: 14, note: 35, velocity: 113,
  60, 1, 14, 35, 113,
  // deltaTick: 180, absoluteTick: 11760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  180, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 11760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 11760, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 11880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 11940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 12000, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  60, 1, 10, 31, 62,
  // deltaTick: 180, absoluteTick: 12180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 12240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 12240, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 12360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 12420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 12480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 12720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 12720, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 12900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 12960, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 12960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 13050, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 90, absoluteTick: 13140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  90, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 13200, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  60, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 13320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 120, absoluteTick: 13440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  120, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 13440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 13440, eventType: NRPN, channel: 14, controlNum: 73, value: 0,
  0, 4, 14, 73, 0,
  // deltaTick: 180, absoluteTick: 13620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 13680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 13680, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 13680, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 13680, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 13770, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 13800, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 13860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 13920, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  60, 1, 10, 43, 127,
  // deltaTick: 180, absoluteTick: 14100, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  180, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 14160, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 14160, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 14160, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 14259, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 14281, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 14340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 14400, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 60, absoluteTick: 14460, eventType: NoteOff, channel: 14, note: 35, velocity: 0,
  60, 0, 14, 35, 0,
  // deltaTick: 180, absoluteTick: 14640, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  180, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 14640, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 14820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 14880, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  60, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 14880, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 15000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 15060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 15120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 15300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 15360, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 15360, eventType: NRPN, channel: 26, controlNum: 2, value: 16384,
  0, 4, 26, 2, 16384,
  // deltaTick: 0, absoluteTick: 15360, eventType: StartEnvelope, channel: 26, { controlNum: 2, envelopeLength: 13440}, targetValue: 4260,
  0, 8, 26, 3440642, 4260,
  // deltaTick: 240, absoluteTick: 15600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 15600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 15600, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 15720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 15780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 15840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 15840, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  0, 1, 10, 31, 62,
  // deltaTick: 120, absoluteTick: 15960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 16020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 16080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 16080, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 16200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 16260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 16320, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 16560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 16560, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 16740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 16800, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 16800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 16800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 16890, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 16920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 16980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 17040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 17220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 17280, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 17520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 17520, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 17520, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 17520, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 17610, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 17640, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 17700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 17760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 17760, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 17880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 17940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 18000, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 18000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 18000, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 18099, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 18121, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 18180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 18240, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 18480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 18480, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 18660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 18720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 18720, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 18840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 18900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 18960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 19140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 19200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 19440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 19440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 19440, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 19560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 19620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 19680, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 19680, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  0, 1, 10, 31, 62,
  // deltaTick: 120, absoluteTick: 19800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 19860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 19920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 19920, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 20040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 20100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 20160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 20400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 20400, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 20580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 20640, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 20640, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 20640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 20730, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 20760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 20820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 20880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 21060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 21120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 21120, eventType: NRPN, channel: 25, controlNum: 100, value: 0,
  0, 4, 25, 100, 0,
  // deltaTick: 0, absoluteTick: 21120, eventType: StartEnvelope, channel: 25, { controlNum: 100, envelopeLength: 9600}, targetValue: 38451,
  0, 8, 25, 2457700, 38451,
  // deltaTick: 240, absoluteTick: 21360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 21360, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 21360, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 21360, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 21450, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 21480, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 21540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 21600, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 21600, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 21720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 21780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 21840, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 21840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 21840, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 21939, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 21961, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 22020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 22080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 22320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 22320, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 22500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 22560, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 22560, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 22560, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 22680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 22680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 22740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 22800, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 22800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 22920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 22980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 23040, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 23280, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 23280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 23280, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 23400, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 23460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 23520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 23520, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  0, 1, 10, 31, 62,
  // deltaTick: 120, absoluteTick: 23640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 23700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 23760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 23760, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 23880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 23940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 24000, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 24240, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 24240, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 24420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 24480, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 24480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 24480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 24570, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 24600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 24660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 24720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 180, absoluteTick: 24900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 24960, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 25200, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 25200, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 25200, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 25200, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 25290, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 25320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 25380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 25440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 25440, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 25560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 25620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 25680, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 25680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 25680, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 25779, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 25801, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 25860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 25920, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 26160, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 26160, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 180, absoluteTick: 26340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 26400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 26400, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 26520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 26580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 26640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 26820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 26880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 27120, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 27120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 27120, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 27240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 27300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 27360, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 27360, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 27360, eventType: NoteOn, channel: 10, note: 31, velocity: 62,
  0, 1, 10, 31, 62,
  // deltaTick: 120, absoluteTick: 27480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 27540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 27600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 27600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 27600, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 27720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 27780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 27840, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 120, absoluteTick: 27960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 120, absoluteTick: 28080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  120, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 28080, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 28200, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 28260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 28320, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 28320, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 28320, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 28320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 28410, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 28440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 28500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 28560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 240, absoluteTick: 28800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  240, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 28800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 90, absoluteTick: 28890, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 28920, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 60, absoluteTick: 28980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 30, absoluteTick: 29010, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 29040, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 29040, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 29040, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 29040, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 29130, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 29130, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  0, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 29160, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  30, 0, 12, 31, 0,
  // deltaTick: 0, absoluteTick: 29160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 60, absoluteTick: 29220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 29280, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 29280, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 120, absoluteTick: 29400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 29400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 29460, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 29520, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 29520, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 29520, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 29619, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 29641, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 29700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 29760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 90, absoluteTick: 29850, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 29880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 90, absoluteTick: 29970, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 30000, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 30000, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 90, absoluteTick: 30090, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 30120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 60, absoluteTick: 30180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 30240, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 30240, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 30360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 30420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 30480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 30480, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 30480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 30480, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 30600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 30600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 30660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 30720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 30720, eventType: NRPN, channel: 26, controlNum: 0, value: 0,
  0, 4, 26, 0, 0,
  // deltaTick: 240, absoluteTick: 30960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  240, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 30960, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 31080, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 31080, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 31140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 31200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 31200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 31320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 31380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 31440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 31440, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 31560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 31620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 31680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 31680, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 31920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  240, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 32040, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 32100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 32160, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 32160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 32160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 32250, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 32280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 32340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 32400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 32520, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 32580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 32640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 32880, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  240, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 32880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 32880, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 32970, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 33000, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 33000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 33060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 33120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 33120, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 33240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 33300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 33360, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 33360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 33360, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 33459, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 33481, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 33540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 33600, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 33600, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 33840, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  240, 1, 10, 31, 67,
  // deltaTick: 120, absoluteTick: 33960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 34020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 34080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 34080, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 34200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 34260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 34320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 34440, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 34500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 34560, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 34800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  240, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 34800, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 34920, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 34920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 34980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 35040, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 35040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 35160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 35220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 35280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 35280, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 35400, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 35460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 35520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 35520, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 35760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  240, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 35880, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 35940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 36000, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 36000, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 36000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 36090, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 36120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 36180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 36240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 36360, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 36420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 36480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 36720, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  240, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 36720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 36720, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 36810, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 36840, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 36840, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 36900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 36960, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 36960, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 37080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 37140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 37200, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 37200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 37200, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 37299, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 37321, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 37380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 37440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 37440, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 37680, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  240, 1, 10, 31, 67,
  // deltaTick: 120, absoluteTick: 37800, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 37860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 37920, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 37920, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 37920, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 38040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 38040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 38100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 38160, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 38160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 38280, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 38280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 38340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 38400, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 38640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  240, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 38640, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 38760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 38760, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 38820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 38880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 38880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 39000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 39060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 39120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 39120, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 39240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 39300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 39360, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 39360, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 39600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  240, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 39720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 39780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 39840, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 39840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 39840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 39930, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 39960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 40020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 40080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 40200, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 40260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 40320, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 240, absoluteTick: 40560, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  240, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 40560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 40560, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 40650, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 40680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 40680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 40740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 40800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 40800, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 40920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 40980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 41040, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 41040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 41040, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 41139, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 41161, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 41220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 41280, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 41280, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 41520, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  240, 1, 10, 31, 67,
  // deltaTick: 120, absoluteTick: 41640, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 41700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 41760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 41760, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 41880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 41940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 42000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 42120, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 42180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 42240, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 42240, eventType: NRPN, channel: 14, controlNum: 73, value: 1966,
  0, 4, 14, 73, 1966,
  // deltaTick: 0, absoluteTick: 42240, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 1920}, targetValue: 33095,
  0, 8, 14, 491593, 33095,
  // deltaTick: 60, absoluteTick: 42300, eventType: NoteOn, channel: 14, note: 35, velocity: 113,
  60, 1, 14, 35, 113,
  // deltaTick: 180, absoluteTick: 42480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  180, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 42480, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 42600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 42600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 42660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 42720, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 42720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 42840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 42900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 42960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 42960, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 43080, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 43140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 43200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 43200, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 240, absoluteTick: 43440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  240, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 43560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 43620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 43680, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 43680, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 43680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 43770, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 43800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 43860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 43920, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  60, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 44040, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 44040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 120, absoluteTick: 44160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  120, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 44160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 44160, eventType: NRPN, channel: 14, controlNum: 73, value: 1311,
  0, 4, 14, 73, 1311,
  // deltaTick: 180, absoluteTick: 44340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 44400, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 44400, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 44400, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 44490, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 44520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 44520, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 44580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 44640, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 44640, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 120, absoluteTick: 44760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 44820, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 44880, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 44880, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 44880, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 44979, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 45001, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 45060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  59, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 45120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 45120, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 45120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 45180, eventType: NoteOff, channel: 14, note: 35, velocity: 0,
  60, 0, 14, 35, 0,
  // deltaTick: 120, absoluteTick: 45300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 45360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 45480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 45540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 45600, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 45600, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 45600, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 45720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 45720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 45780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 45840, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 45840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 45840, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 45960, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 45960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 45960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 46020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 46080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 46080, eventType: NoteOn, channel: 5, note: 80, velocity: 127,
  0, 1, 5, 80, 127,
  // deltaTick: 0, absoluteTick: 46080, eventType: NoteOn, channel: 6, note: 60, velocity: 5,
  0, 1, 6, 60, 5,
  // deltaTick: 0, absoluteTick: 46080, eventType: NoteOn, channel: 14, note: 91, velocity: 127,
  0, 1, 14, 91, 127,
  // deltaTick: 0, absoluteTick: 46080, eventType: NRPN, channel: 14, controlNum: 73, value: 1311,
  0, 4, 14, 73, 1311,
  // deltaTick: 0, absoluteTick: 46080, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 15360}, targetValue: 7026,
  0, 8, 14, 3932233, 7026,
  // deltaTick: 180, absoluteTick: 46260, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 46320, eventType: NoteOn, channel: 6, note: 60, velocity: 11,
  60, 1, 6, 60, 11,
  // deltaTick: 0, absoluteTick: 46320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 46320, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 46440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 46440, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 46440, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 46500, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 46500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 46560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 46560, eventType: NoteOn, channel: 6, note: 60, velocity: 12,
  0, 1, 6, 60, 12,
  // deltaTick: 0, absoluteTick: 46560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 46680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 46740, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 46740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 46800, eventType: NoteOn, channel: 6, note: 60, velocity: 18,
  60, 1, 6, 60, 18,
  // deltaTick: 0, absoluteTick: 46800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 46800, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 46920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 46980, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 46980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 47040, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 47040, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 47040, eventType: NoteOn, channel: 6, note: 60, velocity: 21,
  0, 1, 6, 60, 21,
  // deltaTick: 180, absoluteTick: 47220, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 47280, eventType: NoteOn, channel: 6, note: 60, velocity: 21,
  60, 1, 6, 60, 21,
  // deltaTick: 0, absoluteTick: 47280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 47400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 47460, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 47460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 47520, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 47520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 47520, eventType: NoteOn, channel: 6, note: 60, velocity: 24,
  0, 1, 6, 60, 24,
  // deltaTick: 0, absoluteTick: 47520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 47610, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 47640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 47700, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 47700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 47760, eventType: NoteOn, channel: 6, note: 60, velocity: 27,
  60, 1, 6, 60, 27,
  // deltaTick: 0, absoluteTick: 47760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 47880, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 47940, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 47940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 48000, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 48000, eventType: NoteOn, channel: 6, note: 60, velocity: 28,
  0, 1, 6, 60, 28,
  // deltaTick: 180, absoluteTick: 48180, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 48240, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 48240, eventType: NoteOn, channel: 6, note: 60, velocity: 30,
  0, 1, 6, 60, 30,
  // deltaTick: 0, absoluteTick: 48240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 48240, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 48330, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 48360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 48360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 48420, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 48420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 48480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 48480, eventType: NoteOn, channel: 6, note: 60, velocity: 33,
  0, 1, 6, 60, 33,
  // deltaTick: 0, absoluteTick: 48480, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 48600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 48660, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 48660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 48720, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 48720, eventType: NoteOn, channel: 6, note: 60, velocity: 37,
  0, 1, 6, 60, 37,
  // deltaTick: 0, absoluteTick: 48720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 48720, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 0, absoluteTick: 48720, eventType: NRPN, channel: 13, controlNum: 77, value: 0,
  0, 4, 13, 77, 0,
  // deltaTick: 60, absoluteTick: 48780, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 39, absoluteTick: 48819, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  39, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 48841, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 48900, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  59, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 48900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 48960, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 48960, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 48960, eventType: NoteOn, channel: 6, note: 60, velocity: 40,
  0, 1, 6, 60, 40,
  // deltaTick: 180, absoluteTick: 49140, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 49200, eventType: NoteOn, channel: 6, note: 60, velocity: 41,
  60, 1, 6, 60, 41,
  // deltaTick: 0, absoluteTick: 49200, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 120, absoluteTick: 49320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 49380, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 49380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 49440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 49440, eventType: NoteOn, channel: 6, note: 60, velocity: 46,
  0, 1, 6, 60, 46,
  // deltaTick: 0, absoluteTick: 49440, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 49560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 49620, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 49620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 49680, eventType: NoteOn, channel: 6, note: 60, velocity: 46,
  60, 1, 6, 60, 46,
  // deltaTick: 0, absoluteTick: 49680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 49800, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 49860, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 49860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 49920, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 49920, eventType: NoteOn, channel: 6, note: 60, velocity: 50,
  0, 1, 6, 60, 50,
  // deltaTick: 180, absoluteTick: 50100, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 50160, eventType: NoteOn, channel: 6, note: 60, velocity: 50,
  60, 1, 6, 60, 50,
  // deltaTick: 0, absoluteTick: 50160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 50160, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 50280, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 50280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 50340, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 50340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 50400, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 50400, eventType: NoteOn, channel: 6, note: 60, velocity: 51,
  0, 1, 6, 60, 51,
  // deltaTick: 0, absoluteTick: 50400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 50520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 50580, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 50580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 50580, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 50640, eventType: NoteOn, channel: 6, note: 60, velocity: 51,
  60, 1, 6, 60, 51,
  // deltaTick: 0, absoluteTick: 50640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 50640, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 50760, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 50820, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 50820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 50880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 50880, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 50880, eventType: NoteOn, channel: 6, note: 60, velocity: 51,
  0, 1, 6, 60, 51,
  // deltaTick: 180, absoluteTick: 51060, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 51120, eventType: NoteOn, channel: 6, note: 60, velocity: 51,
  60, 1, 6, 60, 51,
  // deltaTick: 0, absoluteTick: 51120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 51240, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 51300, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 51300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 51360, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 51360, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 51360, eventType: NoteOn, channel: 6, note: 60, velocity: 56,
  0, 1, 6, 60, 56,
  // deltaTick: 0, absoluteTick: 51360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 51450, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 51480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 51540, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 51540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 51600, eventType: NoteOn, channel: 6, note: 60, velocity: 60,
  60, 1, 6, 60, 60,
  // deltaTick: 120, absoluteTick: 51720, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 51720, eventType: NRPN, channel: 13, controlNum: 77, value: 4769,
  0, 4, 13, 77, 4769,
  // deltaTick: 60, absoluteTick: 51780, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 51840, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 51840, eventType: NoteOn, channel: 6, note: 60, velocity: 64,
  0, 1, 6, 60, 64,
  // deltaTick: 0, absoluteTick: 51840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 51840, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 52020, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 52020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 52080, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 52080, eventType: NoteOn, channel: 6, note: 60, velocity: 64,
  0, 1, 6, 60, 64,
  // deltaTick: 0, absoluteTick: 52080, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 52080, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 52170, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 52200, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 52200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 52260, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 52260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 52320, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 52320, eventType: NoteOn, channel: 6, note: 60, velocity: 64,
  0, 1, 6, 60, 64,
  // deltaTick: 0, absoluteTick: 52320, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 120, absoluteTick: 52440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 52500, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 52500, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 52560, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 52560, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 52560, eventType: NoteOn, channel: 6, note: 60, velocity: 64,
  0, 1, 6, 60, 64,
  // deltaTick: 0, absoluteTick: 52560, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 52659, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 52681, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 52740, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  59, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 52740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 52800, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 52800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 52800, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 52800, eventType: NoteOn, channel: 6, note: 60, velocity: 64,
  0, 1, 6, 60, 64,
  // deltaTick: 0, absoluteTick: 52800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 52980, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 52980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 53040, eventType: NoteOn, channel: 6, note: 60, velocity: 69,
  60, 1, 6, 60, 69,
  // deltaTick: 0, absoluteTick: 53040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 53160, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 53220, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 53220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 53280, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 53280, eventType: NoteOn, channel: 6, note: 60, velocity: 71,
  0, 1, 6, 60, 71,
  // deltaTick: 0, absoluteTick: 53280, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 53280, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 53400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 53400, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 53460, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 53460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 53520, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 53520, eventType: NoteOn, channel: 6, note: 60, velocity: 76,
  0, 1, 6, 60, 76,
  // deltaTick: 0, absoluteTick: 53520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 53640, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 53640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 53700, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 53700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 53760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 53760, eventType: NoteOn, channel: 6, note: 60, velocity: 77,
  0, 1, 6, 60, 77,
  // deltaTick: 180, absoluteTick: 53940, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 54000, eventType: NoteOn, channel: 6, note: 60, velocity: 79,
  60, 1, 6, 60, 79,
  // deltaTick: 0, absoluteTick: 54000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 54000, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 54120, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 54120, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 0, absoluteTick: 54120, eventType: NRPN, channel: 13, controlNum: 77, value: 9175,
  0, 4, 13, 77, 9175,
  // deltaTick: 60, absoluteTick: 54180, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 54180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 54240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 54240, eventType: NoteOn, channel: 6, note: 60, velocity: 80,
  0, 1, 6, 60, 80,
  // deltaTick: 0, absoluteTick: 54240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 54240, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 54360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 54420, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 54420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 54480, eventType: NoteOn, channel: 6, note: 60, velocity: 81,
  60, 1, 6, 60, 81,
  // deltaTick: 0, absoluteTick: 54480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 54480, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 54600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 54660, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 54660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 54720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 54720, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 54720, eventType: NoteOn, channel: 6, note: 60, velocity: 83,
  0, 1, 6, 60, 83,
  // deltaTick: 180, absoluteTick: 54900, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 54960, eventType: NoteOn, channel: 6, note: 60, velocity: 84,
  60, 1, 6, 60, 84,
  // deltaTick: 0, absoluteTick: 54960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 55080, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 55140, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 55140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 55200, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 55200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 55200, eventType: NoteOn, channel: 6, note: 60, velocity: 84,
  0, 1, 6, 60, 84,
  // deltaTick: 0, absoluteTick: 55200, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 55290, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 55320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 55380, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 55380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 55440, eventType: NoteOn, channel: 6, note: 60, velocity: 84,
  60, 1, 6, 60, 84,
  // deltaTick: 0, absoluteTick: 55440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 55560, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 55620, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 55620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 55680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 55680, eventType: NoteOn, channel: 6, note: 60, velocity: 86,
  0, 1, 6, 60, 86,
  // deltaTick: 180, absoluteTick: 55860, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 55920, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 55920, eventType: NoteOn, channel: 6, note: 60, velocity: 86,
  0, 1, 6, 60, 86,
  // deltaTick: 0, absoluteTick: 55920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 55920, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 56010, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 56040, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 56040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 56100, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 56100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 56160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 56160, eventType: NoteOn, channel: 6, note: 60, velocity: 89,
  0, 1, 6, 60, 89,
  // deltaTick: 0, absoluteTick: 56160, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 120, absoluteTick: 56280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 56340, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 56340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 56400, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 56400, eventType: NoteOn, channel: 6, note: 60, velocity: 93,
  0, 1, 6, 60, 93,
  // deltaTick: 0, absoluteTick: 56400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 56400, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 56499, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 56521, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 56580, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  59, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 56580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 56640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 56640, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 56640, eventType: NoteOn, channel: 6, note: 60, velocity: 96,
  0, 1, 6, 60, 96,
  // deltaTick: 180, absoluteTick: 56820, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 56880, eventType: NoteOn, channel: 6, note: 60, velocity: 97,
  60, 1, 6, 60, 97,
  // deltaTick: 0, absoluteTick: 56880, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 120, absoluteTick: 57000, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 57060, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 57060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 57120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 57120, eventType: NoteOn, channel: 6, note: 60, velocity: 99,
  0, 1, 6, 60, 99,
  // deltaTick: 0, absoluteTick: 57120, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 57240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 57300, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 57300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 57360, eventType: NoteOn, channel: 6, note: 60, velocity: 102,
  60, 1, 6, 60, 102,
  // deltaTick: 0, absoluteTick: 57360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 57480, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 57540, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 57540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 57600, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 57600, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 57600, eventType: NoteOn, channel: 6, note: 60, velocity: 102,
  0, 1, 6, 60, 102,
  // deltaTick: 180, absoluteTick: 57780, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 57840, eventType: NoteOn, channel: 6, note: 60, velocity: 104,
  60, 1, 6, 60, 104,
  // deltaTick: 0, absoluteTick: 57840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 57840, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 57960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 57960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 58020, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 58020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 58080, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 58080, eventType: NoteOn, channel: 6, note: 60, velocity: 106,
  0, 1, 6, 60, 106,
  // deltaTick: 0, absoluteTick: 58080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 58200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 58260, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 58260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 58320, eventType: NoteOn, channel: 6, note: 60, velocity: 107,
  60, 1, 6, 60, 107,
  // deltaTick: 0, absoluteTick: 58320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 58320, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 58440, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  120, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 58500, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 58500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 58560, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 58560, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 58560, eventType: NoteOn, channel: 6, note: 60, velocity: 110,
  0, 1, 6, 60, 110,
  // deltaTick: 180, absoluteTick: 58740, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 58800, eventType: NoteOn, channel: 6, note: 60, velocity: 110,
  60, 1, 6, 60, 110,
  // deltaTick: 0, absoluteTick: 58800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 58920, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 58980, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 58980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 59040, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 59040, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 59040, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 59040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 90, absoluteTick: 59130, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 59160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  30, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 59220, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 59220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 59280, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  60, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 59280, eventType: NRPN, channel: 13, controlNum: 77, value: 11942,
  0, 4, 13, 77, 11942,
  // deltaTick: 120, absoluteTick: 59400, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 59400, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 59460, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 59520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 59520, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 59520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 59700, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 59700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 59760, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  60, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 59760, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 59760, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 59760, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 90, absoluteTick: 59850, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  90, 0, 1, 54, 0,
  // deltaTick: 30, absoluteTick: 59880, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 59880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 59940, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 59940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 60000, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 60000, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 60000, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 120, absoluteTick: 60120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 60180, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 60180, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 60240, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 60240, eventType: NoteOn, channel: 1, note: 54, velocity: 127,
  0, 1, 1, 54, 127,
  // deltaTick: 0, absoluteTick: 60240, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 60240, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 99, absoluteTick: 60339, eventType: NoteOff, channel: 1, note: 54, velocity: 0,
  99, 0, 1, 54, 0,
  // deltaTick: 22, absoluteTick: 60361, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  22, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 60420, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  59, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 60420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 60480, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 60480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 60480, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 60480, eventType: NoteOn, channel: 6, note: 60, velocity: 112,
  0, 1, 6, 60, 112,
  // deltaTick: 0, absoluteTick: 60480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 60660, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  180, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 60660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 60720, eventType: NoteOn, channel: 6, note: 60, velocity: 115,
  60, 1, 6, 60, 115,
  // deltaTick: 0, absoluteTick: 60720, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 120, absoluteTick: 60840, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 60900, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 60900, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 60, absoluteTick: 60960, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 60960, eventType: NoteOn, channel: 6, note: 60, velocity: 116,
  0, 1, 6, 60, 116,
  // deltaTick: 0, absoluteTick: 60960, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 120, absoluteTick: 61080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 61140, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 61140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 61200, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 61200, eventType: NoteOn, channel: 6, note: 60, velocity: 116,
  0, 1, 6, 60, 116,
  // deltaTick: 0, absoluteTick: 61200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 61200, eventType: NoteOn, channel: 12, note: 31, velocity: 47,
  0, 1, 12, 31, 47,
  // deltaTick: 120, absoluteTick: 61320, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 61320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 61320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 0, absoluteTick: 61320, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  0, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 61380, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 61380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 61440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 61440, eventType: NoteOn, channel: 9, note: 84, velocity: 127,
  0, 1, 9, 84, 127,
  // deltaTick: 0, absoluteTick: 61440, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 61440, eventType: NoteOn, channel: 13, note: 57, velocity: 122,
  0, 1, 13, 57, 122,
  // deltaTick: 0, absoluteTick: 61440, eventType: NRPN, channel: 10, controlNum: 42, value: 6554,
  0, 4, 10, 42, 6554,
  // deltaTick: 0, absoluteTick: 61440, eventType: NRPN, channel: 10, controlNum: 43, value: 9503,
  0, 4, 10, 43, 9503,
  // deltaTick: 0, absoluteTick: 61440, eventType: NRPN, channel: 10, controlNum: 47, value: 34734,
  0, 4, 10, 47, 34734,
  // deltaTick: 0, absoluteTick: 61440, eventType: NRPN, channel: 11, controlNum: 42, value: 6554,
  0, 4, 11, 42, 6554,
  // deltaTick: 0, absoluteTick: 61440, eventType: NRPN, channel: 11, controlNum: 43, value: 9503,
  0, 4, 11, 43, 9503,
  // deltaTick: 0, absoluteTick: 61440, eventType: AllNotesOff, channel: 1, controlNum: 0, value: 0,
  0, 7, 1, 0, 0,
  // deltaTick: 0, absoluteTick: 61440, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 30720}, targetValue: 13435,
  0, 8, 10, 7864363, 13435,
  // deltaTick: 0, absoluteTick: 61440, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 20160}, targetValue: 18022,
  0, 8, 10, 5161002, 18022,
  // deltaTick: 0, absoluteTick: 61440, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 30720}, targetValue: 13435,
  0, 8, 11, 7864363, 13435,
  // deltaTick: 0, absoluteTick: 61440, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 20160}, targetValue: 18022,
  0, 8, 11, 5161002, 18022,
  // deltaTick: 0, absoluteTick: 61440, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 61440}, targetValue: 7026,
  0, 8, 14, 15728713, 7026,
  // deltaTick: 60, absoluteTick: 61500, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 120, absoluteTick: 61620, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  120, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 61680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 61680, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 61860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 61860, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 61920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 61920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 62040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 62100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 62160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 62160, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 62220, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 62280, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 62340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 62340, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 62400, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 62400, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 62640, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 62640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 62640, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 62820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 62820, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 62880, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 62880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 62880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 63000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 63000, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 63060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 63120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 63120, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 63240, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 63240, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 63300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 63300, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 63360, eventType: NoteOff, channel: 9, note: 84, velocity: 0,
  60, 0, 9, 84, 0,
  // deltaTick: 0, absoluteTick: 63360, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 63480, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 63600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 63780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 63840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 63840, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 63840, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 63960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 64020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 64020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 64080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 64080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 64080, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 64200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 64260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 64260, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 64260, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 64320, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 64320, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 64500, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 64560, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 64560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 64560, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 64560, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 64680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 64740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 64740, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 64800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 64800, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 64860, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 64920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 64980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 64980, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 65040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 65160, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  120, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 65220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 65280, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  60, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 65280, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 65460, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 65520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 65520, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 65700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 65700, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 65760, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 65760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 65880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 65940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 66000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 66000, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 66060, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 66120, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 66180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 66180, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 66240, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 66240, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 66480, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 66480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 66480, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 66660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 66660, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 66720, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 66720, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 66720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 66840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 66840, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 66900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 66960, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 67080, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 67080, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 60, absoluteTick: 67140, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 67200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 67200, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 67320, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 67380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 67440, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 67620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 67680, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 67680, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 67680, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 67800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 67860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 67860, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 67920, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 67920, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 67920, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 68040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 68100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 68100, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 68100, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 68160, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 68160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 68160, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 68340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 68340, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 68400, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 68400, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 68400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 68400, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 68520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 68580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 68580, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 68640, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 68640, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 68700, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 68760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 68820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 68820, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 68880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 69000, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 69060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 69120, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  60, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 69120, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 69300, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 69360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 69360, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 69540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 69540, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 69600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 69600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 69720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 69780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 69840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 69840, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 69900, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 69960, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 70020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 70020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 70080, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 70080, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 70320, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 70320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 70320, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 70500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 70500, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 70560, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 70560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 70560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 70680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 70680, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 70740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 70800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 70800, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 70920, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 70920, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 70980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 70980, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 71040, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  60, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 71160, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 71280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 71460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 71520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 71520, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 71520, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 71640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 71700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 71700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 71760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 71760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 71760, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 71880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 71940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 71940, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 71940, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 72000, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 72000, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 72180, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 72240, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 72240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 72240, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 72240, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 72360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 72420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 72420, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 72480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 72480, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 72540, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 72600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 72660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 72660, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 72720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 72840, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 72900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 72960, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  60, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 72960, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 73140, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 73200, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 73200, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 73380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 73380, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 73440, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 73440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 73560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 73620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 73680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 73680, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 73740, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 73860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 73860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 73860, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 73860, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 73920, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 73920, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 74160, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 74160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 74160, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 74340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 74340, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 74400, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 74400, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 74400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 74520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 74520, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 74580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 74640, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 74760, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 74760, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 74820, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 74880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 74880, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 74880, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 120, absoluteTick: 75000, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 75060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 75120, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 75300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 75360, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 75360, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 75360, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 75480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 75540, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 75540, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 75600, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 75600, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 75600, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 75720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 75780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 75780, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 75780, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 75840, eventType: NoteOn, channel: 5, note: 80, velocity: 127,
  60, 1, 5, 80, 127,
  // deltaTick: 0, absoluteTick: 75840, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 75840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 75840, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 76020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 76020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 76080, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 76080, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 76080, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 76080, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 76200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 76200, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 60, absoluteTick: 76260, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  60, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 76260, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 76320, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 76320, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 76380, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 76440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 76500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 76500, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 76560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 76680, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  120, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 76740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 76800, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 76800, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 76800, eventType: NoteOn, channel: 13, note: 57, velocity: 122,
  0, 1, 13, 57, 122,
  // deltaTick: 0, absoluteTick: 76800, eventType: NRPN, channel: 10, controlNum: 49, value: 4587,
  0, 4, 10, 49, 4587,
  // deltaTick: 180, absoluteTick: 76980, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 77040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 77040, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 77220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 77220, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 77280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 77280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 77400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 77460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 77520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 77520, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 77580, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 77640, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 77700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 77700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 77760, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 77760, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 77760, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 78000, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 78000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 78000, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 78180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 78180, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 78240, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 78240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 78240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 78360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 78360, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 78420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 78480, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 78480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 78480, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 78600, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 78600, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 78660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 78660, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 78720, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  60, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 78840, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 78840, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 78960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 79140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 79200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 79200, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 79200, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 79200, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 79320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 79380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 79380, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 79440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 79440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 79440, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 79560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 79560, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 79620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 79620, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 79620, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 79680, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 79680, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 79860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 79920, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 79920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 79920, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 79920, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 80040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 80100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 80100, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 80160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 80160, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 80220, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 80280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 80340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 80340, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 80400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 80520, eventType: NRPN, channel: 13, controlNum: 77, value: 5024,
  120, 4, 13, 77, 5024,
  // deltaTick: 60, absoluteTick: 80580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 80640, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 80640, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 80640, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 80820, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 80880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 80880, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 81060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 81060, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 81120, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 81120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 81240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 81300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 81360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 81360, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 81420, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 81480, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 81540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 81540, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 81600, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 81600, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 81600, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 81600, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 10560}, targetValue: 12238,
  0, 8, 10, 2703402, 12238,
  // deltaTick: 0, absoluteTick: 81600, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 10560}, targetValue: 12238,
  0, 8, 11, 2703402, 12238,
  // deltaTick: 240, absoluteTick: 81840, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 81840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 81840, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 82020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 82020, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 82080, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 82080, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 82080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 82200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 82200, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 82260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 82320, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 82320, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 82440, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 82440, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 60, absoluteTick: 82500, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 82560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 82560, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 82680, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 82680, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 82740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 82800, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 82980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 83040, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 83040, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 83040, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 83040, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 83160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 83220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 83220, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 83280, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 83280, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 83280, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 83400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 83400, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 83460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 83460, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 83460, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 83520, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 83520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 83520, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 83700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 83700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 83760, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 83760, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 83760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 83760, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 83880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 83940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 83940, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 84000, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 84000, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 84060, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 84120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 84180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 84180, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 84240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 84360, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 84420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 84480, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 84480, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 84480, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 84660, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 84720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 84720, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 84900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 84900, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 84960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 84960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 85080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 85140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 85200, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 85200, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 85260, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 85320, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 85380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 85380, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 85440, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 85440, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 85440, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 85680, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 85680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 85680, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 85860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 85860, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 85920, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 85920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 85920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 86040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 86040, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 86100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 86160, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 86160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 86160, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 86280, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 86280, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 86340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 86340, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 86400, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  60, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 86520, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 86520, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 86640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 86820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 86880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 86880, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 86880, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 86880, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 87000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 87060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 87060, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 87120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 87120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 87120, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 87240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 87240, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 87300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 87300, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 87300, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 87360, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 87360, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 87540, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 87600, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 87600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 87600, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 87600, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 87720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 87780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 87780, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 87840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 87840, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 87900, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 87960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 88020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 88020, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 88080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 88200, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 88260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 88320, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 88320, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 88320, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 88500, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 88560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 88560, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 88740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 88740, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 88800, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 88800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 88920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 88980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 89040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 89040, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 89100, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 89220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 89220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 89220, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 89220, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 89280, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 89280, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 89280, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 89520, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 89520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 89520, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 89700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 89700, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 89760, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 89760, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 89760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 89880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 89880, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 89940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 90000, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 90000, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 90120, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 90120, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 90180, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 90240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 90240, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 90240, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 120, absoluteTick: 90360, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 90360, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 90420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 90480, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 90660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 90720, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 90720, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 90720, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 90720, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 90840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 90900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 90900, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 90960, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 90960, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 90960, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 91080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 91080, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 91140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 91140, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 91140, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 91200, eventType: NoteOn, channel: 5, note: 80, velocity: 127,
  60, 1, 5, 80, 127,
  // deltaTick: 0, absoluteTick: 91200, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 91200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 91200, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 91380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 91380, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 91440, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 91440, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 91440, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 91440, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 91560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 91560, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 60, absoluteTick: 91620, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  60, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 91620, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 91680, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 91680, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 91740, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 91800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 91860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 91860, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 91920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 92040, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  120, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 92100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 92160, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 92160, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 92160, eventType: NoteOn, channel: 13, note: 57, velocity: 122,
  0, 1, 13, 57, 122,
  // deltaTick: 0, absoluteTick: 92160, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 23040}, targetValue: 25231,
  0, 8, 10, 5898283, 25231,
  // deltaTick: 0, absoluteTick: 92160, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 26880}, targetValue: 20316,
  0, 8, 10, 6881322, 20316,
  // deltaTick: 0, absoluteTick: 92160, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 27840}, targetValue: 33751,
  0, 8, 11, 7127082, 33751,
  // deltaTick: 0, absoluteTick: 92160, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 23040}, targetValue: 29818,
  0, 8, 11, 5898283, 29818,
  // deltaTick: 180, absoluteTick: 92340, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 92400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 92400, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 92580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 92580, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 92640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 92640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 92760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 92820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 92880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 92880, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 92940, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 93000, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 93060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 93060, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 93120, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 93120, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 93120, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 93360, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 93360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 93360, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 93540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 93540, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 93600, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 93600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 93600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 93720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 93720, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 93780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 93840, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 93840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 93840, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 93960, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 93960, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 94020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 94020, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 94080, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  60, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 94200, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 94200, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 94320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 94500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 94560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 94560, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 94560, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 94560, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 94680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 94740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 94740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 94800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 94800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 94800, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 94920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 94920, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 94980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 94980, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 94980, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 95040, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 95040, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 95220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 95280, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 95280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 95280, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 95280, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 95400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 95460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 95460, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 95520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 95520, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 95580, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 95640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 95700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 95700, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 95760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 95880, eventType: NRPN, channel: 13, controlNum: 77, value: 5024,
  120, 4, 13, 77, 5024,
  // deltaTick: 60, absoluteTick: 95940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 96000, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 96000, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 96000, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 96180, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 96240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 96240, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 96420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 96420, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 96480, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 96480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 96600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 96660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 96720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 96720, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 96780, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 96840, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 96900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 96900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 96960, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 96960, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 96960, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 97200, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 97200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 97200, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 97380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 97380, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 97440, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 97440, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 97440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 97560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 97560, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 97620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 97680, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 97680, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 97800, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 97800, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 60, absoluteTick: 97860, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 97920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 97920, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 98040, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 98040, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 98100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 98160, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 98340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 98400, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 98400, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 98400, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 98400, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 98520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 98580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 98580, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 98640, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 98640, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 98640, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 98760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 98760, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 98820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 98820, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 98820, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 98880, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 98880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 98880, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 99060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 99060, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 99120, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 99120, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 99120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 99120, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 99240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 99300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 99300, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 99360, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 99360, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 99420, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 99480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 99540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 99540, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 99600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 99720, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 99780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 99840, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 99840, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 99840, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 100020, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 100080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 100080, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 100260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 100260, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 100320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 100320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 100440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 100500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 100560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 100560, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 100620, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 100680, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 100740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 100740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 100800, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 100800, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 100800, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 101040, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 101040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 101040, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 101220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 101220, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 101280, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 101280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 101280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 101400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 101400, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 101460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 101520, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 101520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 101520, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 101640, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 101640, eventType: NRPN, channel: 13, controlNum: 77, value: 12124,
  0, 4, 13, 77, 12124,
  // deltaTick: 60, absoluteTick: 101700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 101700, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 101760, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  60, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 101880, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 101880, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 102000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 102180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 102240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 102240, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 102240, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 102240, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 102360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 102420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 102420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 102480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 102480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 102480, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 102600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 102600, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 102660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 102660, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 102660, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 102720, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  60, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 102720, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 102900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 102960, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 102960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 102960, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 102960, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 103080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 103140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 103140, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 103200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 103200, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 103260, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 103320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 103380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 103380, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 103440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 103560, eventType: NRPN, channel: 13, controlNum: 77, value: 4660,
  120, 4, 13, 77, 4660,
  // deltaTick: 60, absoluteTick: 103620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 103680, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 103680, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 103680, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 103860, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 103920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 103920, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 104100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 104100, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 104160, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 104160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 104280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 104340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 104400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 104400, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 104460, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 104580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 104580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 104580, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 104580, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 104640, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 104640, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 104640, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 104880, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  240, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 104880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 104880, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 105060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 105060, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 105120, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 105120, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 105120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 105240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 105240, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 105300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 105360, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 105360, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 105480, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 105480, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 105540, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  60, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 105600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 105600, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 105600, eventType: NRPN, channel: 13, controlNum: 77, value: 12261,
  0, 4, 13, 77, 12261,
  // deltaTick: 120, absoluteTick: 105720, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 105720, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 105780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 105840, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 106020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 106080, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 106080, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 106080, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 106080, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 106200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 106260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 106260, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 106320, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 106320, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 106320, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 106440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 106440, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 106500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 106500, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 0, absoluteTick: 106500, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 106560, eventType: NoteOn, channel: 5, note: 80, velocity: 127,
  60, 1, 5, 80, 127,
  // deltaTick: 0, absoluteTick: 106560, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 106560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 106560, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 106740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 106740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 106800, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  60, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 106800, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 106800, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 106800, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 106920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 106920, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 60, absoluteTick: 106980, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  60, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 106980, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 107040, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 107040, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 107100, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 107160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 107220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 107220, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 107280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 107400, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  120, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 107460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 107520, eventType: NoteOn, channel: 0, note: 81, velocity: 54,
  60, 1, 0, 81, 54,
  // deltaTick: 0, absoluteTick: 107520, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 107520, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 107520, eventType: NoteOn, channel: 13, note: 57, velocity: 122,
  0, 1, 13, 57, 122,
  // deltaTick: 180, absoluteTick: 107700, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 107760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 107760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 107760, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 107940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 107940, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 108000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 108000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 108120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 108180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 108240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 108240, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 108300, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 108420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 108420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 108480, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 108480, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 108480, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 108480, eventType: NoteOn, channel: 0, note: 81, velocity: 58,
  0, 1, 0, 81, 58,
  // deltaTick: 0, absoluteTick: 108480, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 108720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 108720, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 108720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 108720, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 108900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 108900, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 108960, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 108960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 108960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 109080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 109080, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 109140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 109200, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 109200, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 109200, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 109320, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 109320, eventType: NRPN, channel: 13, controlNum: 77, value: 12306,
  0, 4, 13, 77, 12306,
  // deltaTick: 60, absoluteTick: 109380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 109440, eventType: NoteOn, channel: 0, note: 81, velocity: 64,
  60, 1, 0, 81, 64,
  // deltaTick: 0, absoluteTick: 109440, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 109440, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 109560, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 109560, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 109680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 109680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 109860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 109920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 109920, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 109920, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 109920, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 110040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 110100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 110100, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 110160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 110160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 110160, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 110280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 110280, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 110340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 110340, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 110400, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 110400, eventType: NoteOn, channel: 0, note: 81, velocity: 76,
  0, 1, 0, 81, 76,
  // deltaTick: 0, absoluteTick: 110400, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 110400, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 110580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 110640, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 110640, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 110640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 110640, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 110640, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 110760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 110820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 110820, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 110880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 110880, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 110940, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 111000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 111060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 111060, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 111120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 111240, eventType: NRPN, channel: 13, controlNum: 77, value: 5206,
  120, 4, 13, 77, 5206,
  // deltaTick: 60, absoluteTick: 111300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 111360, eventType: NoteOn, channel: 0, note: 81, velocity: 81,
  60, 1, 0, 81, 81,
  // deltaTick: 0, absoluteTick: 111360, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 111360, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 111360, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 111540, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 111600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 111600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 111600, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 111780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 111780, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 111840, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 111840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 111960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 112020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 112080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 112080, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 112140, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 112260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 112260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 112320, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 112320, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 112320, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 112320, eventType: NoteOn, channel: 0, note: 81, velocity: 84,
  0, 1, 0, 81, 84,
  // deltaTick: 0, absoluteTick: 112320, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 240, absoluteTick: 112560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 112560, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 112560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 112560, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 112740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 112740, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 112800, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 112800, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 112800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 112920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 112920, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 112980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 113040, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  60, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 113040, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 113160, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 113160, eventType: NRPN, channel: 13, controlNum: 77, value: 12443,
  0, 4, 13, 77, 12443,
  // deltaTick: 120, absoluteTick: 113280, eventType: NoteOn, channel: 0, note: 81, velocity: 94,
  120, 1, 0, 81, 94,
  // deltaTick: 0, absoluteTick: 113280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 113280, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 113280, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 113400, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 113400, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 113460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 113520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 113520, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 180, absoluteTick: 113700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 113760, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 113760, eventType: NoteOn, channel: 8, note: 36, velocity: 94,
  0, 1, 8, 36, 94,
  // deltaTick: 0, absoluteTick: 113760, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 113760, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 113880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 113940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 113940, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 114000, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 114000, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 114000, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 114120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 114120, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 60, absoluteTick: 114180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 114180, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 114240, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 114240, eventType: NoteOn, channel: 0, note: 81, velocity: 92,
  0, 1, 0, 81, 92,
  // deltaTick: 0, absoluteTick: 114240, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 114240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 114240, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 114420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 114420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 114480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 114480, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 114480, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 114480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 114480, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 114600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 114660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 114660, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 114720, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  60, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 114720, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 114780, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 114840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 114900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 114900, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 114960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 115080, eventType: NRPN, channel: 13, controlNum: 77, value: 4842,
  120, 4, 13, 77, 4842,
  // deltaTick: 60, absoluteTick: 115140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 115200, eventType: NoteOn, channel: 0, note: 81, velocity: 115,
  60, 1, 0, 81, 115,
  // deltaTick: 0, absoluteTick: 115200, eventType: NoteOn, channel: 8, note: 36, velocity: 60,
  0, 1, 8, 36, 60,
  // deltaTick: 0, absoluteTick: 115200, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 115200, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 115200, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 7680}, targetValue: 14745,
  0, 8, 10, 1966123, 14745,
  // deltaTick: 0, absoluteTick: 115200, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 5760}, targetValue: 21627,
  0, 8, 11, 1474603, 21627,
  // deltaTick: 180, absoluteTick: 115380, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 115440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 115440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 115440, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 115620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 115620, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 115680, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 115680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 115680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 115800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 115860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 115920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 115920, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 115980, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 116100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 116100, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 116160, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 116160, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 116160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 116160, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 116160, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 240, absoluteTick: 116400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 116400, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 116400, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 116400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 116400, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 0, absoluteTick: 116400, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 180, absoluteTick: 116580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 116580, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 116640, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 116640, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 116640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 116640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 116640, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 116760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 116760, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 116820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 116880, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 116880, eventType: NoteOn, channel: 8, note: 36, velocity: 58,
  0, 1, 8, 36, 58,
  // deltaTick: 0, absoluteTick: 116880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 116880, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 0, absoluteTick: 116880, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 117000, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 117060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 117120, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 117120, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 117120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 117120, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 117120, eventType: NoteOn, channel: 13, note: 57, velocity: 117,
  0, 1, 13, 57, 117,
  // deltaTick: 0, absoluteTick: 117120, eventType: NRPN, channel: 13, controlNum: 77, value: 13580,
  0, 4, 13, 77, 13580,
  // deltaTick: 120, absoluteTick: 117240, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 117360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 117360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 117540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 117600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 117600, eventType: NoteOn, channel: 8, note: 36, velocity: 55,
  0, 1, 8, 36, 55,
  // deltaTick: 0, absoluteTick: 117600, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 117600, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 117720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 117780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 117780, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 117840, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 117840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 117840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 117840, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 117960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 118020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 118020, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 118080, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 118080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 118080, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 118080, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 0, absoluteTick: 118080, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 118080, eventType: NRPN, channel: 13, controlNum: 77, value: 18707,
  0, 4, 13, 77, 18707,
  // deltaTick: 180, absoluteTick: 118260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 118320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 118320, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 118320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 118320, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 118320, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 118440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 118500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 118500, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 118560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 118560, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 118620, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 118680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 118740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 118740, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 118800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 118980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 119040, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 119040, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 119040, eventType: NoteOn, channel: 8, note: 36, velocity: 60,
  0, 1, 8, 36, 60,
  // deltaTick: 0, absoluteTick: 119040, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 119040, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 119040, eventType: NRPN, channel: 10, controlNum: 49, value: 4587,
  0, 4, 10, 49, 4587,
  // deltaTick: 0, absoluteTick: 119040, eventType: NRPN, channel: 13, controlNum: 77, value: 21663,
  0, 4, 13, 77, 21663,
  // deltaTick: 0, absoluteTick: 119040, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 3840}, targetValue: 13107,
  0, 8, 10, 983082, 13107,
  // deltaTick: 0, absoluteTick: 119040, eventType: StartEnvelope, channel: 10, { controlNum: 49, envelopeLength: 3840}, targetValue: 3277,
  0, 8, 10, 983089, 3277,
  // deltaTick: 180, absoluteTick: 119220, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  180, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 119280, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 119280, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 119280, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 180, absoluteTick: 119460, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  180, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 119460, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 119520, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  60, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 119520, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 119520, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 119520, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 120, absoluteTick: 119640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 119700, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 119760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 119760, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 119760, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 119820, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  60, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 119940, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  120, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 119940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 30, absoluteTick: 119970, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 120000, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  30, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 120000, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 120000, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 120000, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 120000, eventType: NRPN, channel: 13, controlNum: 77, value: 24931,
  0, 4, 13, 77, 24931,
  // deltaTick: 0, absoluteTick: 120000, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 2880}, targetValue: 14848,
  0, 8, 11, 737322, 14848,
  // deltaTick: 240, absoluteTick: 120240, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  240, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 120240, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  0, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 120240, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 0, absoluteTick: 120240, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 180, absoluteTick: 120420, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  180, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 120420, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 120480, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 120480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 120480, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 120480, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 120, absoluteTick: 120600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 120600, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 120660, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 120720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 120720, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 120720, eventType: NoteOn, channel: 8, note: 36, velocity: 58,
  0, 1, 8, 36, 58,
  // deltaTick: 0, absoluteTick: 120720, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 120840, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 120, absoluteTick: 120960, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  120, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 120960, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 120960, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 120960, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 120960, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 120960, eventType: NRPN, channel: 13, controlNum: 77, value: 28462,
  0, 4, 13, 77, 28462,
  // deltaTick: 0, absoluteTick: 120960, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 1920}, targetValue: 32112,
  0, 8, 11, 491563, 32112,
  // deltaTick: 120, absoluteTick: 121080, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  120, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 121140, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 121200, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 121200, eventType: NoteOn, channel: 10, note: 36, velocity: 63,
  0, 1, 10, 36, 63,
  // deltaTick: 180, absoluteTick: 121380, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  180, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 121440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 121440, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 121440, eventType: NoteOn, channel: 8, note: 36, velocity: 55,
  0, 1, 8, 36, 55,
  // deltaTick: 0, absoluteTick: 121440, eventType: NoteOn, channel: 10, note: 48, velocity: 127,
  0, 1, 10, 48, 127,
  // deltaTick: 0, absoluteTick: 121440, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 121560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 121620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 121620, eventType: NoteOn, channel: 10, note: 36, velocity: 64,
  0, 1, 10, 36, 64,
  // deltaTick: 60, absoluteTick: 121680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 121680, eventType: NoteOff, channel: 8, note: 36, velocity: 0,
  0, 0, 8, 36, 0,
  // deltaTick: 0, absoluteTick: 121680, eventType: NoteOff, channel: 10, note: 48, velocity: 0,
  0, 0, 10, 48, 0,
  // deltaTick: 0, absoluteTick: 121680, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 121680, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 120, absoluteTick: 121800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 121860, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 121860, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 121920, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 121920, eventType: NoteOn, channel: 7, note: 24, velocity: 127,
  0, 1, 7, 24, 127,
  // deltaTick: 0, absoluteTick: 121920, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 121920, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 180, absoluteTick: 122100, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  180, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 122100, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 30, absoluteTick: 122130, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 122160, eventType: NoteOff, channel: 7, note: 24, velocity: 0,
  30, 0, 7, 24, 0,
  // deltaTick: 0, absoluteTick: 122160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 122160, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 122160, eventType: NoteOn, channel: 10, note: 60, velocity: 127,
  0, 1, 10, 60, 127,
  // deltaTick: 0, absoluteTick: 122160, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 120, absoluteTick: 122280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 122340, eventType: NoteOff, channel: 10, note: 60, velocity: 0,
  60, 0, 10, 60, 0,
  // deltaTick: 0, absoluteTick: 122340, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 30, absoluteTick: 122370, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 122400, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  30, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 122400, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 122400, eventType: NoteOn, channel: 3, note: 60, velocity: 126,
  0, 1, 3, 60, 126,
  // deltaTick: 0, absoluteTick: 122400, eventType: NoteOn, channel: 10, note: 36, velocity: 66,
  0, 1, 10, 36, 66,
  // deltaTick: 60, absoluteTick: 122460, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 122520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 122580, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 122580, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 30, absoluteTick: 122610, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 30, absoluteTick: 122640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  30, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 122640, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 180, absoluteTick: 122820, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  180, 0, 10, 36, 0,
  // deltaTick: 30, absoluteTick: 122850, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  30, 0, 0, 81, 0,
  // deltaTick: 6, absoluteTick: 122856, eventType: NoteOn, channel: 9, note: 84, velocity: 127,
  6, 1, 9, 84, 127,
  // deltaTick: 0, absoluteTick: 122856, eventType: AllNotesOff, channel: 7, controlNum: 0, value: 0,
  0, 7, 7, 0, 0,
  // deltaTick: 0, absoluteTick: 122856, eventType: AllNotesOff, channel: 8, controlNum: 0, value: 0,
  0, 7, 8, 0, 0,
  // deltaTick: 24, absoluteTick: 122880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 122880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 122880, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 122880, eventType: NRPN, channel: 10, controlNum: 47, value: 38993,
  0, 4, 10, 47, 38993,
  // deltaTick: 0, absoluteTick: 122880, eventType: NRPN, channel: 11, controlNum: 47, value: 38993,
  0, 4, 11, 47, 38993,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 13440}, targetValue: 9503,
  0, 8, 10, 3440682, 9503,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 30720}, targetValue: 24576,
  0, 8, 10, 7864363, 24576,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 13440}, targetValue: 54382,
  0, 8, 10, 3440687, 54382,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 7680}, targetValue: 50684,
  0, 8, 11, 1966127, 50684,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 13440}, targetValue: 37355,
  0, 8, 11, 3440682, 37355,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 24960}, targetValue: 19661,
  0, 8, 11, 6389803, 19661,
  // deltaTick: 0, absoluteTick: 122880, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 30720}, targetValue: 0,
  0, 8, 14, 7864393, 0,
  // deltaTick: 24, absoluteTick: 122904, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 96, absoluteTick: 123000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 123060, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 123120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 123120, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 123120, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 123144, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 36, absoluteTick: 123180, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 123233, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 123240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 123300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 123300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 123300, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 123360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 123360, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 123360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 123384, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 96, absoluteTick: 123480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 123540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 123600, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 123600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 123600, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 123600, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 123624, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 123624, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 123660, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 123660, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 123720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 123780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 123780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 123780, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 123840, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 123840, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 123840, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 123840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 123864, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 123960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 124080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 124080, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 24, absoluteTick: 124104, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 124140, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 124193, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 124260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 124260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 124260, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 124320, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 124320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 124320, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 124320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 24, absoluteTick: 124344, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 124440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 124440, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 124500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 124560, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 124560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 124560, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 24, absoluteTick: 124584, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 124620, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 124680, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 124680, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 124740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 124740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 36, absoluteTick: 124776, eventType: NoteOff, channel: 9, note: 84, velocity: 0,
  36, 0, 9, 84, 0,
  // deltaTick: 24, absoluteTick: 124800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 124800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 124800, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 24, absoluteTick: 124824, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 124920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 124920, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 125040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 125040, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 125100, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 125153, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 125160, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 125220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 125220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 125280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 125280, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 125280, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 125280, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 125400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 125460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 125460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 125520, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 125520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 125520, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 125520, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 125580, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 125641, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 125700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 125700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 125700, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 125760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 125760, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 125760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 125760, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 125880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 125940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 126000, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 126000, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 126060, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 126113, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 126180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 126180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 126180, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 126240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 126240, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 126240, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 126300, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 126360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 126420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 126420, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 126480, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 126480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 126540, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 126600, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 126600, eventType: NRPN, channel: 13, controlNum: 77, value: 5206,
  0, 4, 13, 77, 5206,
  // deltaTick: 60, absoluteTick: 126660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 126660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 126720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 126720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 126720, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 126720, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 126840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 126900, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 126960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 126960, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 126960, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 127020, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 127073, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 127080, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 127140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 127140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 127140, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 127200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 127200, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 127200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 127320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 127380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 127440, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 127440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 127440, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 127440, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 127500, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 127500, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 127560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 127620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 127620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 127620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 127680, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 127680, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 127680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 127680, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 127680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 127800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 127920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 127920, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 127980, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 128033, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 128100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 128100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 128100, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 128160, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 128160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 128160, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 128160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 128280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 128280, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 128340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 128400, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 128400, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 128460, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 128520, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 128520, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 128580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 128640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 128640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 128640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 128640, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 128760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 128760, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 128820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 128880, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 128880, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 128940, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 128993, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 129000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 129060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 129060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 129120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 129120, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 129120, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 129120, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 129240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 129300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 129300, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 129360, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 129360, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 129360, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 129360, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 129420, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 129481, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 129540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 129540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 129540, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 129600, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 129600, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 129600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 129600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 129600, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 129720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 129780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 129780, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 129840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 129840, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 129900, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 129953, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 130020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 130020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 130020, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 130080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 130080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 130080, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 130080, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 130080, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 130140, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 130200, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 130200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 130200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 130260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 130260, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 130320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 130320, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  0, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 130320, eventType: NoteOn, channel: 2, note: 38, velocity: 103,
  0, 1, 2, 38, 103,
  // deltaTick: 0, absoluteTick: 130320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 130380, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 130500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 130500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 130560, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 130560, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 130560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 130560, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 130560, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 7680}, targetValue: 45535,
  0, 8, 11, 1966127, 45535,
  // deltaTick: 120, absoluteTick: 130680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 130740, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 130800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 130800, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 130800, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 130860, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 130913, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 130920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 130980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 130980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 130980, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 131040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 131040, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 131040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 131160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 131220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 131280, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 131280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 131280, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 131280, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 131340, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 131340, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 131400, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 131460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 131460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 131460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 131520, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 131520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 131520, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 131520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 131640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 131760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 131760, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 131820, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 131873, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 131940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 131940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 131940, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 132000, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 132000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 132000, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 132000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 132120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 132120, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 132180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 132240, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 132240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 132240, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 132300, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 132360, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 132360, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 132420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 132420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 132480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 132480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 132480, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 132600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 132600, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 132720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 132720, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 132780, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 132833, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 132840, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 132900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 132900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 132960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 132960, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 132960, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 132960, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 133080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 133140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 133140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 133200, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 133200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 133200, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 133200, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 133260, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 133321, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 133380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 133380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 133380, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 133440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 133440, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 133440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 133440, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 133560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 133620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 133680, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 133680, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 133740, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 133793, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 133860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 133860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 133860, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 133920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 133920, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 133920, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 133980, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 134040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 134100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 134100, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 134160, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 134160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 134220, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 134280, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 134280, eventType: NRPN, channel: 13, controlNum: 77, value: 12306,
  0, 4, 13, 77, 12306,
  // deltaTick: 60, absoluteTick: 134340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 134340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 53, absoluteTick: 134393, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 134400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 134400, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 134400, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 134520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 134580, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 134640, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  60, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 134640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 134640, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 134640, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 134700, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 134753, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 134760, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 134820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 134820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 134820, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 134880, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 134880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 134880, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 134880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 135000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 135060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 135120, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 135120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 135120, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 135120, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 135180, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 135180, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 135240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 135300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 135300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 135300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 135353, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 135360, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  7, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 135360, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 135360, eventType: NoteOn, channel: 2, note: 38, velocity: 107,
  0, 1, 2, 38, 107,
  // deltaTick: 0, absoluteTick: 135360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 135480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 135600, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 135600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 135600, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 135660, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 135713, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 135780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 135780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 135780, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 135840, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 135840, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 135840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 135840, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 135840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 135960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 135960, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 136020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 136080, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 136080, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  0, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 136080, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 136140, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 136200, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 136260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 136313, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 136320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 136320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 136320, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 136320, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 11520}, targetValue: 34986,
  0, 8, 10, 2949167, 34986,
  // deltaTick: 0, absoluteTick: 136320, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 11520}, targetValue: 7074,
  0, 8, 10, 2949162, 7074,
  // deltaTick: 0, absoluteTick: 136320, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 11520}, targetValue: 7074,
  0, 8, 11, 2949162, 7074,
  // deltaTick: 120, absoluteTick: 136440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 136440, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 136500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 136560, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 136560, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 136620, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 136673, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 136680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 136740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 136740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 136800, eventType: NoteOn, channel: 2, note: 38, velocity: 112,
  60, 1, 2, 38, 112,
  // deltaTick: 0, absoluteTick: 136800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 136800, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 136800, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 136800, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 136800, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 136920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 136980, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 136980, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 137040, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 137040, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  0, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 137040, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 137040, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 137040, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 137040, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 137100, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 137161, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 137220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 137220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 137220, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 53, absoluteTick: 137273, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 137280, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  7, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 137280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 137280, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 137280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 137280, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 137400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 137460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 137460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 137520, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 137520, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 137520, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 137520, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 137520, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 137580, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 137633, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 137700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 137700, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 137700, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 53, absoluteTick: 137753, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 137760, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  7, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 137760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 137760, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 137760, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 137760, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 137820, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 137880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 137880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 137940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 137940, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 138000, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 138000, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 138000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 138060, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 53, absoluteTick: 138113, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 138180, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  67, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 138180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 138180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 138240, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 138240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 138240, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 138240, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 138240, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 3840}, targetValue: 34078,
  0, 8, 11, 983087, 34078,
  // deltaTick: 120, absoluteTick: 138360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 138420, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 138480, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 138480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 138480, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 138480, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 138540, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 138593, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 138600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 138660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 138660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 138660, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 138720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 138720, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 138720, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 138720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 138840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 138900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 138960, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 138960, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 138960, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 138960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 138960, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 138960, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 139020, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 139020, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 139080, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 139140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 139140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 139140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 139200, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 139200, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 139200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 139200, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 139200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 139320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 139440, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  120, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 139440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 139440, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 139500, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 139560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 139620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 139620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 139620, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 139680, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 139680, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 139680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 139680, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 139680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 139800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 139800, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 139860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 139920, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 139920, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 139920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 139920, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 139980, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 140040, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 140040, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 140100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 140100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 140160, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 140160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 140160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 140160, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 140280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 140280, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 140400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 140400, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 140460, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 140520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 140520, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 140580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 140580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 140640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 140640, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 140640, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 140640, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 140760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 140820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 140820, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 140880, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 140880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 140880, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 140880, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 140940, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 141001, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 141060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 141060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 141060, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 141120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 141120, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 141120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 141120, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 141240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 141300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 141360, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 141360, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 141420, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 141480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 141540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 141540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 141540, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 141600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 141600, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 141600, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 141660, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 141720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 141780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 141780, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 141840, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 141840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 141900, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 141960, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 141960, eventType: NRPN, channel: 13, controlNum: 77, value: 5388,
  0, 4, 13, 77, 5388,
  // deltaTick: 60, absoluteTick: 142020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 142020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 53, absoluteTick: 142073, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 142080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 142080, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 142080, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 142080, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 5760}, targetValue: 42850,
  0, 8, 11, 1474607, 42850,
  // deltaTick: 120, absoluteTick: 142200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 142260, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 142320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 142320, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 142320, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 142380, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 142433, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 142440, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 142500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 142500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 142500, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 142560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 142560, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 142560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 142680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 142740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 142800, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 142800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 142800, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 142800, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 142860, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 142860, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 142920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 142980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 142980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 142980, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 143033, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 143040, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  7, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 143040, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 143040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 143064, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 143160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 143280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 143280, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 143340, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 143393, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 143460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 143460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 143460, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 143520, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 143520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 143520, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 143520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 143640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 143640, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 143700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 143760, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 143760, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 143820, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 143880, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 24, absoluteTick: 143904, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 143940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 143993, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 144000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 144000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 144000, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 144120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 144120, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 144180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 144240, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 144240, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 144300, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 144353, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 144360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 144420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 144420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 144480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 144480, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 144480, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 144480, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 144600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 144660, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 144660, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 144720, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 144720, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 144720, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 144720, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 144780, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 144841, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 144900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 144900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 144900, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 53, absoluteTick: 144953, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 144960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 144960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 144960, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 24, absoluteTick: 144984, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 145080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 145140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 145140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 145200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 145200, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 145260, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 145313, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 145380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 145380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 145380, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 53, absoluteTick: 145433, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 145440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 145440, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 145440, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 145440, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 145500, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 145560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 145560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 24, absoluteTick: 145584, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 145620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  36, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 145620, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 145680, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 145680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 145704, eventType: NoteOn, channel: 2, note: 38, velocity: 103,
  24, 1, 2, 38, 103,
  // deltaTick: 36, absoluteTick: 145740, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 53, absoluteTick: 145793, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 145860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 145860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 53, absoluteTick: 145913, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 145920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 145920, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 24, absoluteTick: 145944, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 146040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 146100, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 146160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 146160, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 146160, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 146220, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 46, absoluteTick: 146266, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  46, 0, 0, 81, 0,
  // deltaTick: 14, absoluteTick: 146280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  14, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 146340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 146340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 146340, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 146400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 146400, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 146400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 146520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 146580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 146640, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 146640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 146640, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 146640, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 146700, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 146700, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 146760, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 146820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 146820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 146820, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 146873, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 146880, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  7, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 146880, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 146880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 147000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 147120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 147120, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 147180, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 46, absoluteTick: 147226, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  46, 0, 0, 81, 0,
  // deltaTick: 74, absoluteTick: 147300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  74, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 147300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 147300, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 147360, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 147360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 147360, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 147360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 147480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 147480, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 147540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 147600, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 147600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 147600, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 147660, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 147720, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 147720, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 147780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 147780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 53, absoluteTick: 147833, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 147840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 147840, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 147840, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 17280}, targetValue: 22483,
  0, 8, 10, 4423722, 22483,
  // deltaTick: 0, absoluteTick: 147840, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 17280}, targetValue: 51703,
  0, 8, 10, 4423727, 51703,
  // deltaTick: 0, absoluteTick: 147840, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 17280}, targetValue: 22483,
  0, 8, 11, 4423722, 22483,
  // deltaTick: 0, absoluteTick: 147840, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 11520}, targetValue: 51703,
  0, 8, 11, 2949167, 51703,
  // deltaTick: 0, absoluteTick: 147840, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 9600}, targetValue: 38338,
  0, 8, 11, 2457643, 38338,
  // deltaTick: 120, absoluteTick: 147960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 147960, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 148080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 148080, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 148140, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 46, absoluteTick: 148186, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  46, 0, 0, 81, 0,
  // deltaTick: 14, absoluteTick: 148200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  14, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 148260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 148260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 148320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 148320, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 148320, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 148320, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 148440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 148500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 148500, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 148560, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 148560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 148560, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 148560, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 148620, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 148681, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 148740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 148740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 148740, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 53, absoluteTick: 148793, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 148800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 148800, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 24, absoluteTick: 148824, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 148920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 148980, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 149040, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 149040, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 149100, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 46, absoluteTick: 149146, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  46, 0, 0, 81, 0,
  // deltaTick: 74, absoluteTick: 149220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  74, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 149220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 149220, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 149280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 149280, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 149280, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 149340, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 149400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 149460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 149460, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 149520, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 149520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 149580, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 149640, eventType: NRPN, channel: 13, controlNum: 77, value: 12488,
  60, 4, 13, 77, 12488,
  // deltaTick: 24, absoluteTick: 149664, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 149700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 149700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 53, absoluteTick: 149753, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 7, absoluteTick: 149760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  7, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 149760, eventType: NoteOn, channel: 11, note: 34, velocity: 67,
  0, 1, 11, 34, 67,
  // deltaTick: 0, absoluteTick: 149760, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 149880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 149940, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  60, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 150000, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  60, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 150000, eventType: NoteOn, channel: 11, note: 34, velocity: 127,
  0, 1, 11, 34, 127,
  // deltaTick: 0, absoluteTick: 150000, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 150024, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 36, absoluteTick: 150060, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 46, absoluteTick: 150106, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  46, 0, 0, 81, 0,
  // deltaTick: 14, absoluteTick: 150120, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  14, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 150180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 150180, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 150180, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 150240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 150240, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 150240, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 24, absoluteTick: 150264, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 150360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 150420, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 150480, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 150480, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 150480, eventType: NoteOn, channel: 11, note: 44, velocity: 127,
  0, 1, 11, 44, 127,
  // deltaTick: 0, absoluteTick: 150480, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 150540, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 150540, eventType: NoteOn, channel: 11, note: 57, velocity: 67,
  0, 1, 11, 57, 67,
  // deltaTick: 60, absoluteTick: 150600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 150660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 150660, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 150660, eventType: NoteOff, channel: 11, note: 44, velocity: 0,
  0, 0, 11, 44, 0,
  // deltaTick: 60, absoluteTick: 150720, eventType: NoteOff, channel: 11, note: 57, velocity: 0,
  60, 0, 11, 57, 0,
  // deltaTick: 0, absoluteTick: 150720, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 150720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 150720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 150744, eventType: NoteOn, channel: 2, note: 38, velocity: 107,
  24, 1, 2, 38, 107,
  // deltaTick: 96, absoluteTick: 150840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 150960, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  120, 1, 10, 34, 127,
  // deltaTick: 0, absoluteTick: 150960, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 24, absoluteTick: 150984, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 151020, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 151073, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 151140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 151140, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 151140, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 151200, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 151200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 151200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 151200, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 151200, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 24, absoluteTick: 151224, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 151320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 151320, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 151380, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 151440, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 151440, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 151440, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 24, absoluteTick: 151464, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 151500, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 53, absoluteTick: 151553, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 151560, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 151620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 151620, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 151680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 151680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 151680, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 151680, eventType: NoteOn, channel: 11, note: 52, velocity: 66,
  0, 1, 11, 52, 66,
  // deltaTick: 120, absoluteTick: 151800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 151800, eventType: NoteOff, channel: 11, note: 52, velocity: 0,
  0, 0, 11, 52, 0,
  // deltaTick: 60, absoluteTick: 151860, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 151920, eventType: NoteOn, channel: 10, note: 36, velocity: 63,
  60, 1, 10, 36, 63,
  // deltaTick: 0, absoluteTick: 151920, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 151980, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 152033, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 152040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 152100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 152100, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 36, absoluteTick: 152136, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  36, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 152160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 152160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 152160, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 152160, eventType: NoteOn, channel: 10, note: 48, velocity: 127,
  0, 1, 10, 48, 127,
  // deltaTick: 0, absoluteTick: 152160, eventType: NoteOn, channel: 11, note: 36, velocity: 127,
  0, 1, 11, 36, 127,
  // deltaTick: 120, absoluteTick: 152280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 152340, eventType: NoteOff, channel: 11, note: 36, velocity: 0,
  60, 0, 11, 36, 0,
  // deltaTick: 0, absoluteTick: 152340, eventType: NoteOn, channel: 10, note: 36, velocity: 64,
  0, 1, 10, 36, 64,
  // deltaTick: 36, absoluteTick: 152376, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 24, absoluteTick: 152400, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  24, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 152400, eventType: NoteOff, channel: 10, note: 48, velocity: 0,
  0, 0, 10, 48, 0,
  // deltaTick: 0, absoluteTick: 152400, eventType: NoteOn, channel: 11, note: 48, velocity: 67,
  0, 1, 11, 48, 67,
  // deltaTick: 0, absoluteTick: 152400, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 152460, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 53, absoluteTick: 152513, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 8, absoluteTick: 152521, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  8, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 152580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 152580, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 152580, eventType: NoteOff, channel: 11, note: 48, velocity: 0,
  0, 0, 11, 48, 0,
  // deltaTick: 36, absoluteTick: 152616, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  36, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 152640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 152640, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 152640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 152640, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 152640, eventType: NoteOn, channel: 11, note: 42, velocity: 68,
  0, 1, 11, 42, 68,
  // deltaTick: 120, absoluteTick: 152760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 152820, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 152820, eventType: NoteOff, channel: 11, note: 42, velocity: 0,
  0, 0, 11, 42, 0,
  // deltaTick: 36, absoluteTick: 152856, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 152856, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 152880, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  24, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 152880, eventType: NoteOn, channel: 10, note: 60, velocity: 127,
  0, 1, 10, 60, 127,
  // deltaTick: 0, absoluteTick: 152880, eventType: NoteOn, channel: 11, note: 52, velocity: 65,
  0, 1, 11, 52, 65,
  // deltaTick: 60, absoluteTick: 152940, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 30, absoluteTick: 152970, eventType: NoteOn, channel: 0, note: 81, velocity: 81,
  30, 1, 0, 81, 81,
  // deltaTick: 90, absoluteTick: 153060, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 153060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 153060, eventType: NoteOff, channel: 10, note: 60, velocity: 0,
  0, 0, 10, 60, 0,
  // deltaTick: 0, absoluteTick: 153060, eventType: NoteOn, channel: 11, note: 36, velocity: 64,
  0, 1, 11, 36, 64,
  // deltaTick: 36, absoluteTick: 153096, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 24, absoluteTick: 153120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 153120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 153120, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 153120, eventType: NoteOn, channel: 10, note: 36, velocity: 66,
  0, 1, 10, 36, 66,
  // deltaTick: 0, absoluteTick: 153120, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 153180, eventType: NoteOff, channel: 11, note: 52, velocity: 0,
  60, 0, 11, 52, 0,
  // deltaTick: 60, absoluteTick: 153240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 153240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 153300, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 153300, eventType: NoteOff, channel: 11, note: 36, velocity: 0,
  0, 0, 11, 36, 0,
  // deltaTick: 60, absoluteTick: 153360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 153360, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  0, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 153360, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 153360, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 60, absoluteTick: 153420, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 30, absoluteTick: 153450, eventType: NoteOn, channel: 0, note: 81, velocity: 74,
  30, 1, 0, 81, 74,
  // deltaTick: 90, absoluteTick: 153540, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  90, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 153540, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  0, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 153540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 153540, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 153540, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 36, absoluteTick: 153576, eventType: NoteOn, channel: 9, note: 84, velocity: 127,
  36, 1, 9, 84, 127,
  // deltaTick: 24, absoluteTick: 153600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  24, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 153600, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 153600, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 153600, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 13440}, targetValue: 39391,
  0, 8, 10, 3440683, 39391,
  // deltaTick: 7, absoluteTick: 153607, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 153720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 153780, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 153840, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 153840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 153840, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 153840, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 153900, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 153960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 153960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 154020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 154020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 154020, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 154080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 154080, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 154080, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 154080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 154200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 154260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 154320, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 154320, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  0, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 154320, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 154320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 154320, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 154320, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 154380, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 154380, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 154440, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 154500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 154500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 154500, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 154560, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 154560, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  0, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 154560, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 154560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 154567, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 154680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 154800, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  120, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 154800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 154800, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 154860, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 154920, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 154980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 154980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 154980, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 155040, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  60, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 155040, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 155040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 155040, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 155040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 155160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 155160, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 155220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 155280, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 155280, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 0, absoluteTick: 155280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 155280, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 155340, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 155400, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 155400, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 155460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 155460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 36, absoluteTick: 155496, eventType: NoteOff, channel: 9, note: 84, velocity: 0,
  36, 0, 9, 84, 0,
  // deltaTick: 24, absoluteTick: 155520, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 155520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 155520, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 155527, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 155640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 155640, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 155760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 155760, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 155820, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 155880, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 155880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 155940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 155940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 156000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 156000, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 156000, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 156000, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 156120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 156180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 156180, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 156240, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 156240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 156240, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 156240, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 156300, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 156361, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 156420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 156420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 156420, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 156480, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  60, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 156480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 156480, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 156487, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 156600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 156660, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 156720, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 156720, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 156780, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 156840, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 156900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 156900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 156900, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 156960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 156960, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 156960, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 157020, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 157080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 157140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 157140, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 157200, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 157200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 157260, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 157320, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 157320, eventType: NRPN, channel: 13, controlNum: 77, value: 5570,
  0, 4, 13, 77, 5570,
  // deltaTick: 60, absoluteTick: 157380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 157380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 157440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 157440, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 157440, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 157440, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 9600}, targetValue: 30801,
  0, 8, 11, 2457643, 30801,
  // deltaTick: 7, absoluteTick: 157447, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 157560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 157620, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 157680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 157680, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 157680, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 157740, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 157800, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 157800, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 157860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 157860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 157860, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 157920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 157920, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 157920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 158040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 158100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 158160, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 158160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 158160, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 158160, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 158220, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 158220, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 158280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 158340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 158340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 158340, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 158400, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 158400, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 158400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 158407, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 158424, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 158520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 158640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 158640, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 158700, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 158760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 158820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 158820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 158820, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 158880, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 158880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 158880, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 158880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 159000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 159000, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 159060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 159120, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 159120, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 159180, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 159240, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 24, absoluteTick: 159264, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 159300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 159360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 159360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 159360, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 159360, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 17280}, targetValue: 42254,
  0, 8, 11, 4423727, 42254,
  // deltaTick: 7, absoluteTick: 159367, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 159480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 159480, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 159540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 159600, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 159600, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 159660, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 159720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 159720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 159780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 159780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 159840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 159840, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 159840, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 159840, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 159960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 160020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 160020, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 160080, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 160080, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 160080, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 160080, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 160140, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 160201, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 160260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 160260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 160260, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 160320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 160320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 160320, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 160327, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 160344, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 160440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 160500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 160500, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 160560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 160560, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 160620, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 160680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 160740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 160740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 160740, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 160800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 160800, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 160800, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 160800, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 160807, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 53, absoluteTick: 160860, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  53, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 160920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 160920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 24, absoluteTick: 160944, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 160980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  36, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 160980, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 161040, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 161040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 161047, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 17, absoluteTick: 161064, eventType: NoteOn, channel: 2, note: 38, velocity: 103,
  17, 1, 2, 38, 103,
  // deltaTick: 36, absoluteTick: 161100, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 161220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 161220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 161280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 161280, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 161287, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 161304, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  17, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 161400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 161460, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 161520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 161520, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 161520, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 161580, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 161640, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 161640, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 161700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 161700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 161700, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 161760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 161760, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 161760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 161880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 161940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 162000, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 162000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 162000, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 162000, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 162060, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 162060, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 162120, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 162180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 162180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 162180, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 162240, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 162240, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 162240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 162247, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 162360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 162480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 162480, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 162540, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 162600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 162660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 162660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 162660, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 162720, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 162720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 162720, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 162720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 162840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 162840, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 162900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 162960, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 162960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 162960, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 163020, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 163080, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 163080, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 163140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 163140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 163200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 163200, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 163207, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 163320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 163320, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 163440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 163440, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 163500, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 163560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 163560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 163620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 163620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 163680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 163680, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 163680, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 163680, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 163800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 163860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 163860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 163920, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 163920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 163920, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 163920, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 163980, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 164041, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 164100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 164100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 164100, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 164160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 164160, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 164167, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 164184, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 164280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 164340, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 164400, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 164400, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 164460, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 164520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 164580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 164580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 164580, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 164640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 164640, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 164640, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 164700, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 164760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 164820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 164820, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 164880, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 164880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 164940, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 165000, eventType: NRPN, channel: 13, controlNum: 77, value: 12852,
  60, 4, 13, 77, 12852,
  // deltaTick: 24, absoluteTick: 165024, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 165060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 165060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 165120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 165120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 165120, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 165120, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 165120, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 15360}, targetValue: 57982,
  0, 8, 10, 3932207, 57982,
  // deltaTick: 0, absoluteTick: 165120, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 15360}, targetValue: 5243,
  0, 8, 10, 3932202, 5243,
  // deltaTick: 0, absoluteTick: 165120, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 15360}, targetValue: 5243,
  0, 8, 11, 3932202, 5243,
  // deltaTick: 120, absoluteTick: 165240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 165300, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 165360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 165360, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 165360, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 165384, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 36, absoluteTick: 165420, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 165480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 165480, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 165540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 165540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 165540, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 165600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 165600, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 165600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 165624, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 165720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 165780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 165840, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 165840, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 165840, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 165840, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 165900, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 165900, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 165960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 166020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 166020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 166020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 166080, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 166080, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 166080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 166080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 166104, eventType: NoteOn, channel: 2, note: 38, velocity: 107,
  24, 1, 2, 38, 107,
  // deltaTick: 96, absoluteTick: 166200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 166320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 166320, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 24, absoluteTick: 166344, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 166380, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 166440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 166500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 166500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 166500, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 166560, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 166560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 166560, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 166560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 24, absoluteTick: 166584, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 166680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 166680, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 166740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 166800, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 166800, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 24, absoluteTick: 166824, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 166860, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 166920, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 166980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 167040, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 167040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 167040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 167040, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 167040, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 17280}, targetValue: 21299,
  0, 8, 10, 4423723, 21299,
  // deltaTick: 0, absoluteTick: 167040, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 13440}, targetValue: 43914,
  0, 8, 11, 3440683, 43914,
  // deltaTick: 120, absoluteTick: 167160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 167160, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 167220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 167280, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 167280, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 167340, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 167400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 167400, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 167460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 167460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 36, absoluteTick: 167496, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  36, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 167520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  24, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 167520, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 167520, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 167520, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 167640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 167700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 167700, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 36, absoluteTick: 167736, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 24, absoluteTick: 167760, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  24, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 167760, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 167760, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 167760, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 167820, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 167881, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 167940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 167940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 167940, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 36, absoluteTick: 167976, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  36, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 168000, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 168000, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 168000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 168000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 168000, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 168120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 168180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 168180, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 36, absoluteTick: 168216, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 168216, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 24, absoluteTick: 168240, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  24, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 168240, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 168300, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 168360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 168420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 168420, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 168420, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 36, absoluteTick: 168456, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  36, 0, 5, 80, 0,
  // deltaTick: 24, absoluteTick: 168480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  24, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 168480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 168480, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 168480, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 168480, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 168540, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 168600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 168600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 168660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 168660, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 168720, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 168720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 168780, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 168840, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 168900, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 168900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 168900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 168960, eventType: NoteOff, channel: 14, note: 91, velocity: 0,
  60, 0, 14, 91, 0,
  // deltaTick: 0, absoluteTick: 168960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 168960, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 168967, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 168984, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  17, 1, 5, 80, 44,
  // deltaTick: 96, absoluteTick: 169080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 169140, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 169200, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 169200, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 169200, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 169224, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 36, absoluteTick: 169260, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 169320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 169320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 169380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 169380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 169380, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 169440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 169440, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 169440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 169464, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 96, absoluteTick: 169560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 169620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 169680, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 169680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 169680, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 169680, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 169704, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 0, absoluteTick: 169704, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  0, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 169740, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 169740, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 169800, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 169860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 169860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 169860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 169920, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 169920, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 169920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 169927, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 169944, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  17, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 170040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 170160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 170160, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 24, absoluteTick: 170184, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 170220, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 67, absoluteTick: 170287, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  67, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 170340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  53, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 170340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 170340, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 170400, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 170400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 170400, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 170400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 24, absoluteTick: 170424, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  24, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 170520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 170520, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 170580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 170640, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 170640, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 170640, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 24, absoluteTick: 170664, eventType: NoteOn, channel: 5, note: 80, velocity: 44,
  24, 1, 5, 80, 44,
  // deltaTick: 36, absoluteTick: 170700, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 170760, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 170760, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 170820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 170820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 170880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 170880, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 170887, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 170904, eventType: NoteOff, channel: 5, note: 80, velocity: 0,
  17, 0, 5, 80, 0,
  // deltaTick: 96, absoluteTick: 171000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 171000, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 171120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 171120, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 171180, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 171240, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 7, absoluteTick: 171247, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 171300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  53, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 171300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 171360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 171360, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 171360, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 171360, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 171480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 171540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 171540, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 171600, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 171600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 171600, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 171600, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 171660, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 171721, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 171780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 171780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 171780, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 171840, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  60, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 171840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 171840, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 171847, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 171960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 172020, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 172080, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 172080, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 172140, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 67, absoluteTick: 172207, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  67, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 172260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  53, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 172260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 172260, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 172320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 172320, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 172320, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 172380, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 172440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 172500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 172500, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 172560, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 172560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 172620, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 172680, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 172680, eventType: NRPN, channel: 13, controlNum: 77, value: 5935,
  0, 4, 13, 77, 5935,
  // deltaTick: 60, absoluteTick: 172740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 172740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 172800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 172800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 172800, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 172800, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 172920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 172980, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 173040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 173040, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 173040, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 173100, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 173160, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 173160, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 173220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 173220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 173220, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 173280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 173280, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 173280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 173400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 173460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 173520, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 173520, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 173520, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 173520, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 173580, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 173580, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 173640, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 173700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 173700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 173700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 173760, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 173760, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 173760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 173760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 173784, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 173880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 174000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 174000, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 174060, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 174120, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 174180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 174180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 174180, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 174240, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 174240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 174240, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 174240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 174360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 174360, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 174420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 174480, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 174480, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 174540, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 174600, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 174600, eventType: NRPN, channel: 13, controlNum: 77, value: 12852,
  0, 4, 13, 77, 12852,
  // deltaTick: 24, absoluteTick: 174624, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 174660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 174720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 174720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 174720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 174720, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 174720, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 174840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 174840, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 174900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 174960, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 174960, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 175020, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 175080, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 175080, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 175140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 175140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 175200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 175200, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 175200, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 175200, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 175320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 175380, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 175380, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 175440, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 175440, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 175440, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 175440, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 175500, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 175561, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 175620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 175620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 175620, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 175680, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 175680, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 175680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 175680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 175680, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 24, absoluteTick: 175704, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 175800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 175860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 175860, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 175920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 175920, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 175980, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 60, absoluteTick: 176040, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 176100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 176100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 176100, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 176160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 176160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 176160, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 176160, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 176160, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 176220, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 176280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 176280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 24, absoluteTick: 176304, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 176340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  36, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 176340, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 176400, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 176400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 176424, eventType: NoteOn, channel: 2, note: 38, velocity: 103,
  24, 1, 2, 38, 103,
  // deltaTick: 36, absoluteTick: 176460, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 176520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 176520, eventType: NRPN, channel: 13, controlNum: 77, value: 5935,
  0, 4, 13, 77, 5935,
  // deltaTick: 60, absoluteTick: 176580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 176580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 176640, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 176640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 176640, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 176640, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 176640, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 176640, eventType: NoteOn, channel: 14, note: 60, velocity: 6,
  0, 1, 14, 60, 6,
  // deltaTick: 0, absoluteTick: 176640, eventType: NRPN, channel: 14, controlNum: 73, value: 45875,
  0, 4, 14, 73, 45875,
  // deltaTick: 0, absoluteTick: 176640, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 3840}, targetValue: 56450,
  0, 8, 11, 983087, 56450,
  // deltaTick: 0, absoluteTick: 176640, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 7680}, targetValue: 56032,
  0, 8, 14, 1966153, 56032,
  // deltaTick: 24, absoluteTick: 176664, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 6, absoluteTick: 176670, eventType: NoteOn, channel: 14, note: 126, velocity: 96,
  6, 1, 14, 126, 96,
  // deltaTick: 90, absoluteTick: 176760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  90, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 176760, eventType: NoteOff, channel: 14, note: 60, velocity: 0,
  0, 0, 14, 60, 0,
  // deltaTick: 60, absoluteTick: 176820, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 176820, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 176880, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 176880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 176880, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 176880, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 176940, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 176993, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 177000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 177060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 177060, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 177060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 177060, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 177120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 177120, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 177120, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 177120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 177240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 177300, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 177300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 177360, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 177360, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 177360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 177360, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 177360, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 177420, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 177420, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 177480, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 177540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 177540, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 177540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 177540, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 177600, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 177600, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 177600, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 177600, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 177600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 177600, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 120, absoluteTick: 177720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 177780, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 177840, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 177840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 177840, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 177900, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 177953, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 178020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 178020, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 178020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 178020, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 178080, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 178080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 178080, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 178080, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 178080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 178200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 178200, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 178260, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 178260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 178320, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 178320, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 178320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 178320, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 178380, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 178440, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 178440, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 178440, eventType: NRPN, channel: 13, controlNum: 77, value: 12852,
  0, 4, 13, 77, 12852,
  // deltaTick: 60, absoluteTick: 178500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 178500, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 178500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 178560, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 178560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 178560, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 178560, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 178560, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 120, absoluteTick: 178680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 178680, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 178740, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 178800, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 178800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 178800, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 178860, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 178913, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 178920, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 178980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 178980, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 178980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 179040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 179040, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 179040, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 179040, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 179040, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 179160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 179220, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 179220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 179220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 179280, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 179280, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 179280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 179280, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 179280, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 179340, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 179401, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 179460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 179460, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 179460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 179460, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 179520, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 179520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 179520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 179520, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 179520, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 24, absoluteTick: 179544, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 179640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 179700, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 179700, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 179760, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 179760, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 179760, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 179820, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 53, absoluteTick: 179873, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 67, absoluteTick: 179940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  67, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 179940, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 179940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 179940, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 180000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 180000, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 180000, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 180000, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 180060, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 180120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 180180, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 180180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 180180, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 180240, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 180240, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 180240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 180300, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 180360, eventType: NRPN, channel: 13, controlNum: 77, value: 5753,
  60, 4, 13, 77, 5753,
  // deltaTick: 24, absoluteTick: 180384, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 180420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 180420, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 180420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 180480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 180480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 180480, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 180480, eventType: NoteOn, channel: 11, note: 34, velocity: 67,
  0, 1, 11, 34, 67,
  // deltaTick: 0, absoluteTick: 180480, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 180480, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 5760}, targetValue: 37683,
  0, 8, 10, 1474607, 37683,
  // deltaTick: 0, absoluteTick: 180480, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 3840}, targetValue: 22282,
  0, 8, 10, 983082, 22282,
  // deltaTick: 0, absoluteTick: 180480, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 7680}, targetValue: 28835,
  0, 8, 11, 1966123, 28835,
  // deltaTick: 0, absoluteTick: 180480, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 3840}, targetValue: 23920,
  0, 8, 11, 983082, 23920,
  // deltaTick: 0, absoluteTick: 180480, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 7680}, targetValue: 37355,
  0, 8, 11, 1966127, 37355,
  // deltaTick: 120, absoluteTick: 180600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 180660, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 180660, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 35, absoluteTick: 180695, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  35, 0, 13, 57, 0,
  // deltaTick: 25, absoluteTick: 180720, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  25, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 180720, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 180720, eventType: NoteOn, channel: 11, note: 34, velocity: 127,
  0, 1, 11, 34, 127,
  // deltaTick: 0, absoluteTick: 180720, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 180744, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 36, absoluteTick: 180780, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 53, absoluteTick: 180833, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  53, 0, 0, 81, 0,
  // deltaTick: 7, absoluteTick: 180840, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  7, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 180900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 180900, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 180900, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 180900, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 180960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 180960, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 180960, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 180960, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 12, absoluteTick: 180972, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  12, 1, 13, 57, 127,
  // deltaTick: 12, absoluteTick: 180984, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  12, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 181080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 181080, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 60, absoluteTick: 181140, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 181140, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 181200, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 181200, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 181200, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 181200, eventType: NoteOn, channel: 11, note: 44, velocity: 127,
  0, 1, 11, 44, 127,
  // deltaTick: 0, absoluteTick: 181200, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 181260, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 181260, eventType: NoteOn, channel: 11, note: 57, velocity: 67,
  0, 1, 11, 57, 67,
  // deltaTick: 60, absoluteTick: 181320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 181380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 181380, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 181380, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 181380, eventType: NoteOff, channel: 11, note: 44, velocity: 0,
  0, 0, 11, 44, 0,
  // deltaTick: 60, absoluteTick: 181440, eventType: NoteOff, channel: 11, note: 57, velocity: 0,
  60, 0, 11, 57, 0,
  // deltaTick: 0, absoluteTick: 181440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 181440, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 181440, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 7, absoluteTick: 181447, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 181464, eventType: NoteOn, channel: 2, note: 38, velocity: 107,
  17, 1, 2, 38, 107,
  // deltaTick: 71, absoluteTick: 181535, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  71, 0, 13, 57, 0,
  // deltaTick: 25, absoluteTick: 181560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  25, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 181620, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 60, absoluteTick: 181680, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 181680, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 0, absoluteTick: 181680, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 0, absoluteTick: 181680, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 24, absoluteTick: 181704, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 181740, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 35, absoluteTick: 181775, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  35, 0, 13, 57, 0,
  // deltaTick: 25, absoluteTick: 181800, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  25, 0, 0, 81, 0,
  // deltaTick: 60, absoluteTick: 181860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 181860, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 181860, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 181860, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 181920, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 181920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 181920, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 181920, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 181920, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 181920, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 7, absoluteTick: 181927, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 181944, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 71, absoluteTick: 182015, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  71, 0, 13, 57, 0,
  // deltaTick: 25, absoluteTick: 182040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  25, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 182040, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 182100, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 182100, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 182160, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 182160, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 182160, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 0, absoluteTick: 182160, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 24, absoluteTick: 182184, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 182220, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 182280, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 182280, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 182340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 182340, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 33, absoluteTick: 182373, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  33, 0, 13, 57, 0,
  // deltaTick: 27, absoluteTick: 182400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  27, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 182400, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 182400, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 182400, eventType: NoteOn, channel: 11, note: 52, velocity: 66,
  0, 1, 11, 52, 66,
  // deltaTick: 0, absoluteTick: 182400, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 0, absoluteTick: 182400, eventType: NRPN, channel: 13, controlNum: 77, value: 13034,
  0, 4, 13, 77, 13034,
  // deltaTick: 0, absoluteTick: 182400, eventType: AllNotesOff, channel: 5, controlNum: 0, value: 0,
  0, 7, 5, 0, 0,
  // deltaTick: 7, absoluteTick: 182407, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 182520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 182520, eventType: NoteOff, channel: 11, note: 52, velocity: 0,
  0, 0, 11, 52, 0,
  // deltaTick: 60, absoluteTick: 182580, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 182580, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 182640, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 182640, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 182640, eventType: NoteOn, channel: 10, note: 36, velocity: 63,
  0, 1, 10, 36, 63,
  // deltaTick: 0, absoluteTick: 182640, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 0, absoluteTick: 182640, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 182700, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 182760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 182760, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 182820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 182820, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 182820, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 182880, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 10, note: 48, velocity: 127,
  0, 1, 10, 48, 127,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 11, note: 36, velocity: 127,
  0, 1, 11, 36, 127,
  // deltaTick: 0, absoluteTick: 182880, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 7, absoluteTick: 182887, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 183000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 183060, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 183060, eventType: NoteOff, channel: 11, note: 36, velocity: 0,
  0, 0, 11, 36, 0,
  // deltaTick: 0, absoluteTick: 183060, eventType: NoteOn, channel: 10, note: 36, velocity: 64,
  0, 1, 10, 36, 64,
  // deltaTick: 60, absoluteTick: 183120, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOff, channel: 10, note: 48, velocity: 0,
  0, 0, 10, 48, 0,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  0, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOn, channel: 11, note: 48, velocity: 67,
  0, 1, 11, 48, 67,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 0, absoluteTick: 183120, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 60, absoluteTick: 183180, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 183240, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 1, absoluteTick: 183241, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  1, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 183300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 183300, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 183300, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 183300, eventType: NoteOff, channel: 11, note: 48, velocity: 0,
  0, 0, 11, 48, 0,
  // deltaTick: 60, absoluteTick: 183360, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  60, 0, 13, 57, 0,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 11, note: 42, velocity: 68,
  0, 1, 11, 42, 68,
  // deltaTick: 0, absoluteTick: 183360, eventType: NoteOn, channel: 13, note: 57, velocity: 127,
  0, 1, 13, 57, 127,
  // deltaTick: 7, absoluteTick: 183367, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 183480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 183540, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 183540, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 183540, eventType: NoteOff, channel: 11, note: 42, velocity: 0,
  0, 0, 11, 42, 0,
  // deltaTick: 60, absoluteTick: 183600, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  60, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 183600, eventType: NoteOn, channel: 10, note: 60, velocity: 127,
  0, 1, 10, 60, 127,
  // deltaTick: 0, absoluteTick: 183600, eventType: NoteOn, channel: 11, note: 52, velocity: 65,
  0, 1, 11, 52, 65,
  // deltaTick: 7, absoluteTick: 183607, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 183660, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 37, absoluteTick: 183697, eventType: NoteOn, channel: 0, note: 81, velocity: 81,
  37, 1, 0, 81, 81,
  // deltaTick: 83, absoluteTick: 183780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  83, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 183780, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 183780, eventType: NoteOff, channel: 10, note: 60, velocity: 0,
  0, 0, 10, 60, 0,
  // deltaTick: 0, absoluteTick: 183780, eventType: NoteOn, channel: 11, note: 36, velocity: 64,
  0, 1, 11, 36, 64,
  // deltaTick: 7, absoluteTick: 183787, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 183840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  53, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 183840, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 183840, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 183840, eventType: NoteOn, channel: 10, note: 36, velocity: 66,
  0, 1, 10, 36, 66,
  // deltaTick: 0, absoluteTick: 183840, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 183847, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 53, absoluteTick: 183900, eventType: NoteOff, channel: 11, note: 52, velocity: 0,
  53, 0, 11, 52, 0,
  // deltaTick: 60, absoluteTick: 183960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 183960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 184020, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  60, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 184020, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 184020, eventType: NoteOff, channel: 11, note: 36, velocity: 0,
  0, 0, 11, 36, 0,
  // deltaTick: 60, absoluteTick: 184080, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 184080, eventType: NoteOn, channel: 6, note: 60, velocity: 127,
  0, 1, 6, 60, 127,
  // deltaTick: 0, absoluteTick: 184080, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 7, absoluteTick: 184087, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 184140, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  53, 1, 3, 60, 72,
  // deltaTick: 37, absoluteTick: 184177, eventType: NoteOn, channel: 0, note: 81, velocity: 74,
  37, 1, 0, 81, 74,
  // deltaTick: 79, absoluteTick: 184256, eventType: NoteOff, channel: 13, note: 57, velocity: 0,
  79, 0, 13, 57, 0,
  // deltaTick: 4, absoluteTick: 184260, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  4, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 184260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 184260, eventType: NoteOff, channel: 6, note: 60, velocity: 0,
  0, 0, 6, 60, 0,
  // deltaTick: 0, absoluteTick: 184260, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 184260, eventType: NoteOff, channel: 14, note: 126, velocity: 0,
  0, 0, 14, 126, 0,
  // deltaTick: 7, absoluteTick: 184267, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 184320, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  53, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 184320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 184320, eventType: NoteOn, channel: 9, note: 84, velocity: 127,
  0, 1, 9, 84, 127,
  // deltaTick: 0, absoluteTick: 184320, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 184320, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 21120}, targetValue: 14418,
  0, 8, 10, 5406763, 14418,
  // deltaTick: 0, absoluteTick: 184320, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 3840}, targetValue: 15728,
  0, 8, 10, 983082, 15728,
  // deltaTick: 0, absoluteTick: 184320, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 3840}, targetValue: 12124,
  0, 8, 11, 983082, 12124,
  // deltaTick: 0, absoluteTick: 184320, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 0}, targetValue: 0,
  0, 8, 14, 73, 0,
  // deltaTick: 1, absoluteTick: 184321, eventType: NRPN, channel: 13, controlNum: 77, value: 7241,
  1, 4, 13, 77, 7241,
  // deltaTick: 119, absoluteTick: 184440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  119, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 184500, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 184560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 184560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 184560, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 184560, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 184620, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 184680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 184740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 184740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 184740, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 184800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 184800, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 184800, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 184920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 184980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 185040, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 185040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 185040, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 185040, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 185100, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 185100, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 185160, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 185220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 185220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 185220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 185280, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 185280, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 185280, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 185280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 185400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 185520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 185520, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 185520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 185520, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 185580, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 185700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 185700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 185700, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 185760, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 185760, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 185760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 185760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 185880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 185880, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 185940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 186000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 186000, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 186060, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 186120, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 186120, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 186180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 186180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 186240, eventType: NoteOff, channel: 9, note: 84, velocity: 0,
  60, 0, 9, 84, 0,
  // deltaTick: 0, absoluteTick: 186240, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 186240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 186240, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 186240, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 28800}, targetValue: 37683,
  0, 8, 10, 7372847, 37683,
  // deltaTick: 120, absoluteTick: 186360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 186360, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 186480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 186480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 186480, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 186540, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 186600, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 186660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 186660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 186720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 186720, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 186720, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 186720, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 186840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 186900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 186900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 186960, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 186960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 186960, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 186960, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 187020, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 187081, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 187140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 187140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 187140, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 187200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 187200, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 187200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 187200, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 187320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 187380, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 187440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 187440, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 187440, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 187440, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 187500, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 187620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 187620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 187620, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 187680, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 187680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 187680, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 187740, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 187800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 187860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 187860, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 187920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 187980, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 188040, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 188100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 188100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 188160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 188160, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 188160, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 17280}, targetValue: 7312,
  0, 8, 10, 4423722, 7312,
  // deltaTick: 0, absoluteTick: 188160, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 17280}, targetValue: 29491,
  0, 8, 11, 4423723, 29491,
  // deltaTick: 0, absoluteTick: 188160, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 11520}, targetValue: 31305,
  0, 8, 11, 2949162, 31305,
  // deltaTick: 0, absoluteTick: 188160, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 15457}, targetValue: 51202,
  0, 8, 11, 3957039, 51202,
  // deltaTick: 7, absoluteTick: 188167, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 188280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 188340, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 188400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 188400, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 188400, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 188407, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 188460, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 188520, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 188580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 188580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 188580, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 188640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 188640, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 188640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 188760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 188820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 188880, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 188880, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 188880, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 188880, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 188940, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 188940, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 189000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 189060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 189060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 189060, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 189120, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 189120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 189127, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 189144, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 189240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 189360, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  120, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 189360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 189360, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 189367, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 189420, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 189540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 189540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 189540, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 189600, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 189600, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 189600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 189600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 189720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 189720, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 189780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 189840, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 189900, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 189960, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 24, absoluteTick: 189984, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 190020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 190080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 190080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 190080, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 190087, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 190200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 190200, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 190260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 190320, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 190320, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 190327, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 190380, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 190440, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 190500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 190500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 190560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 190560, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 190560, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 190560, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 190680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 190740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 190740, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 190800, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 190800, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 190800, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 190800, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 190860, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 190921, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 190980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 190980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 190980, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 191040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 191040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 191040, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 191047, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 191064, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 191160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 191220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 191220, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 191280, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 191280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 191280, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 191287, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 191340, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 191460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 191460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 191460, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 191520, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 191520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 191520, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 191520, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 191527, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 53, absoluteTick: 191580, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  53, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 191640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 191640, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 24, absoluteTick: 191664, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 191700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  36, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 191700, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 191760, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 191760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 191767, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 17, absoluteTick: 191784, eventType: NoteOn, channel: 2, note: 38, velocity: 103,
  17, 1, 2, 38, 103,
  // deltaTick: 36, absoluteTick: 191820, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 191940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 191940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 192000, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 192000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 192000, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 192007, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 192024, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  17, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 192120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 192180, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 192240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 192240, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 192240, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 192247, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 192300, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 192360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 192420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 192420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 192420, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 192480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 192480, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 192480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 192600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 192660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 192720, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 192720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 192720, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 192720, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 192780, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 192780, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 192840, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 192900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 192900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 192900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 192960, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 192960, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 192960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 192967, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 193080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 193200, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  120, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 193200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 193200, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 193207, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 193260, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 193380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 193380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 193380, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 193440, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 193440, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 193440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 193440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 193560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 193560, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 193620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 193680, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 193680, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 193740, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 193800, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  60, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 193800, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 193860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 193860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 193920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 193920, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 193927, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 194040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 194040, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 194160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 194160, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 194167, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 194220, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 194280, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 194340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 194340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 194400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 194400, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 194400, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 194400, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 194520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 194580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 194580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 194640, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 194640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 194640, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 194640, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 194700, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 194761, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 194820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 194820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 194820, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 194880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 194880, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 194887, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 17, absoluteTick: 194904, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  17, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 195000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 195060, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 195120, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 195120, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 195120, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 195127, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 195180, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 195300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 195300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 195300, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 195360, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 195360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 195360, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 195420, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 195480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 195540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 195540, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 195600, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 195660, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 84, absoluteTick: 195744, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  84, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 195780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  36, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 195780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 195840, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 195840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 195840, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 120, absoluteTick: 195960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 196020, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 196080, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 196080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 196080, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 196080, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 24, absoluteTick: 196104, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 36, absoluteTick: 196140, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  36, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 196200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 196260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 196260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 196260, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 196320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 196320, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 196320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 24, absoluteTick: 196344, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 96, absoluteTick: 196440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 196500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 196560, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 196560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 196560, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 196560, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 196620, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 196620, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 196680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 196740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 196740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 196740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 196800, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 196800, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 196800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 24, absoluteTick: 196824, eventType: NoteOn, channel: 2, note: 38, velocity: 107,
  24, 1, 2, 38, 107,
  // deltaTick: 96, absoluteTick: 196920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 197040, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 197040, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 197040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 197040, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 24, absoluteTick: 197064, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 197100, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  36, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 197220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 197220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 197220, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 197280, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 197280, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 197280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 197280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 24, absoluteTick: 197304, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  24, 1, 2, 38, 127,
  // deltaTick: 96, absoluteTick: 197400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  96, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 197400, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 197460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 197520, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 24, absoluteTick: 197544, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  24, 0, 2, 38, 0,
  // deltaTick: 36, absoluteTick: 197580, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  36, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 197640, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 197700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 197760, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 197760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 197760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 197760, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 197880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 197880, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 197940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 198000, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 198000, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 198000, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 198060, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 198120, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 198180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 198180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 198240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 198240, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 198240, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 198240, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 198360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 198420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 198420, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 198480, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 198480, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 198480, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 198480, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 198540, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 198601, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 198660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 198660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 198660, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 198720, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 198720, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 198720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 198720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 198720, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 198840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 198900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 198900, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 198960, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 198960, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 198960, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 198960, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 199020, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 199140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 199140, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 199140, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 199200, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 199200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 199200, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 199200, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 199260, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 199320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 199320, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 199380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 199380, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 199440, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 199440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 199500, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 199620, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  120, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 199620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  0, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 199620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 199680, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 199680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 199680, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 199680, eventType: AllNotesOff, channel: 9, controlNum: 0, value: 0,
  0, 7, 9, 0, 0,
  // deltaTick: 0, absoluteTick: 199680, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 9600}, targetValue: 16159,
  0, 8, 11, 2457642, 16159,
  // deltaTick: 7, absoluteTick: 199687, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 199800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 199860, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 199920, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 199920, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 199920, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 199927, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 199980, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 200040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 200100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 200100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 200100, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 200160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 200160, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 200160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 200280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 200340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 200400, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 200400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 200400, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 200400, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 200460, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 200460, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 200520, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 200580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 200580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 200580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 200640, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 200640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 7, absoluteTick: 200647, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 200760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 200880, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  120, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 200880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 200880, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 200887, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 200940, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 201060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 201060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 201060, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 201120, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 201120, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 201120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 201120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 201240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 201240, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 201300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 201360, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 201360, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 201420, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 201480, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 201540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 201540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 201600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 201600, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 201607, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 201720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 201720, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 201840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 201840, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 7, absoluteTick: 201847, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 201900, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  53, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 201960, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 202020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 202020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 202080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 202080, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 202080, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 202080, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 202200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 202260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 202260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 202320, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 202320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 202320, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 202320, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 202380, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 202441, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 202500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 202500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 202500, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 202560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 202560, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 202567, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 202680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 202740, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 202800, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 202800, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 202800, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 202807, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 202860, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  53, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 202980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 202980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 202980, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 203040, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 203040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 203040, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 203100, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 203160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 203220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 203220, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 203280, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 203340, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 203460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 203460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 203520, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 203520, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 203520, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 97, absoluteTick: 203617, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 11423}, targetValue: 40959,
  97, 8, 11, 2924335, 40959,
  // deltaTick: 23, absoluteTick: 203640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  23, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 203700, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 203760, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 203760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 203760, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 203760, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 203820, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 203880, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 203940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 203940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 203940, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 204000, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 204000, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 204000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 204120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 204180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 204240, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 204240, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 204240, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 204240, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 204300, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 204300, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 204360, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 204420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 204420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 204420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 204480, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 204480, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 204480, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 204600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 204720, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 204720, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 204720, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 204720, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 204780, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 204900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 204900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 204900, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 204960, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 204960, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 204960, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 204960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 205080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 205080, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 205140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 205200, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 205260, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 205320, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 205380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 205440, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 205440, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 205440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 205440, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 205440, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 9600}, targetValue: 1195,
  0, 8, 10, 2457642, 1195,
  // deltaTick: 0, absoluteTick: 205440, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 9600}, targetValue: 12124,
  0, 8, 10, 2457643, 12124,
  // deltaTick: 0, absoluteTick: 205440, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 9600}, targetValue: 26214,
  0, 8, 11, 2457643, 26214,
  // deltaTick: 120, absoluteTick: 205560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 205560, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 205620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 205680, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 205680, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  0, 1, 10, 31, 63,
  // deltaTick: 0, absoluteTick: 205680, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 205740, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 205800, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 205860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 205860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 205920, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 205920, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 205920, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  0, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 205920, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 206040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 206100, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 206100, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 206160, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 206160, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  0, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 206160, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 206160, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 206220, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 206281, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 206340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 206340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 206340, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 206400, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 206400, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 206400, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 206400, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 206520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 206580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 206580, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 206640, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 206640, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 206640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 206640, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 206700, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 206820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 206820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 206820, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 206880, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 206880, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 206880, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 206880, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 0, absoluteTick: 206880, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 206940, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 207000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 207000, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 207060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 207060, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 207120, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 207120, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 207120, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 207180, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 207300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 207300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 207360, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 207360, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 207360, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 207360, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 120, absoluteTick: 207480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 207540, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 207600, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 207600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 207600, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 0, absoluteTick: 207600, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 207660, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 207720, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 207780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 207780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 207780, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 207840, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 207840, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 207840, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 207960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 208020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 208080, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 208080, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 208080, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 0, absoluteTick: 208080, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 208140, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 208140, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 60, absoluteTick: 208200, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 208260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 208260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 208260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 208320, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 208320, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 208320, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 208440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 208560, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 208560, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 208560, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 208560, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 208620, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 208740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 208740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 208740, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 208800, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 208800, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 208800, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 208800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 208920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 208920, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 208980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 209040, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 209040, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 209100, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 209160, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 209220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 209220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 209280, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 209280, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 209280, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 209280, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 5760}, targetValue: 6110,
  0, 8, 11, 1474602, 6110,
  // deltaTick: 120, absoluteTick: 209400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 209400, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 209520, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 209520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 209520, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 209580, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 209640, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 209700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 209700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 209760, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 209760, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 209760, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 209760, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 209880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 209940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 209940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 210000, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 210000, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 210000, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 0, absoluteTick: 210000, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 210060, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 210121, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 210180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 210180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 210180, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 210240, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 210240, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 210240, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 120, absoluteTick: 210360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 210420, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 210480, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 210480, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 210480, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  0, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 210480, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 60, absoluteTick: 210540, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 210660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 210660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 210660, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 210720, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 210720, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 210720, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 210780, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 210840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 210900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 210900, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 210960, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 211020, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 211140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 211140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 211200, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 211200, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 211200, eventType: NoteOn, channel: 11, note: 34, velocity: 67,
  0, 1, 11, 34, 67,
  // deltaTick: 120, absoluteTick: 211320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 211380, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  60, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 211440, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 211440, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 211440, eventType: NoteOn, channel: 11, note: 34, velocity: 127,
  0, 1, 11, 34, 127,
  // deltaTick: 0, absoluteTick: 211440, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 211500, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 211560, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 211620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 211620, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 211620, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 211680, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 211680, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 211680, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 120, absoluteTick: 211800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 211860, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 211920, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 211920, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 0, absoluteTick: 211920, eventType: NoteOn, channel: 11, note: 44, velocity: 127,
  0, 1, 11, 44, 127,
  // deltaTick: 0, absoluteTick: 211920, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 211980, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 0, absoluteTick: 211980, eventType: NoteOn, channel: 11, note: 57, velocity: 67,
  0, 1, 11, 57, 67,
  // deltaTick: 60, absoluteTick: 212040, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 212100, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 212100, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 212100, eventType: NoteOff, channel: 11, note: 44, velocity: 0,
  0, 0, 11, 44, 0,
  // deltaTick: 60, absoluteTick: 212160, eventType: NoteOff, channel: 11, note: 57, velocity: 0,
  60, 0, 11, 57, 0,
  // deltaTick: 0, absoluteTick: 212160, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 212160, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 120, absoluteTick: 212280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 212400, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  120, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 212400, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 212400, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  0, 1, 10, 34, 127,
  // deltaTick: 0, absoluteTick: 212400, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 60, absoluteTick: 212460, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 212580, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 212580, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  0, 0, 10, 34, 0,
  // deltaTick: 0, absoluteTick: 212580, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 212640, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 212640, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 212640, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 212640, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  0, 1, 10, 34, 64,
  // deltaTick: 120, absoluteTick: 212760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 212760, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 212820, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  60, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 212880, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 212940, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 60, absoluteTick: 213000, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 213060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 213120, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 213120, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 213120, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 213120, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 120, absoluteTick: 213240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 213240, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 213300, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 213360, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 213360, eventType: NoteOn, channel: 10, note: 36, velocity: 63,
  0, 1, 10, 36, 63,
  // deltaTick: 0, absoluteTick: 213360, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 213420, eventType: NoteOn, channel: 3, note: 60, velocity: 90,
  60, 1, 3, 60, 90,
  // deltaTick: 60, absoluteTick: 213480, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  60, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 213540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 213540, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 213600, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  60, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 213600, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 213600, eventType: NoteOn, channel: 10, note: 48, velocity: 127,
  0, 1, 10, 48, 127,
  // deltaTick: 0, absoluteTick: 213600, eventType: NoteOn, channel: 11, note: 34, velocity: 127,
  0, 1, 11, 34, 127,
  // deltaTick: 120, absoluteTick: 213720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 213780, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  60, 0, 11, 34, 0,
  // deltaTick: 0, absoluteTick: 213780, eventType: NoteOn, channel: 10, note: 36, velocity: 64,
  0, 1, 10, 36, 64,
  // deltaTick: 60, absoluteTick: 213840, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 213840, eventType: NoteOff, channel: 10, note: 48, velocity: 0,
  0, 0, 10, 48, 0,
  // deltaTick: 0, absoluteTick: 213840, eventType: NoteOn, channel: 11, note: 46, velocity: 67,
  0, 1, 11, 46, 67,
  // deltaTick: 0, absoluteTick: 213840, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 60, absoluteTick: 213900, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 61, absoluteTick: 213961, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  61, 0, 12, 31, 0,
  // deltaTick: 59, absoluteTick: 214020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  59, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 214020, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 214020, eventType: NoteOff, channel: 11, note: 46, velocity: 0,
  0, 0, 11, 46, 0,
  // deltaTick: 60, absoluteTick: 214080, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  60, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 214080, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 214080, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 0, absoluteTick: 214080, eventType: NoteOn, channel: 11, note: 38, velocity: 68,
  0, 1, 11, 38, 68,
  // deltaTick: 120, absoluteTick: 214200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 214260, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 214260, eventType: NoteOff, channel: 11, note: 38, velocity: 0,
  0, 0, 11, 38, 0,
  // deltaTick: 60, absoluteTick: 214320, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  60, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 214320, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 214320, eventType: NoteOn, channel: 10, note: 60, velocity: 127,
  0, 1, 10, 60, 127,
  // deltaTick: 0, absoluteTick: 214320, eventType: NoteOn, channel: 11, note: 46, velocity: 65,
  0, 1, 11, 46, 65,
  // deltaTick: 60, absoluteTick: 214380, eventType: NoteOn, channel: 3, note: 60, velocity: 96,
  60, 1, 3, 60, 96,
  // deltaTick: 120, absoluteTick: 214500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 214500, eventType: NoteOff, channel: 10, note: 60, velocity: 0,
  0, 0, 10, 60, 0,
  // deltaTick: 0, absoluteTick: 214500, eventType: NoteOn, channel: 11, note: 34, velocity: 64,
  0, 1, 11, 34, 64,
  // deltaTick: 60, absoluteTick: 214560, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 214560, eventType: NoteOff, channel: 11, note: 46, velocity: 0,
  0, 0, 11, 46, 0,
  // deltaTick: 0, absoluteTick: 214560, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 214560, eventType: NoteOn, channel: 10, note: 36, velocity: 66,
  0, 1, 10, 36, 66,
  // deltaTick: 0, absoluteTick: 214560, eventType: NoteOn, channel: 12, note: 31, velocity: 48,
  0, 1, 12, 31, 48,
  // deltaTick: 120, absoluteTick: 214680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 214680, eventType: NoteOff, channel: 12, note: 31, velocity: 0,
  0, 0, 12, 31, 0,
  // deltaTick: 60, absoluteTick: 214740, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  60, 0, 10, 36, 0,
  // deltaTick: 0, absoluteTick: 214740, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 60, absoluteTick: 214800, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  60, 1, 4, 60, 127,
  // deltaTick: 0, absoluteTick: 214800, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  0, 1, 10, 36, 127,
  // deltaTick: 60, absoluteTick: 214860, eventType: NoteOn, channel: 3, note: 60, velocity: 72,
  60, 1, 3, 60, 72,
  // deltaTick: 120, absoluteTick: 214980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 214980, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  0, 0, 10, 36, 0,
  // deltaTick: 60, absoluteTick: 215040, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  60, 0, 4, 60, 0,
  // deltaTick: 0, absoluteTick: 215040, eventType: NoteOn, channel: 3, note: 60, velocity: 127,
  0, 1, 3, 60, 127,
  // deltaTick: 0, absoluteTick: 215040, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 215040, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 0, absoluteTick: 215040, eventType: NRPN, channel: 22, controlNum: 100, value: 0,
  0, 4, 22, 100, 0,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 28800}, targetValue: 10042,
  0, 8, 10, 7372842, 10042,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 28800}, targetValue: 37355,
  0, 8, 10, 7372847, 37355,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 28800}, targetValue: 17367,
  0, 8, 10, 7372843, 17367,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 28800}, targetValue: 10042,
  0, 8, 11, 7372842, 10042,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 28897}, targetValue: 41287,
  0, 8, 11, 7397679, 41287,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 28800}, targetValue: 17367,
  0, 8, 11, 7372843, 17367,
  // deltaTick: 0, absoluteTick: 215040, eventType: StartEnvelope, channel: 22, { controlNum: 100, envelopeLength: 30720}, targetValue: 4431,
  0, 8, 22, 7864420, 4431,
  // deltaTick: 7, absoluteTick: 215047, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 215047, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  0, 1, 0, 81, 127,
  // deltaTick: 0, absoluteTick: 215047, eventType: NoteOn, channel: 4, note: 60, velocity: 127,
  0, 1, 4, 60, 127,
  // deltaTick: 113, absoluteTick: 215160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 215220, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 215280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 215280, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 7, absoluteTick: 215287, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 0, absoluteTick: 215287, eventType: NoteOff, channel: 4, note: 60, velocity: 0,
  0, 0, 4, 60, 0,
  // deltaTick: 53, absoluteTick: 215340, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 215460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 215460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 215460, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 215520, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 215520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 215640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 215700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 215760, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 215760, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 215820, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 215820, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 215940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 215940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 215940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 216000, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 216000, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 216007, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 216120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 216240, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 216240, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 216247, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 173, absoluteTick: 216420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  173, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 216420, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 216480, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 216480, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 216480, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 216600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 216600, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 216660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 216720, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 216720, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 216840, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 216900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 216960, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 216960, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 0, absoluteTick: 216960, eventType: AllNotesOff, channel: 4, controlNum: 0, value: 0,
  0, 7, 4, 0, 0,
  // deltaTick: 7, absoluteTick: 216967, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 217080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 217080, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 217200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 217207, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 173, absoluteTick: 217380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  173, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 217440, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 217440, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 217440, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 217560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 217620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 217620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 217680, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 217680, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 217740, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 217860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 217860, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 217860, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 217920, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 217920, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 217927, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 218040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 218100, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 218160, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 218160, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 218167, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 218220, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  53, 1, 3, 60, 68,
  // deltaTick: 120, absoluteTick: 218340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 218340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 218340, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 218400, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 218400, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 218460, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 218520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 218580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 218580, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 218640, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 218700, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 218820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 218820, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 218880, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 218880, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 14, absoluteTick: 218894, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 219000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 219060, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 219120, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 219120, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 14, absoluteTick: 219134, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 219180, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  46, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 219300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 219300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 219300, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 219360, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 219360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 219480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 219540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 219600, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 219600, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 219660, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 219660, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 219780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 219780, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 219780, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 219840, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 219840, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 14, absoluteTick: 219854, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 219960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 220080, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 220080, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 14, absoluteTick: 220094, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 220260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 220260, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 220320, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 220320, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 220320, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 220440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 220440, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 220500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 220560, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 220560, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 220680, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 220740, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 220800, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 220800, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 14, absoluteTick: 220814, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 220920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 220920, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 221040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 221054, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 221220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 221280, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 221280, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 221280, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 221400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 221460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 221460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 221520, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 221520, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 221580, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 221700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 221700, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 221700, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 221760, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 221760, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 14, absoluteTick: 221774, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 221880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 221940, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 222000, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 222000, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 14, absoluteTick: 222014, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 222060, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  46, 1, 3, 60, 68,
  // deltaTick: 120, absoluteTick: 222180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 222180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 222180, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 222240, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 222240, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 14, absoluteTick: 222254, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 46, absoluteTick: 222300, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  46, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 222360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 222420, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 222420, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 222480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 222494, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 222540, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  46, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 222660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 222660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 222720, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 222720, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 14, absoluteTick: 222734, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 222840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 222900, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 222960, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 222960, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 14, absoluteTick: 222974, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 223020, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  46, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 223140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 223140, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 223140, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 223200, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 223200, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 120, absoluteTick: 223320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 223380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 223440, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 223440, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 223500, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 223500, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 223620, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 223620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 223620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 223680, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 223680, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 14, absoluteTick: 223694, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 223800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 223920, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 223920, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 14, absoluteTick: 223934, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 224100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 224100, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 224160, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 224160, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 224160, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 224280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 224280, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 224340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 224400, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 224400, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 224520, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 224580, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 224640, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 224640, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 14, absoluteTick: 224654, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 224760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 224760, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 120, absoluteTick: 224880, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 224894, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 225060, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 225120, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 225120, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  0, 1, 10, 31, 65,
  // deltaTick: 0, absoluteTick: 225120, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 225240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 225300, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 225300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 225360, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 225360, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 225420, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 225540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 225540, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 225540, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 225600, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 225600, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 14, absoluteTick: 225614, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 225720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 225780, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 225840, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  60, 1, 10, 31, 67,
  // deltaTick: 0, absoluteTick: 225840, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 14, absoluteTick: 225854, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 225900, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  46, 1, 3, 60, 68,
  // deltaTick: 120, absoluteTick: 226020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 226020, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 226020, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 226080, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 226080, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  0, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 226140, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 226200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 226260, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 226260, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 226320, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 226380, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 226500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 226500, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 226560, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 226560, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 226567, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 226680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 226740, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 226800, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 226800, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  0, 1, 11, 31, 127,
  // deltaTick: 7, absoluteTick: 226807, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 226860, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 226980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 226980, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 226980, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 227040, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 180, absoluteTick: 227220, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 227280, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 0, absoluteTick: 227280, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 227340, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 227340, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 120, absoluteTick: 227460, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 227460, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 227460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 227520, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 227520, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 227527, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 227640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 120, absoluteTick: 227760, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  120, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 227760, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 227767, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 227820, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 227940, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 227940, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 227940, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 60, absoluteTick: 228000, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 228000, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 120, absoluteTick: 228120, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  120, 0, 11, 31, 0,
  // deltaTick: 60, absoluteTick: 228180, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 228240, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  60, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 228300, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 60, absoluteTick: 228360, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 228420, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 228480, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 228480, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 228480, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 228487, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 228600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 228600, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 228660, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 228720, eventType: NoteOn, channel: 10, note: 31, velocity: 63,
  60, 1, 10, 31, 63,
  // deltaTick: 7, absoluteTick: 228727, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 228780, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 228900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 228900, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 228960, eventType: NoteOn, channel: 10, note: 43, velocity: 127,
  60, 1, 10, 43, 127,
  // deltaTick: 0, absoluteTick: 228960, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 180, absoluteTick: 229140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  180, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 229140, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  0, 1, 10, 31, 64,
  // deltaTick: 60, absoluteTick: 229200, eventType: NoteOff, channel: 10, note: 43, velocity: 0,
  60, 0, 10, 43, 0,
  // deltaTick: 0, absoluteTick: 229200, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  0, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 229260, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 229380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 229380, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 229380, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 229440, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 229440, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  0, 1, 10, 31, 127,
  // deltaTick: 0, absoluteTick: 229440, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 229447, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 229560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 229620, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  60, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 229620, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 229680, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  60, 1, 10, 55, 127,
  // deltaTick: 0, absoluteTick: 229680, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  0, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 229687, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 229740, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 229860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 229860, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 0, absoluteTick: 229860, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 60, absoluteTick: 229920, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  60, 1, 10, 31, 66,
  // deltaTick: 60, absoluteTick: 229980, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 120, absoluteTick: 230100, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  120, 0, 10, 31, 0,
  // deltaTick: 0, absoluteTick: 230100, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  0, 0, 11, 40, 0,
  // deltaTick: 60, absoluteTick: 230160, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 60, absoluteTick: 230220, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 120, absoluteTick: 230340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 230340, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  0, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 230400, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 230400, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 14, absoluteTick: 230414, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 230520, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 230580, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 230633, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 230640, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  7, 1, 11, 31, 127,
  // deltaTick: 14, absoluteTick: 230654, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 230700, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  46, 1, 3, 60, 62,
  // deltaTick: 113, absoluteTick: 230813, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 230820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 230820, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 230873, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 230880, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 231000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 231053, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 231113, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 231120, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  7, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 231180, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 231180, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 113, absoluteTick: 231293, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 231300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 231300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 231360, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 231360, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 14, absoluteTick: 231374, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 231480, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 113, absoluteTick: 231593, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 231600, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  7, 1, 11, 43, 65,
  // deltaTick: 14, absoluteTick: 231614, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 159, absoluteTick: 231773, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  159, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 231780, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  7, 1, 11, 31, 66,
  // deltaTick: 53, absoluteTick: 231833, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 231840, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 231840, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 231960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 231960, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 232013, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 232073, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 232080, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  7, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 232200, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 232253, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 67, absoluteTick: 232320, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  67, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 232320, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 14, absoluteTick: 232334, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 232440, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 232440, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 113, absoluteTick: 232553, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 21, absoluteTick: 232574, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  21, 0, 0, 81, 0,
  // deltaTick: 159, absoluteTick: 232733, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  159, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 232793, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 7, absoluteTick: 232800, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 232800, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 232920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 232973, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 232980, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 233033, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 233040, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  7, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 233100, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 233213, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 233220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 233220, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 233280, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 233280, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 14, absoluteTick: 233294, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 106, absoluteTick: 233400, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  106, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 233460, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 233513, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  53, 1, 10, 31, 67,
  // deltaTick: 7, absoluteTick: 233520, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  7, 1, 11, 55, 65,
  // deltaTick: 14, absoluteTick: 233534, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 46, absoluteTick: 233580, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  46, 1, 3, 60, 68,
  // deltaTick: 113, absoluteTick: 233693, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 233700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 233700, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 53, absoluteTick: 233753, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  53, 1, 10, 31, 66,
  // deltaTick: 7, absoluteTick: 233760, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 60, absoluteTick: 233820, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 233880, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 233933, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 233940, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  7, 0, 11, 40, 0,
  // deltaTick: 53, absoluteTick: 233993, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 67, absoluteTick: 234060, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  67, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 234173, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 234180, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 234240, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 234240, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 234247, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 234360, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 234420, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 234473, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 234480, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  7, 1, 11, 31, 127,
  // deltaTick: 7, absoluteTick: 234487, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 234540, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 113, absoluteTick: 234653, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 234660, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 234660, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 234713, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 234720, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 234840, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 234893, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 234953, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 234960, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  7, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 235020, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 235020, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 113, absoluteTick: 235133, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 235140, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 235140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 235200, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 235200, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 235207, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 235320, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 113, absoluteTick: 235433, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 235440, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  7, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 235447, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 235613, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 235620, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  7, 1, 11, 31, 66,
  // deltaTick: 53, absoluteTick: 235673, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 235680, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 235680, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 235800, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 235800, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 235853, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 235913, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 235920, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  7, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 236040, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 236093, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 67, absoluteTick: 236160, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  67, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 236160, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 236167, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 236280, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 236280, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 113, absoluteTick: 236393, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 236407, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 236573, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 236633, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 7, absoluteTick: 236640, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 236640, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 236760, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 236813, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 236820, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 236873, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 236880, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  7, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 236940, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 237053, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 237060, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 237060, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 237120, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 237120, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 237127, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 237240, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 237300, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 237353, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  53, 1, 10, 31, 67,
  // deltaTick: 7, absoluteTick: 237360, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  7, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 237367, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 237420, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  53, 1, 3, 60, 68,
  // deltaTick: 113, absoluteTick: 237533, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 237540, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 237540, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 53, absoluteTick: 237593, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  53, 1, 10, 31, 66,
  // deltaTick: 7, absoluteTick: 237600, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 237607, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 53, absoluteTick: 237660, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  53, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 237720, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 237773, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 237780, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  7, 0, 11, 40, 0,
  // deltaTick: 53, absoluteTick: 237833, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 237847, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 237900, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  53, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 238013, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 238020, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 238080, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 238080, eventType: NoteOn, channel: 11, note: 31, velocity: 67,
  0, 1, 11, 31, 67,
  // deltaTick: 7, absoluteTick: 238087, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 238200, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 238260, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  60, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 238313, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 238320, eventType: NoteOn, channel: 11, note: 31, velocity: 127,
  7, 1, 11, 31, 127,
  // deltaTick: 7, absoluteTick: 238327, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 238380, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 113, absoluteTick: 238493, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 238500, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 238500, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 238553, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 238560, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 238680, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 238733, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 238793, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 238800, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  7, 1, 11, 43, 127,
  // deltaTick: 60, absoluteTick: 238860, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 238860, eventType: NoteOn, channel: 11, note: 55, velocity: 67,
  0, 1, 11, 55, 67,
  // deltaTick: 113, absoluteTick: 238973, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 238980, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 238980, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 239040, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 0, absoluteTick: 239040, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 239047, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 239160, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 113, absoluteTick: 239273, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 239280, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  7, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 239287, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 239453, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 239460, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  7, 1, 11, 31, 66,
  // deltaTick: 53, absoluteTick: 239513, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  53, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 239520, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 239520, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 120, absoluteTick: 239640, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 239640, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 239693, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 239753, eventType: NoteOn, channel: 10, note: 31, velocity: 64,
  60, 1, 10, 31, 64,
  // deltaTick: 7, absoluteTick: 239760, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  7, 1, 11, 43, 60,
  // deltaTick: 120, absoluteTick: 239880, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  120, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 239933, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 67, absoluteTick: 240000, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  67, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 240000, eventType: NoteOn, channel: 11, note: 50, velocity: 66,
  0, 1, 11, 50, 66,
  // deltaTick: 7, absoluteTick: 240007, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 240120, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 240120, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 113, absoluteTick: 240233, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  113, 1, 10, 31, 127,
  // deltaTick: 14, absoluteTick: 240247, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 166, absoluteTick: 240413, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  166, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 240473, eventType: NoteOn, channel: 10, note: 31, velocity: 65,
  60, 1, 10, 31, 65,
  // deltaTick: 7, absoluteTick: 240480, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 240480, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 120, absoluteTick: 240600, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 240653, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 240660, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 240713, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 240720, eventType: NoteOn, channel: 11, note: 50, velocity: 67,
  7, 1, 11, 50, 67,
  // deltaTick: 60, absoluteTick: 240780, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 240893, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 240900, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 240900, eventType: NoteOff, channel: 11, note: 50, velocity: 0,
  0, 0, 11, 50, 0,
  // deltaTick: 60, absoluteTick: 240960, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 240960, eventType: NoteOn, channel: 11, note: 43, velocity: 68,
  0, 1, 11, 43, 68,
  // deltaTick: 7, absoluteTick: 240967, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 241080, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 241140, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 241193, eventType: NoteOn, channel: 10, note: 31, velocity: 67,
  53, 1, 10, 31, 67,
  // deltaTick: 7, absoluteTick: 241200, eventType: NoteOn, channel: 11, note: 55, velocity: 65,
  7, 1, 11, 55, 65,
  // deltaTick: 7, absoluteTick: 241207, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 241260, eventType: NoteOn, channel: 3, note: 60, velocity: 68,
  53, 1, 3, 60, 68,
  // deltaTick: 113, absoluteTick: 241373, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 241380, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 241380, eventType: NoteOn, channel: 11, note: 40, velocity: 64,
  0, 1, 11, 40, 64,
  // deltaTick: 53, absoluteTick: 241433, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  53, 1, 10, 31, 66,
  // deltaTick: 7, absoluteTick: 241440, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 60, absoluteTick: 241500, eventType: NoteOff, channel: 11, note: 55, velocity: 0,
  60, 0, 11, 55, 0,
  // deltaTick: 60, absoluteTick: 241560, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 241613, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  53, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 241620, eventType: NoteOff, channel: 11, note: 40, velocity: 0,
  7, 0, 11, 40, 0,
  // deltaTick: 53, absoluteTick: 241673, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  53, 1, 10, 31, 127,
  // deltaTick: 67, absoluteTick: 241740, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  67, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 241853, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 241860, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 241920, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  60, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 241920, eventType: NoteOn, channel: 11, note: 34, velocity: 67,
  0, 1, 11, 34, 67,
  // deltaTick: 7, absoluteTick: 241927, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 242040, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 60, absoluteTick: 242100, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  60, 0, 11, 34, 0,
  // deltaTick: 53, absoluteTick: 242153, eventType: NoteOn, channel: 10, note: 38, velocity: 64,
  53, 1, 10, 38, 64,
  // deltaTick: 7, absoluteTick: 242160, eventType: NoteOn, channel: 11, note: 34, velocity: 127,
  7, 1, 11, 34, 127,
  // deltaTick: 7, absoluteTick: 242167, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 242220, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 113, absoluteTick: 242333, eventType: NoteOff, channel: 10, note: 38, velocity: 0,
  113, 0, 10, 38, 0,
  // deltaTick: 7, absoluteTick: 242340, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 242340, eventType: NoteOff, channel: 11, note: 34, velocity: 0,
  0, 0, 11, 34, 0,
  // deltaTick: 53, absoluteTick: 242393, eventType: NoteOn, channel: 10, note: 38, velocity: 127,
  53, 1, 10, 38, 127,
  // deltaTick: 180, absoluteTick: 242573, eventType: NoteOff, channel: 10, note: 38, velocity: 0,
  180, 0, 10, 38, 0,
  // deltaTick: 60, absoluteTick: 242633, eventType: NoteOn, channel: 10, note: 38, velocity: 64,
  60, 1, 10, 38, 64,
  // deltaTick: 7, absoluteTick: 242640, eventType: NoteOn, channel: 11, note: 48, velocity: 127,
  7, 1, 11, 48, 127,
  // deltaTick: 60, absoluteTick: 242700, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 0, absoluteTick: 242700, eventType: NoteOn, channel: 11, note: 57, velocity: 67,
  0, 1, 11, 57, 67,
  // deltaTick: 113, absoluteTick: 242813, eventType: NoteOff, channel: 10, note: 38, velocity: 0,
  113, 0, 10, 38, 0,
  // deltaTick: 7, absoluteTick: 242820, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 242820, eventType: NoteOff, channel: 11, note: 48, velocity: 0,
  0, 0, 11, 48, 0,
  // deltaTick: 60, absoluteTick: 242880, eventType: NoteOff, channel: 11, note: 57, velocity: 0,
  60, 0, 11, 57, 0,
  // deltaTick: 0, absoluteTick: 242880, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 242880, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 242887, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 243000, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 113, absoluteTick: 243113, eventType: NoteOn, channel: 10, note: 36, velocity: 127,
  113, 1, 10, 36, 127,
  // deltaTick: 7, absoluteTick: 243120, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  7, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 243120, eventType: NoteOn, channel: 11, note: 43, velocity: 65,
  0, 1, 11, 43, 65,
  // deltaTick: 7, absoluteTick: 243127, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 243180, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 113, absoluteTick: 243293, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  113, 0, 10, 36, 0,
  // deltaTick: 7, absoluteTick: 243300, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 243300, eventType: NoteOn, channel: 11, note: 31, velocity: 66,
  0, 1, 11, 31, 66,
  // deltaTick: 53, absoluteTick: 243353, eventType: NoteOn, channel: 10, note: 36, velocity: 64,
  53, 1, 10, 36, 64,
  // deltaTick: 7, absoluteTick: 243360, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 243360, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 120, absoluteTick: 243480, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  120, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 243533, eventType: NoteOff, channel: 10, note: 36, velocity: 0,
  53, 0, 10, 36, 0,
  // deltaTick: 67, absoluteTick: 243600, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  67, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 243600, eventType: NoteOn, channel: 11, note: 43, velocity: 60,
  0, 1, 11, 43, 60,
  // deltaTick: 60, absoluteTick: 243660, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 60, absoluteTick: 243720, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  60, 0, 11, 43, 0,
  // deltaTick: 60, absoluteTick: 243780, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  60, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 243833, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  53, 1, 10, 34, 127,
  // deltaTick: 7, absoluteTick: 243840, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  7, 1, 3, 60, 99,
  // deltaTick: 0, absoluteTick: 243840, eventType: NoteOn, channel: 11, note: 48, velocity: 66,
  0, 1, 11, 48, 66,
  // deltaTick: 0, absoluteTick: 243840, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 1920}, targetValue: 41287,
  0, 8, 10, 491567, 41287,
  // deltaTick: 0, absoluteTick: 243840, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 1920}, targetValue: 10042,
  0, 8, 10, 491562, 10042,
  // deltaTick: 0, absoluteTick: 243840, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 1920}, targetValue: 17367,
  0, 8, 10, 491563, 17367,
  // deltaTick: 0, absoluteTick: 243840, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 1920}, targetValue: 17367,
  0, 8, 11, 491563, 17367,
  // deltaTick: 0, absoluteTick: 243840, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 1920}, targetValue: 10042,
  0, 8, 11, 491562, 10042,
  // deltaTick: 7, absoluteTick: 243847, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 90, absoluteTick: 243937, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 1823}, targetValue: 41287,
  90, 8, 11, 466735, 41287,
  // deltaTick: 23, absoluteTick: 243960, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  23, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 244013, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  53, 0, 10, 34, 0,
  // deltaTick: 60, absoluteTick: 244073, eventType: NoteOn, channel: 10, note: 34, velocity: 63,
  60, 1, 10, 34, 63,
  // deltaTick: 14, absoluteTick: 244087, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  14, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 244140, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 60, absoluteTick: 244200, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  60, 1, 11, 43, 127,
  // deltaTick: 53, absoluteTick: 244253, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  53, 0, 10, 34, 0,
  // deltaTick: 7, absoluteTick: 244260, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 244260, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  0, 0, 11, 43, 0,
  // deltaTick: 53, absoluteTick: 244313, eventType: NoteOn, channel: 10, note: 46, velocity: 127,
  53, 1, 10, 46, 127,
  // deltaTick: 7, absoluteTick: 244320, eventType: NoteOff, channel: 11, note: 48, velocity: 0,
  7, 0, 11, 48, 0,
  // deltaTick: 0, absoluteTick: 244320, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 244320, eventType: NoteOn, channel: 11, note: 43, velocity: 127,
  0, 1, 11, 43, 127,
  // deltaTick: 173, absoluteTick: 244493, eventType: NoteOn, channel: 10, note: 34, velocity: 64,
  173, 1, 10, 34, 64,
  // deltaTick: 60, absoluteTick: 244553, eventType: NoteOff, channel: 10, note: 46, velocity: 0,
  60, 0, 10, 46, 0,
  // deltaTick: 7, absoluteTick: 244560, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  7, 0, 2, 38, 0,
  // deltaTick: 60, absoluteTick: 244620, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 244733, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  113, 0, 10, 34, 0,
  // deltaTick: 7, absoluteTick: 244740, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 244740, eventType: NoteOn, channel: 11, note: 31, velocity: 68,
  0, 1, 11, 31, 68,
  // deltaTick: 53, absoluteTick: 244793, eventType: NoteOn, channel: 10, note: 34, velocity: 127,
  53, 1, 10, 34, 127,
  // deltaTick: 7, absoluteTick: 244800, eventType: NoteOff, channel: 11, note: 43, velocity: 0,
  7, 0, 11, 43, 0,
  // deltaTick: 0, absoluteTick: 244800, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  0, 1, 2, 38, 127,
  // deltaTick: 0, absoluteTick: 244800, eventType: NoteOn, channel: 3, note: 60, velocity: 99,
  0, 1, 3, 60, 99,
  // deltaTick: 7, absoluteTick: 244807, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  7, 1, 0, 81, 127,
  // deltaTick: 113, absoluteTick: 244920, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  113, 0, 3, 60, 0,
  // deltaTick: 53, absoluteTick: 244973, eventType: NoteOff, channel: 10, note: 34, velocity: 0,
  53, 0, 10, 34, 0,
  // deltaTick: 67, absoluteTick: 245040, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  67, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 245040, eventType: NoteOn, channel: 10, note: 55, velocity: 127,
  0, 1, 10, 55, 127,
  // deltaTick: 7, absoluteTick: 245047, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  7, 0, 0, 81, 0,
  // deltaTick: 53, absoluteTick: 245100, eventType: NoteOn, channel: 3, note: 60, velocity: 62,
  53, 1, 3, 60, 62,
  // deltaTick: 120, absoluteTick: 245220, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  120, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 245220, eventType: NoteOff, channel: 10, note: 55, velocity: 0,
  0, 0, 10, 55, 0,
  // deltaTick: 53, absoluteTick: 245273, eventType: NoteOn, channel: 10, note: 31, velocity: 66,
  53, 1, 10, 31, 66,
  // deltaTick: 180, absoluteTick: 245453, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  180, 0, 10, 31, 0,
  // deltaTick: 60, absoluteTick: 245513, eventType: NoteOn, channel: 10, note: 31, velocity: 127,
  60, 1, 10, 31, 127,
  // deltaTick: 7, absoluteTick: 245520, eventType: NoteOn, channel: 2, note: 38, velocity: 127,
  7, 1, 2, 38, 127,
  // deltaTick: 60, absoluteTick: 245580, eventType: NoteOn, channel: 3, note: 60, velocity: 44,
  60, 1, 3, 60, 44,
  // deltaTick: 113, absoluteTick: 245693, eventType: NoteOff, channel: 10, note: 31, velocity: 0,
  113, 0, 10, 31, 0,
  // deltaTick: 7, absoluteTick: 245700, eventType: NoteOff, channel: 3, note: 60, velocity: 0,
  7, 0, 3, 60, 0,
  // deltaTick: 0, absoluteTick: 245700, eventType: NoteOff, channel: 11, note: 31, velocity: 0,
  0, 0, 11, 31, 0,
  // deltaTick: 53, absoluteTick: 245753, eventType: AllNotesOff, channel: 10, controlNum: 0, value: 0,
  53, 7, 10, 0, 0,
  // deltaTick: 0, absoluteTick: 245753, eventType: AllNotesOff, channel: 11, controlNum: 0, value: 0,
  0, 7, 11, 0, 0,
  // deltaTick: 7, absoluteTick: 245760, eventType: NoteOff, channel: 2, note: 38, velocity: 0,
  7, 0, 2, 38, 0,
  // deltaTick: 0, absoluteTick: 245760, eventType: NRPN, channel: 14, controlNum: 73, value: 988,
  0, 4, 14, 73, 988,
  // deltaTick: 0, absoluteTick: 245760, eventType: AllNotesOff, channel: 3, controlNum: 0, value: 0,
  0, 7, 3, 0, 0,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 10, { controlNum: 42, envelopeLength: 1}, targetValue: 8842,
  0, 8, 10, 298, 8842,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 10, { controlNum: 47, envelopeLength: 1}, targetValue: 39894,
  0, 8, 10, 303, 39894,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 10, { controlNum: 43, envelopeLength: 1}, targetValue: 14008,
  0, 8, 10, 299, 14008,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 11, { controlNum: 47, envelopeLength: 1}, targetValue: 39894,
  0, 8, 11, 303, 39894,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 11, { controlNum: 42, envelopeLength: 1}, targetValue: 8842,
  0, 8, 11, 298, 8842,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 11, { controlNum: 43, envelopeLength: 1}, targetValue: 14008,
  0, 8, 11, 299, 14008,
  // deltaTick: 0, absoluteTick: 245760, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 7680}, targetValue: 19005,
  0, 8, 14, 1966153, 19005,
  // deltaTick: 14, absoluteTick: 245774, eventType: NoteOn, channel: 0, note: 81, velocity: 127,
  14, 1, 0, 81, 127,
  // deltaTick: 46, absoluteTick: 245820, eventType: NoteOn, channel: 14, note: 31, velocity: 64,
  46, 1, 14, 31, 64,
  // deltaTick: 16, absoluteTick: 245836, eventType: NoteOn, channel: 12, note: 55, velocity: 35,
  16, 1, 12, 55, 35,
  // deltaTick: 178, absoluteTick: 246014, eventType: NoteOff, channel: 0, note: 81, velocity: 0,
  178, 0, 0, 81, 0,
  // deltaTick: 706, absoluteTick: 246720, eventType: AllNotesOff, channel: 0, controlNum: 0, value: 0,
  706, 7, 0, 0, 0,
  // deltaTick: 2880, absoluteTick: 249600, eventType: AllNotesOff, channel: 2, controlNum: 0, value: 0,
  2880, 7, 2, 0, 0,
  // deltaTick: 74, absoluteTick: 249674, eventType: NoteOff, channel: 12, note: 55, velocity: 0,
  74, 0, 12, 55, 0,
  // deltaTick: 1846, absoluteTick: 251520, eventType: NRPN, channel: 13, controlNum: 77, value: 5898,
  1846, 4, 13, 77, 5898,
  // deltaTick: 1920, absoluteTick: 253440, eventType: NoteOn, channel: 13, note: 25, velocity: 64,
  1920, 1, 13, 25, 64,
  // deltaTick: 5760, absoluteTick: 259200, eventType: NoteOff, channel: 13, note: 25, velocity: 0,
  5760, 0, 13, 25, 0,
  // deltaTick: 1920, absoluteTick: 261120, eventType: AllNotesOff, channel: 12, controlNum: 0, value: 0,
  1920, 7, 12, 0, 0,
  // deltaTick: 5760, absoluteTick: 266880, eventType: AllNotesOff, channel: 13, controlNum: 0, value: 0,
  5760, 7, 13, 0, 0,
  // deltaTick: 23040, absoluteTick: 289920, eventType: NRPN, channel: 14, controlNum: 73, value: 19005,
  23040, 4, 14, 73, 19005,
  // deltaTick: 0, absoluteTick: 289920, eventType: NRPN, channel: 22, controlNum: 100, value: 4231,
  0, 4, 22, 100, 4231,
  // deltaTick: 0, absoluteTick: 289920, eventType: StartEnvelope, channel: 14, { controlNum: 73, envelopeLength: 7680}, targetValue: 0,
  0, 8, 14, 1966153, 0,
  // deltaTick: 0, absoluteTick: 289920, eventType: StartEnvelope, channel: 22, { controlNum: 100, envelopeLength: 7680}, targetValue: 0,
  0, 8, 22, 1966180, 0,
  // deltaTick: 5760, absoluteTick: 295680, eventType: NoteOff, channel: 14, note: 31, velocity: 0,
  5760, 0, 14, 31, 0,
  // deltaTick: 0, absoluteTick: 295680, eventType: AllNotesOff, channel: 14, controlNum: 0, value: 0,
  0, 7, 14, 0, 0,
  // deltaTick: 11520, absoluteTick: 307200, eventType: AllNotesOff, channel: 6, controlNum: 0, value: 0,
  11520, 7, 6, 0, 0,
};
// END SONG DATA BLOCK

// Track routing format: target track ID, source track ID, volume level
static int32_t track_routing[65][3]
{
{15, 0, 895},
{15, 2, 1051},
{16, 10, 7114},
{17, 11, 5614},
{18, 1, 1780},
{19, 3, 241},
{19, 12, 2742},
{20, 9, 625},
{20, 14, 2049},
{21, 5, 2186},
{21, 9, 625},
{21, 13, 4145},
{21, 14, 2049},
{21, 16, 1369},
{21, 17, 756},
{22, 1, 1780},
{22, 2, 1051},
{22, 4, 292},
{22, 7, 1484},
{22, 12, 3870},
{22, 13, 4145},
{22, 14, 2049},
{22, 16, 1369},
{22, 17, 756},
{22, 18, 5722},
{22, 19, 7378},
{22, 20, 8515},
{22, 21, 6408},
{23, 1, 1780},
{23, 9, 625},
{23, 14, 2049},
{23, 15, 511},
{23, 17, 756},
{23, 22, 16383},
{24, 2, 1051},
{24, 4, 292},
{24, 7, 1484},
{24, 22, 16383},
{25, 0, 895},
{25, 8, 1200},
{26, 0, 895},
{26, 1, 1780},
{26, 2, 1051},
{26, 3, 1093},
{26, 4, 292},
{26, 5, 2186},
{26, 6, 543},
{26, 7, 1484},
{26, 8, 4202},
{26, 9, 625},
{26, 12, 3870},
{26, 13, 4145},
{26, 14, 2049},
{26, 15, 511},
{26, 16, 1369},
{26, 17, 756},
{26, 18, 5722},
{26, 19, 7378},
{26, 20, 8515},
{26, 21, 6408},
{26, 22, 16383},
{26, 23, 13776},
{26, 24, 150},
{26, 25, 10913},
{27, 26, 16383}
};

#define NUM_AUTOMATION_ENVELOPES 13
#define NUM_INSTR_TRACKS 15
#define NUM_DISTORTION_TRACKS 3
#define NUM_CHORUS_TRACKS 0
#define NUM_ECHO_TRACKS 5
#define NUM_REVERB_TRACKS 2
#define NUM_FILTER_TRACKS 2
// Number of real tracks. Does not include the output bus
#define NUM_TRACKS 27
// Number of track outputs, including the output bus. This is typically (2 x NUM_TRACKS) + 2.
#define NUM_TRACK_OUTPUTS 56
// Interval in samples to update parameters when processing envelope events
#define ENVELOPE_INTERVAL 128
#define ENVELOPE_INTERVALF 128.0f
// The index of the left master output in track_outs[]
#define LEFT_OUT_IDX 54
// The index of the right master output in track_outs[]
#define RIGHT_OUT_IDX 55
#define FIRST_DISTORTION_IDX 15
#define FIRST_CHORUS_IDX 999
#define FIRST_ECHO_IDX 18
#define FIRST_REVERB_IDX 23
#define FIRST_FILTER_IDX 25
#define NUM_ROUTING_ITEMS 65
#if NUM_INSTR_TRACKS > 0
#define OPS_HARMONIKKA
#endif
#if NUM_DISTORTION_TRACKS > 0
#define OPS_MURTO
#endif
#if NUM_CHORUS_TRACKS > 0
#define OPS_KUORO
#endif
#if NUM_ECHO_TRACKS > 0
#define OPS_PAPUKAIJA
#endif
#if NUM_REVERB_TRACKS > 0
#define OPS_TYNNYRI
#endif
#if NUM_FILTER_TRACKS > 0
#define OPS_SEULA
#endif
#endif // SONGDATA_HPP
